/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 30 "core/cfg.y" /* yacc.c:339  */


#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <arpa/inet.h>
#include <string.h>
#include <errno.h>
#include "route_struct.h"
#include "globals.h"
#include "shm_init.h"
#include "route.h"
#include "switch.h"
#include "dprint.h"
#include "sr_module.h"
#include "modparam.h"
#include "ip_addr.h"
#include "resolve.h"
#include "socket_info.h"
#include "name_alias.h"
#include "ut.h"
#include "dset.h"
#include "select.h"
#include "flags.h"
#include "tcp_init.h"
#include "tcp_options.h"
#include "sctp_core.h"
#include "pvar.h"
#include "lvalue.h"
#include "rvalue.h"
#include "sr_compat.h"
#include "msg_translator.h"
#include "async_task.h"

#include "kemi.h"
#include "ppcfg.h"
#include "pvapi.h"
#include "config.h"
#include "cfg_core.h"
#include "cfg/cfg.h"
#ifdef CORE_TLS
#include "tls/tls_config.h"
#endif
#include "timer_ticks.h"

#ifdef DEBUG_DMALLOC
#include <dmalloc.h>
#endif

/* hack to avoid alloca usage in the generated C file (needed for compiler
 with no built in alloca, like icc*/
#undef _ALLOCA_H

#define onsend_check(s) \
	do{\
		if (rt!=ONSEND_ROUTE) yyerror( s " allowed only in onsend_routes");\
	}while(0)

	#define IF_AUTO_BIND_IPV6(x) x

#ifdef USE_DNS_CACHE
	#define IF_DNS_CACHE(x) x
#else
	#define IF_DNS_CACHE(x) warn("dns cache support not compiled in")
#endif

#ifdef USE_DNS_FAILOVER
	#define IF_DNS_FAILOVER(x) x
#else
	#define IF_DNS_FAILOVER(x) warn("dns failover support not compiled in")
#endif

#ifdef USE_NAPTR
	#define IF_NAPTR(x) x
#else
	#define IF_NAPTR(x) warn("dns naptr support not compiled in")
#endif

#ifdef USE_DST_BLACKLIST
	#define IF_DST_BLACKLIST(x) x
#else
	#define IF_DST_BLACKLIST(x) warn("dst blacklist support not compiled in")
#endif

#ifdef USE_SCTP
	#define IF_SCTP(x) x
#else
	#define IF_SCTP(x) warn("sctp support not compiled in")
#endif

#ifdef USE_RAW_SOCKS
	#define IF_RAW_SOCKS(x) x
#else
	#define IF_RAW_SOCKS(x) warn("raw socket support not compiled in")
#endif


extern int yylex();
/* safer then using yytext which can be array or pointer */
extern char* yy_number_str;

static void yyerror(char* s, ...);
static void yyerror_at(struct cfg_pos* pos, char* s, ...);
static char* tmp;
static int i_tmp;
static struct socket_id* lst_tmp;
static struct name_lst*  nl_tmp;
static int rt;  /* Type of route block for find_export */
static str* str_tmp;
static str s_tmp;
static struct ip_addr* ip_tmp;
static struct avp_spec* s_attr;
static select_t sel;
static select_t* sel_ptr;
static pv_spec_t* pv_spec;
static struct action *mod_func_action;
static struct lvalue* lval_tmp;
static struct rvalue* rval_tmp;

static void warn(char* s, ...);
static void warn_at(struct cfg_pos* pos, char* s, ...);
static void get_cpos(struct cfg_pos* pos);
static struct rval_expr* mk_rve_rval(enum rval_type, void* v);
static struct rval_expr* mk_rve1(enum rval_expr_op op, struct rval_expr* rve1);
static struct rval_expr* mk_rve2(enum rval_expr_op op, struct rval_expr* rve1,
									struct rval_expr* rve2);
static int rval_expr_int_check(struct rval_expr *rve);
static int warn_ct_rve(struct rval_expr *rve, char* name);
static struct socket_id* mk_listen_id(char*, int, int);
static struct name_lst* mk_name_lst(char* name, int flags);
static struct socket_id* mk_listen_id2(struct name_lst*, int, int);
static void free_name_lst(struct name_lst* lst);
static void free_socket_id_lst(struct socket_id* i);

static struct case_stms* mk_case_stm(struct rval_expr* ct, int is_re, 
									struct action* a, int* err);
static int case_check_type(struct case_stms* stms);
static int case_check_default(struct case_stms* stms);
static int mod_f_params_pre_fixup(struct action* a);
static void free_mod_func_action(struct action* a);


extern int line;
extern int column;
extern int startcolumn;
extern int startline;
extern char *finame;
extern char *routename;
extern char *default_routename;

#define set_cfg_pos(x) \
	do{\
		if(x) {\
		(x)->cline = line;\
		(x)->cfile = (finame!=0)?finame:((cfg_file!=0)?cfg_file:"default");\
		(x)->rname = (routename!=0)?routename:((default_routename!=0)?default_routename:"DEFAULT");\
		}\
	}while(0)



#line 232 "core/cfg.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cfg.tab.h".  */
#ifndef YY_YY_CORE_CFG_TAB_H_INCLUDED
# define YY_YY_CORE_CFG_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    FORWARD = 258,
    FORWARD_TCP = 259,
    FORWARD_TLS = 260,
    FORWARD_SCTP = 261,
    FORWARD_UDP = 262,
    EXIT = 263,
    DROP = 264,
    RETURN = 265,
    BREAK = 266,
    LOG_TOK = 267,
    ERROR = 268,
    ROUTE = 269,
    ROUTE_REQUEST = 270,
    ROUTE_FAILURE = 271,
    ROUTE_ONREPLY = 272,
    ROUTE_REPLY = 273,
    ROUTE_BRANCH = 274,
    ROUTE_SEND = 275,
    ROUTE_EVENT = 276,
    EXEC = 277,
    SET_HOST = 278,
    SET_HOSTPORT = 279,
    SET_HOSTPORTTRANS = 280,
    PREFIX = 281,
    STRIP = 282,
    STRIP_TAIL = 283,
    SET_USERPHONE = 284,
    APPEND_BRANCH = 285,
    REMOVE_BRANCH = 286,
    CLEAR_BRANCHES = 287,
    SET_USER = 288,
    SET_USERPASS = 289,
    SET_PORT = 290,
    SET_URI = 291,
    REVERT_URI = 292,
    FORCE_RPORT = 293,
    ADD_LOCAL_RPORT = 294,
    FORCE_TCP_ALIAS = 295,
    UDP_MTU = 296,
    UDP_MTU_TRY_PROTO = 297,
    UDP4_RAW = 298,
    UDP4_RAW_MTU = 299,
    UDP4_RAW_TTL = 300,
    IF = 301,
    ELSE = 302,
    SET_ADV_ADDRESS = 303,
    SET_ADV_PORT = 304,
    FORCE_SEND_SOCKET = 305,
    SET_FWD_NO_CONNECT = 306,
    SET_RPL_NO_CONNECT = 307,
    SET_FWD_CLOSE = 308,
    SET_RPL_CLOSE = 309,
    SWITCH = 310,
    CASE = 311,
    DEFAULT = 312,
    WHILE = 313,
    CFG_SELECT = 314,
    CFG_RESET = 315,
    URIHOST = 316,
    URIPORT = 317,
    MAX_LEN = 318,
    SETFLAG = 319,
    RESETFLAG = 320,
    ISFLAGSET = 321,
    SETAVPFLAG = 322,
    RESETAVPFLAG = 323,
    ISAVPFLAGSET = 324,
    METHOD = 325,
    URI = 326,
    FROM_URI = 327,
    TO_URI = 328,
    SRCIP = 329,
    SRCPORT = 330,
    DSTIP = 331,
    DSTPORT = 332,
    TOIP = 333,
    TOPORT = 334,
    SNDIP = 335,
    SNDPORT = 336,
    SNDPROTO = 337,
    SNDAF = 338,
    PROTO = 339,
    AF = 340,
    MYSELF = 341,
    MSGLEN = 342,
    UDP = 343,
    TCP = 344,
    TLS = 345,
    SCTP = 346,
    WS = 347,
    WSS = 348,
    DEBUG_V = 349,
    FORK = 350,
    FORK_DELAY = 351,
    MODINIT_DELAY = 352,
    LOGSTDERROR = 353,
    LOGFACILITY = 354,
    LOGNAME = 355,
    LOGCOLOR = 356,
    LOGPREFIX = 357,
    LOGPREFIXMODE = 358,
    LOGENGINETYPE = 359,
    LOGENGINEDATA = 360,
    XAVPVIAPARAMS = 361,
    XAVPVIAFIELDS = 362,
    LISTEN = 363,
    ADVERTISE = 364,
    ALIAS = 365,
    SR_AUTO_ALIASES = 366,
    DNS = 367,
    REV_DNS = 368,
    DNS_TRY_IPV6 = 369,
    DNS_TRY_NAPTR = 370,
    DNS_SRV_LB = 371,
    DNS_UDP_PREF = 372,
    DNS_TCP_PREF = 373,
    DNS_TLS_PREF = 374,
    DNS_SCTP_PREF = 375,
    DNS_RETR_TIME = 376,
    DNS_SLOW_QUERY_MS = 377,
    DNS_RETR_NO = 378,
    DNS_SERVERS_NO = 379,
    DNS_USE_SEARCH = 380,
    DNS_SEARCH_FMATCH = 381,
    DNS_NAPTR_IGNORE_RFC = 382,
    DNS_CACHE_INIT = 383,
    DNS_USE_CACHE = 384,
    DNS_USE_FAILOVER = 385,
    DNS_CACHE_FLAGS = 386,
    DNS_CACHE_NEG_TTL = 387,
    DNS_CACHE_MIN_TTL = 388,
    DNS_CACHE_MAX_TTL = 389,
    DNS_CACHE_MEM = 390,
    DNS_CACHE_GC_INT = 391,
    DNS_CACHE_DEL_NONEXP = 392,
    DNS_CACHE_REC_PREF = 393,
    AUTO_BIND_IPV6 = 394,
    DST_BLST_INIT = 395,
    USE_DST_BLST = 396,
    DST_BLST_MEM = 397,
    DST_BLST_TTL = 398,
    DST_BLST_GC_INT = 399,
    DST_BLST_UDP_IMASK = 400,
    DST_BLST_TCP_IMASK = 401,
    DST_BLST_TLS_IMASK = 402,
    DST_BLST_SCTP_IMASK = 403,
    IP_FREE_BIND = 404,
    PORT = 405,
    STAT = 406,
    CHILDREN = 407,
    SOCKET_WORKERS = 408,
    ASYNC_WORKERS = 409,
    ASYNC_USLEEP = 410,
    ASYNC_NONBLOCK = 411,
    CHECK_VIA = 412,
    PHONE2TEL = 413,
    MEMLOG = 414,
    MEMDBG = 415,
    MEMSUM = 416,
    MEMSAFETY = 417,
    MEMJOIN = 418,
    MEMSTATUSMODE = 419,
    CORELOG = 420,
    SIP_WARNING = 421,
    SERVER_SIGNATURE = 422,
    SERVER_HEADER = 423,
    USER_AGENT_HEADER = 424,
    REPLY_TO_VIA = 425,
    LOADMODULE = 426,
    LOADPATH = 427,
    MODPARAM = 428,
    CFGENGINE = 429,
    MAXBUFFER = 430,
    SQL_BUFFER_SIZE = 431,
    USER = 432,
    GROUP = 433,
    CHROOT = 434,
    WDIR = 435,
    RUNDIR = 436,
    MHOMED = 437,
    DISABLE_TCP = 438,
    TCP_ACCEPT_ALIASES = 439,
    TCP_CHILDREN = 440,
    TCP_CONNECT_TIMEOUT = 441,
    TCP_SEND_TIMEOUT = 442,
    TCP_CON_LIFETIME = 443,
    TCP_POLL_METHOD = 444,
    TCP_MAX_CONNECTIONS = 445,
    TLS_MAX_CONNECTIONS = 446,
    TCP_NO_CONNECT = 447,
    TCP_SOURCE_IPV4 = 448,
    TCP_SOURCE_IPV6 = 449,
    TCP_OPT_FD_CACHE = 450,
    TCP_OPT_BUF_WRITE = 451,
    TCP_OPT_CONN_WQ_MAX = 452,
    TCP_OPT_WQ_MAX = 453,
    TCP_OPT_RD_BUF = 454,
    TCP_OPT_WQ_BLK = 455,
    TCP_OPT_DEFER_ACCEPT = 456,
    TCP_OPT_DELAYED_ACK = 457,
    TCP_OPT_SYNCNT = 458,
    TCP_OPT_LINGER2 = 459,
    TCP_OPT_KEEPALIVE = 460,
    TCP_OPT_KEEPIDLE = 461,
    TCP_OPT_KEEPINTVL = 462,
    TCP_OPT_KEEPCNT = 463,
    TCP_OPT_CRLF_PING = 464,
    TCP_OPT_ACCEPT_NO_CL = 465,
    TCP_OPT_ACCEPT_HEP3 = 466,
    TCP_OPT_ACCEPT_HAPROXY = 467,
    TCP_CLONE_RCVBUF = 468,
    TCP_REUSE_PORT = 469,
    DISABLE_TLS = 470,
    ENABLE_TLS = 471,
    TLSLOG = 472,
    TLS_PORT_NO = 473,
    TLS_METHOD = 474,
    TLS_HANDSHAKE_TIMEOUT = 475,
    TLS_SEND_TIMEOUT = 476,
    SSLv23 = 477,
    SSLv2 = 478,
    SSLv3 = 479,
    TLSv1 = 480,
    TLS_VERIFY = 481,
    TLS_REQUIRE_CERTIFICATE = 482,
    TLS_CERTIFICATE = 483,
    TLS_PRIVATE_KEY = 484,
    TLS_CA_LIST = 485,
    DISABLE_SCTP = 486,
    ENABLE_SCTP = 487,
    SCTP_CHILDREN = 488,
    ADVERTISED_ADDRESS = 489,
    ADVERTISED_PORT = 490,
    DISABLE_CORE = 491,
    OPEN_FD_LIMIT = 492,
    SHM_MEM_SZ = 493,
    SHM_FORCE_ALLOC = 494,
    MLOCK_PAGES = 495,
    REAL_TIME = 496,
    RT_PRIO = 497,
    RT_POLICY = 498,
    RT_TIMER1_PRIO = 499,
    RT_TIMER1_POLICY = 500,
    RT_TIMER2_PRIO = 501,
    RT_TIMER2_POLICY = 502,
    MCAST_LOOPBACK = 503,
    MCAST_TTL = 504,
    MCAST = 505,
    TOS = 506,
    PMTU_DISCOVERY = 507,
    KILL_TIMEOUT = 508,
    MAX_WLOOPS = 509,
    PVBUFSIZE = 510,
    PVBUFSLOTS = 511,
    PVCACHELIMIT = 512,
    PVCACHEACTION = 513,
    HTTP_REPLY_PARSE = 514,
    VERSION_TABLE_CFG = 515,
    VERBOSE_STARTUP = 516,
    ROUTE_LOCKS_SIZE = 517,
    CFG_DESCRIPTION = 518,
    SERVER_ID = 519,
    KEMI = 520,
    ONSEND_ROUTE_CALLBACK = 521,
    REPLY_ROUTE_CALLBACK = 522,
    EVENT_ROUTE_CALLBACK = 523,
    MAX_RECURSIVE_LEVEL = 524,
    MAX_BRANCHES_PARAM = 525,
    LATENCY_CFG_LOG = 526,
    LATENCY_LOG = 527,
    LATENCY_LIMIT_DB = 528,
    LATENCY_LIMIT_ACTION = 529,
    LATENCY_LIMIT_CFG = 530,
    MSG_TIME = 531,
    ONSEND_RT_REPLY = 532,
    FLAGS_DECL = 533,
    AVPFLAGS_DECL = 534,
    ATTR_MARK = 535,
    SELECT_MARK = 536,
    ATTR_FROM = 537,
    ATTR_TO = 538,
    ATTR_FROMURI = 539,
    ATTR_TOURI = 540,
    ATTR_FROMUSER = 541,
    ATTR_TOUSER = 542,
    ATTR_FROMDOMAIN = 543,
    ATTR_TODOMAIN = 544,
    ATTR_GLOBAL = 545,
    ADDEQ = 546,
    SUBST = 547,
    SUBSTDEF = 548,
    SUBSTDEFS = 549,
    EQUAL = 550,
    LOG_OR = 551,
    LOG_AND = 552,
    BIN_OR = 553,
    BIN_AND = 554,
    BIN_XOR = 555,
    BIN_LSHIFT = 556,
    BIN_RSHIFT = 557,
    EQUAL_T = 558,
    DIFF = 559,
    MATCH = 560,
    INTEQ = 561,
    INTDIFF = 562,
    STREQ = 563,
    STRDIFF = 564,
    GT = 565,
    LT = 566,
    GTE = 567,
    LTE = 568,
    PLUS = 569,
    MINUS = 570,
    STAR = 571,
    SLASH = 572,
    MODULO = 573,
    NOT = 574,
    UNARY = 575,
    BIN_NOT = 576,
    DEFINED = 577,
    INTCAST = 578,
    STRCAST = 579,
    DOT = 580,
    STRLEN = 581,
    STREMPTY = 582,
    NUMBER = 583,
    ID = 584,
    NUM_ID = 585,
    STRING = 586,
    IPV6ADDR = 587,
    PVAR = 588,
    AVP_OR_PVAR = 589,
    EVENT_RT_NAME = 590,
    COMMA = 591,
    SEMICOLON = 592,
    RPAREN = 593,
    LPAREN = 594,
    LBRACE = 595,
    RBRACE = 596,
    LBRACK = 597,
    RBRACK = 598,
    CR = 599,
    COLON = 600
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 196 "core/cfg.y" /* yacc.c:355  */

	long intval;
	unsigned long uval;
	char* strval;
	struct expr* expr;
	struct action* action;
	struct case_stms* case_stms;
	struct net* ipnet;
	struct ip_addr* ipaddr;
	struct socket_id* sockid;
	struct name_lst* name_l;
	struct avp_spec* attr;
	struct _pv_spec* pvar;
	struct lvalue* lval;
	struct rvalue* rval;
	struct rval_expr* rv_expr;
	select_t* select;

#line 637 "core/cfg.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_CORE_CFG_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 654 "core/cfg.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  458
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   11558

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  346
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  104
/* YYNRULES -- Number of rules.  */
#define YYNRULES  895
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1672

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   600

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   620,   620,   623,   624,   625,   628,   629,   630,   631,
     632,   633,   633,   634,   634,   635,   636,   636,   637,   637,
     638,   638,   639,   640,   643,   659,   667,   681,   682,   688,
     689,   693,   694,   695,   696,   697,   700,   701,   702,   703,
     704,   705,   706,   709,   710,   713,   714,   715,   716,   717,
     721,   722,   723,   724,   725,   729,   730,   733,   734,   737,
     738,   740,   741,   744,   747,   753,   754,   758,   759,   762,
     763,   766,   772,   773,   774,   775,   776,   777,   778,   779,
     780,   783,   784,   790,   791,   792,   793,   794,   795,   796,
     797,   798,   799,   800,   801,   802,   803,   806,   807,   810,
     811,   812,   813,   814,   815,   816,   817,   818,   819,   820,
     821,   822,   823,   824,   825,   826,   827,   829,   830,   831,
     832,   833,   834,   835,   836,   837,   838,   839,   840,   841,
     842,   843,   844,   845,   846,   847,   848,   849,   850,   851,
     852,   853,   854,   855,   856,   857,   858,   859,   860,   861,
     862,   863,   864,   865,   866,   867,   868,   869,   870,   873,
     874,   877,   878,   881,   882,   883,   884,   887,   888,   891,
     892,   895,   896,   899,   900,   901,   902,   903,   908,   909,
     910,   911,   912,   913,   914,   915,   916,   917,   918,   919,
     920,   921,   922,   923,   924,   925,   926,   927,   928,   929,
     930,   931,   932,   933,   934,   935,   936,   937,   938,   939,
     940,   941,   942,   943,   946,   947,   954,   961,   962,   963,
     964,   965,   966,   967,   968,   969,   970,   971,   972,   973,
     974,   975,   976,   983,   984,   991,   992,   999,  1000,  1007,
    1008,  1015,  1016,  1026,  1027,  1041,  1055,  1056,  1063,  1064,
    1071,  1072,  1079,  1080,  1089,  1090,  1099,  1100,  1107,  1108,
    1115,  1116,  1123,  1124,  1131,  1132,  1139,  1140,  1147,  1148,
    1155,  1156,  1163,  1164,  1171,  1172,  1179,  1180,  1187,  1188,
    1195,  1196,  1203,  1204,  1211,  1212,  1219,  1220,  1227,  1228,
    1235,  1236,  1243,  1245,  1252,  1253,  1264,  1265,  1272,  1273,
    1280,  1281,  1288,  1289,  1296,  1297,  1304,  1311,  1318,  1325,
    1332,  1339,  1340,  1347,  1348,  1355,  1356,  1363,  1364,  1371,
    1372,  1379,  1380,  1387,  1388,  1395,  1396,  1403,  1404,  1411,
    1412,  1413,  1414,  1417,  1418,  1421,  1422,  1423,  1424,  1436,
    1449,  1451,  1462,  1463,  1464,  1465,  1471,  1472,  1482,  1483,
    1484,  1485,  1486,  1487,  1494,  1495,  1502,  1503,  1504,  1505,
    1506,  1507,  1508,  1509,  1510,  1511,  1512,  1513,  1514,  1515,
    1516,  1517,  1518,  1519,  1526,  1527,  1534,  1535,  1542,  1549,
    1550,  1551,  1578,  1579,  1580,  1581,  1582,  1583,  1584,  1585,
    1586,  1587,  1588,  1589,  1590,  1591,  1592,  1593,  1594,  1595,
    1596,  1597,  1598,  1599,  1600,  1601,  1610,  1611,  1620,  1621,
    1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,
    1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,
    1651,  1652,  1654,  1656,  1657,  1658,  1661,  1662,  1665,  1666,
    1667,  1670,  1671,  1674,  1675,  1676,  1684,  1689,  1694,  1699,
    1704,  1707,  1712,  1720,  1726,  1727,  1737,  1738,  1748,  1749,
    1758,  1767,  1768,  1774,  1775,  1781,  1785,  1786,  1789,  1818,
    1833,  1834,  1838,  1849,  1850,  1854,  1855,  1859,  1866,  1882,
    1883,  1886,  1889,  1896,  1912,  1916,  1917,  1922,  1922,  1929,
    1930,  1932,  1931,  1954,  1959,  1962,  1969,  1985,  1988,  1991,
    1998,  2014,  2017,  2020,  2037,  2040,  2041,  2042,  2043,  2044,
    2045,  2067,  2068,  2069,  2070,  2073,  2074,  2075,  2076,  2079,
    2080,  2086,  2087,  2088,  2089,  2090,  2091,  2092,  2095,  2096,
    2097,  2098,  2105,  2106,  2107,  2114,  2115,  2116,  2120,  2121,
    2122,  2123,  2124,  2129,  2130,  2133,  2134,  2135,  2141,  2143,
    2145,  2146,  2148,  2150,  2152,  2154,  2156,  2157,  2159,  2160,
    2161,  2162,  2164,  2166,  2168,  2170,  2172,  2174,  2175,  2211,
    2213,  2215,  2217,  2220,  2222,  2224,  2226,  2230,  2231,  2242,
    2243,  2247,  2248,  2263,  2278,  2279,  2282,  2283,  2284,  2296,
    2297,  2312,  2327,  2329,  2336,  2378,  2379,  2382,  2383,  2384,
    2387,  2388,  2389,  2390,  2391,  2392,  2393,  2394,  2397,  2405,
    2415,  2432,  2439,  2446,  2453,  2460,  2465,  2470,  2471,  2472,
    2473,  2474,  2477,  2486,  2493,  2518,  2534,  2535,  2540,  2559,
    2568,  2580,  2595,  2596,  2599,  2599,  2609,  2610,  2611,  2612,
    2613,  2614,  2615,  2616,  2617,  2620,  2623,  2624,  2627,  2634,
    2637,  2644,  2650,  2651,  2660,  2661,  2662,  2665,  2666,  2678,
    2702,  2713,  2744,  2748,  2758,  2772,  2784,  2785,  2787,  2788,
    2789,  2803,  2804,  2805,  2806,  2807,  2808,  2809,  2813,  2814,
    2815,  2828,  2834,  2835,  2836,  2837,  2838,  2839,  2840,  2841,
    2842,  2843,  2844,  2845,  2846,  2847,  2848,  2866,  2867,  2868,
    2869,  2870,  2871,  2872,  2873,  2874,  2875,  2876,  2877,  2878,
    2879,  2880,  2881,  2882,  2884,  2886,  2887,  2888,  2889,  2890,
    2893,  2911,  2912,  2913,  2916,  2917,  2918,  2919,  2920,  2921,
    2922,  2923,  2924,  2925,  2926,  2927,  2928,  2929,  2930,  2931,
    2932,  2933,  2934,  2935,  2936,  2937,  2938,  2939,  2940,  2941,
    2942,  2943,  2944,  2945,  2946,  2947,  2948,  2949,  2950,  2958,
    2966,  2974,  2982,  2990,  2998,  3006,  3014,  3022,  3023,  3025,
    3033,  3041,  3049,  3058,  3067,  3076,  3084,  3093,  3101,  3102,
    3104,  3107,  3108,  3109,  3110,  3117,  3124,  3125,  3131,  3138,
    3139,  3145,  3152,  3153,  3159,  3162,  3165,  3166,  3167,  3170,
    3171,  3172,  3181,  3190,  3191,  3192,  3193,  3194,  3195,  3196,
    3197,  3198,  3199,  3200,  3201,  3202,  3203,  3204,  3205,  3206,
    3207,  3211,  3215,  3216,  3217,  3218,  3219,  3220,  3221,  3222,
    3223,  3224,  3225,  3226,  3227,  3228,  3229,  3230,  3231,  3232,
    3233,  3234,  3235,  3236,  3237,  3238,  3239,  3240,  3241,  3242,
    3250,  3258,  3266,  3267,  3269,  3271,  3282,  3283,  3284,  3300,
    3301,  3302,  3306,  3309,  3310,  3313,  3316,  3319,  3322,  3325,
    3328,  3331,  3334,  3337,  3340,  3341,  3342,  3345,  3346,  3347,
    3347,  3373,  3375,  3377,  3378,  3381,  3398,  3402,  3406,  3410,
    3415,  3419,  3424,  3428,  3432,  3436
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "FORWARD", "FORWARD_TCP", "FORWARD_TLS",
  "FORWARD_SCTP", "FORWARD_UDP", "EXIT", "DROP", "RETURN", "BREAK",
  "LOG_TOK", "ERROR", "ROUTE", "ROUTE_REQUEST", "ROUTE_FAILURE",
  "ROUTE_ONREPLY", "ROUTE_REPLY", "ROUTE_BRANCH", "ROUTE_SEND",
  "ROUTE_EVENT", "EXEC", "SET_HOST", "SET_HOSTPORT", "SET_HOSTPORTTRANS",
  "PREFIX", "STRIP", "STRIP_TAIL", "SET_USERPHONE", "APPEND_BRANCH",
  "REMOVE_BRANCH", "CLEAR_BRANCHES", "SET_USER", "SET_USERPASS",
  "SET_PORT", "SET_URI", "REVERT_URI", "FORCE_RPORT", "ADD_LOCAL_RPORT",
  "FORCE_TCP_ALIAS", "UDP_MTU", "UDP_MTU_TRY_PROTO", "UDP4_RAW",
  "UDP4_RAW_MTU", "UDP4_RAW_TTL", "IF", "ELSE", "SET_ADV_ADDRESS",
  "SET_ADV_PORT", "FORCE_SEND_SOCKET", "SET_FWD_NO_CONNECT",
  "SET_RPL_NO_CONNECT", "SET_FWD_CLOSE", "SET_RPL_CLOSE", "SWITCH", "CASE",
  "DEFAULT", "WHILE", "CFG_SELECT", "CFG_RESET", "URIHOST", "URIPORT",
  "MAX_LEN", "SETFLAG", "RESETFLAG", "ISFLAGSET", "SETAVPFLAG",
  "RESETAVPFLAG", "ISAVPFLAGSET", "METHOD", "URI", "FROM_URI", "TO_URI",
  "SRCIP", "SRCPORT", "DSTIP", "DSTPORT", "TOIP", "TOPORT", "SNDIP",
  "SNDPORT", "SNDPROTO", "SNDAF", "PROTO", "AF", "MYSELF", "MSGLEN", "UDP",
  "TCP", "TLS", "SCTP", "WS", "WSS", "DEBUG_V", "FORK", "FORK_DELAY",
  "MODINIT_DELAY", "LOGSTDERROR", "LOGFACILITY", "LOGNAME", "LOGCOLOR",
  "LOGPREFIX", "LOGPREFIXMODE", "LOGENGINETYPE", "LOGENGINEDATA",
  "XAVPVIAPARAMS", "XAVPVIAFIELDS", "LISTEN", "ADVERTISE", "ALIAS",
  "SR_AUTO_ALIASES", "DNS", "REV_DNS", "DNS_TRY_IPV6", "DNS_TRY_NAPTR",
  "DNS_SRV_LB", "DNS_UDP_PREF", "DNS_TCP_PREF", "DNS_TLS_PREF",
  "DNS_SCTP_PREF", "DNS_RETR_TIME", "DNS_SLOW_QUERY_MS", "DNS_RETR_NO",
  "DNS_SERVERS_NO", "DNS_USE_SEARCH", "DNS_SEARCH_FMATCH",
  "DNS_NAPTR_IGNORE_RFC", "DNS_CACHE_INIT", "DNS_USE_CACHE",
  "DNS_USE_FAILOVER", "DNS_CACHE_FLAGS", "DNS_CACHE_NEG_TTL",
  "DNS_CACHE_MIN_TTL", "DNS_CACHE_MAX_TTL", "DNS_CACHE_MEM",
  "DNS_CACHE_GC_INT", "DNS_CACHE_DEL_NONEXP", "DNS_CACHE_REC_PREF",
  "AUTO_BIND_IPV6", "DST_BLST_INIT", "USE_DST_BLST", "DST_BLST_MEM",
  "DST_BLST_TTL", "DST_BLST_GC_INT", "DST_BLST_UDP_IMASK",
  "DST_BLST_TCP_IMASK", "DST_BLST_TLS_IMASK", "DST_BLST_SCTP_IMASK",
  "IP_FREE_BIND", "PORT", "STAT", "CHILDREN", "SOCKET_WORKERS",
  "ASYNC_WORKERS", "ASYNC_USLEEP", "ASYNC_NONBLOCK", "CHECK_VIA",
  "PHONE2TEL", "MEMLOG", "MEMDBG", "MEMSUM", "MEMSAFETY", "MEMJOIN",
  "MEMSTATUSMODE", "CORELOG", "SIP_WARNING", "SERVER_SIGNATURE",
  "SERVER_HEADER", "USER_AGENT_HEADER", "REPLY_TO_VIA", "LOADMODULE",
  "LOADPATH", "MODPARAM", "CFGENGINE", "MAXBUFFER", "SQL_BUFFER_SIZE",
  "USER", "GROUP", "CHROOT", "WDIR", "RUNDIR", "MHOMED", "DISABLE_TCP",
  "TCP_ACCEPT_ALIASES", "TCP_CHILDREN", "TCP_CONNECT_TIMEOUT",
  "TCP_SEND_TIMEOUT", "TCP_CON_LIFETIME", "TCP_POLL_METHOD",
  "TCP_MAX_CONNECTIONS", "TLS_MAX_CONNECTIONS", "TCP_NO_CONNECT",
  "TCP_SOURCE_IPV4", "TCP_SOURCE_IPV6", "TCP_OPT_FD_CACHE",
  "TCP_OPT_BUF_WRITE", "TCP_OPT_CONN_WQ_MAX", "TCP_OPT_WQ_MAX",
  "TCP_OPT_RD_BUF", "TCP_OPT_WQ_BLK", "TCP_OPT_DEFER_ACCEPT",
  "TCP_OPT_DELAYED_ACK", "TCP_OPT_SYNCNT", "TCP_OPT_LINGER2",
  "TCP_OPT_KEEPALIVE", "TCP_OPT_KEEPIDLE", "TCP_OPT_KEEPINTVL",
  "TCP_OPT_KEEPCNT", "TCP_OPT_CRLF_PING", "TCP_OPT_ACCEPT_NO_CL",
  "TCP_OPT_ACCEPT_HEP3", "TCP_OPT_ACCEPT_HAPROXY", "TCP_CLONE_RCVBUF",
  "TCP_REUSE_PORT", "DISABLE_TLS", "ENABLE_TLS", "TLSLOG", "TLS_PORT_NO",
  "TLS_METHOD", "TLS_HANDSHAKE_TIMEOUT", "TLS_SEND_TIMEOUT", "SSLv23",
  "SSLv2", "SSLv3", "TLSv1", "TLS_VERIFY", "TLS_REQUIRE_CERTIFICATE",
  "TLS_CERTIFICATE", "TLS_PRIVATE_KEY", "TLS_CA_LIST", "DISABLE_SCTP",
  "ENABLE_SCTP", "SCTP_CHILDREN", "ADVERTISED_ADDRESS", "ADVERTISED_PORT",
  "DISABLE_CORE", "OPEN_FD_LIMIT", "SHM_MEM_SZ", "SHM_FORCE_ALLOC",
  "MLOCK_PAGES", "REAL_TIME", "RT_PRIO", "RT_POLICY", "RT_TIMER1_PRIO",
  "RT_TIMER1_POLICY", "RT_TIMER2_PRIO", "RT_TIMER2_POLICY",
  "MCAST_LOOPBACK", "MCAST_TTL", "MCAST", "TOS", "PMTU_DISCOVERY",
  "KILL_TIMEOUT", "MAX_WLOOPS", "PVBUFSIZE", "PVBUFSLOTS", "PVCACHELIMIT",
  "PVCACHEACTION", "HTTP_REPLY_PARSE", "VERSION_TABLE_CFG",
  "VERBOSE_STARTUP", "ROUTE_LOCKS_SIZE", "CFG_DESCRIPTION", "SERVER_ID",
  "KEMI", "ONSEND_ROUTE_CALLBACK", "REPLY_ROUTE_CALLBACK",
  "EVENT_ROUTE_CALLBACK", "MAX_RECURSIVE_LEVEL", "MAX_BRANCHES_PARAM",
  "LATENCY_CFG_LOG", "LATENCY_LOG", "LATENCY_LIMIT_DB",
  "LATENCY_LIMIT_ACTION", "LATENCY_LIMIT_CFG", "MSG_TIME",
  "ONSEND_RT_REPLY", "FLAGS_DECL", "AVPFLAGS_DECL", "ATTR_MARK",
  "SELECT_MARK", "ATTR_FROM", "ATTR_TO", "ATTR_FROMURI", "ATTR_TOURI",
  "ATTR_FROMUSER", "ATTR_TOUSER", "ATTR_FROMDOMAIN", "ATTR_TODOMAIN",
  "ATTR_GLOBAL", "ADDEQ", "SUBST", "SUBSTDEF", "SUBSTDEFS", "EQUAL",
  "LOG_OR", "LOG_AND", "BIN_OR", "BIN_AND", "BIN_XOR", "BIN_LSHIFT",
  "BIN_RSHIFT", "EQUAL_T", "DIFF", "MATCH", "INTEQ", "INTDIFF", "STREQ",
  "STRDIFF", "GT", "LT", "GTE", "LTE", "PLUS", "MINUS", "STAR", "SLASH",
  "MODULO", "NOT", "UNARY", "BIN_NOT", "DEFINED", "INTCAST", "STRCAST",
  "DOT", "STRLEN", "STREMPTY", "NUMBER", "ID", "NUM_ID", "STRING",
  "IPV6ADDR", "PVAR", "AVP_OR_PVAR", "EVENT_RT_NAME", "COMMA", "SEMICOLON",
  "RPAREN", "LPAREN", "LBRACE", "RBRACE", "LBRACK", "RBRACK", "CR",
  "COLON", "$accept", "cfg", "statements", "statement", "$@1", "$@2",
  "$@3", "$@4", "$@5", "listen_id", "listen_id_lst", "listen_id2", "proto",
  "eqproto", "port", "phostport", "listen_phostport", "id_lst", "intno",
  "flags_decl", "flag_list", "flag_spec", "flag_name", "avpflags_decl",
  "avpflag_list", "avpflag_spec", "assign_stm", "cfg_var_id",
  "cfg_var_idn", "cfg_var", "module_stm", "ip", "ipv4", "ipv6addr", "ipv6",
  "route_name", "route_main", "route_stm", "failure_route_main",
  "failure_route_stm", "route_reply_main", "onreply_route_stm", "$@6",
  "$@7", "branch_route_main", "branch_route_stm", "send_route_main",
  "send_route_stm", "event_route_main", "event_route_stm",
  "preprocess_stm", "equalop", "cmpop", "strop", "rve_equalop",
  "rve_cmpop", "uri_type", "eint_op_onsend", "eint_op", "eip_op_onsend",
  "eip_op", "exp_elem", "ipnet", "host", "host_if_id", "host_or_if",
  "fcmd", "stm", "actions", "action", "if_cmd", "ct_rval", "single_case",
  "case_stms", "switch_cmd", "while_cmd", "select_param", "select_params",
  "select_id", "$@8", "attr_class_spec", "attr_name_spec", "attr_spec",
  "attr_mark", "attr_id", "attr_id_num_idx", "attr_id_no_idx",
  "attr_id_ass", "attr_id_any", "attr_id_any_str", "pvar", "avp_pvar",
  "assign_op", "lval", "rval", "rve_un_op", "rval_expr", "assign_action",
  "avpflag_oper", "cmd", "$@9", "func_params", "func_param", "ret_cmd", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600
};
# endif

#define YYPACT_NINF -1148

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1148)))

#define YYTABLE_NINF -880

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    2434,  -279,    12,    24,  -232,  -226,  -212,  -182,  -163,  -153,
   -1148,  -141,  -133,   -86,   -60,   -52,   -48,   -47,   -44,   -39,
     -35,   -28,   -25,    25,    28,   284,   414,   427,   449,   450,
      26,   252,   625,   677,   678,   793,   839,   841,   842,   850,
     883,   887,   890,   894,   895,   896,   897,   898,   899,   910,
     915,   916,   917,   918,   921,   930,   931,   932,   934,   935,
     940,   942,   943,   944,   946,   462,   479,   494,   495,   526,
     527,   531,   540,   552,   558,   576,   582,   597,   608,   612,
     635,   654,   655,   663,   669,   675,   687,    51,    11,     8,
     133,   688,   697,   732,   734,   785,   823,   830,   833,   862,
     863,   872,   873,   882,   886,   889,   893,   900,   901,   905,
     909,   919,   920,   947,   950,   954,   955,   927,   939,   941,
     945,   951,   952,   953,   957,   973,   986,   987,  1011,  1022,
    1023,  1033,  1037,  1041,  1050,  1052,  1054,  1055,  1057,  1058,
    1059,  1062,  1063,  1064,  1065,  1067,  1068,  1069,  1139,  1152,
    1153,  1155,  1156,  1157,  1160,  1161,  1167,  1168,  1170,  1171,
    1172,  1174,  1175,  1255,   956,  1258,  1260,  1261,  1262,  1264,
    1266,  1267,  1268,  1269,  1287,  1288,   -22,  1289,  1290,  1291,
    1292,  1293,  1295,  1296,  1302,  1303,   144,   210,   111,   132,
     188, -1148, -1148, -1148,   998,  1551, -1148,   217,    77,   295,
     967,   829, -1148, -1148, -1148,  -278, -1148, -1148,   681, -1148,
   -1148, -1148, -1148,  -207, -1148,   194,   212,   767,   321,   226,
     324,   330,   327,   328,   331,   332,    85,   192,   334,   215,
     454,   233,   237,   238,   257,    88,    93,   473,   555,   559,
   -1148,   665, -1148,   684, -1148,   696, -1148,  -255, -1148,  -255,
   -1148,  -255, -1148,  -255, -1148,   702, -1148,   749, -1148,   762,
   -1148,   772, -1148,   778, -1148,   786, -1148,   807, -1148,   926,
   -1148,   933, -1148,  1028, -1148,  1136, -1148,  1230, -1148,  1271,
   -1148,  1272, -1148,  1273, -1148,  1274, -1148,  1275, -1148,  1276,
   -1148,  1277, -1148,  1278, -1148,  1279, -1148,  1304, -1148,  1305,
   -1148,  1306, -1148,  1307, -1148,  1309, -1148,  1310, -1148,  1311,
     333,   653,   768,   666,   667,   668,   672,   673,   674,   679,
     335,   342,   357,   361,   425,   435,   443,   680,   683,   270,
     271,   685, -1148, -1148, -1148,   274, -1148, -1148,   990, -1148,
     276, -1148,   686,   689,   214,   224,   232,   236,   253,   691,
     692,   695,   698,   476,   551,   614,   254,   703,   704,   705,
     706,    29,   709,   710, -1148,  1312, -1148,  1314, -1148,  1315,
   -1148,  1332,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   722,   723,   724,   725,   726,   727,   728,   729,
    1061,   730,   735,   736,   737,   277,   278,   279,   738,   740,
     746,    70,   748,   750,   751,   753,   754,   758,   759,   761,
     763,   764,   765,   766,   769,   774,   775,   265,   318, -1148,
    1445,   780,   782,   783,   794,   795,   796,   798,   282,   799,
     801,   802,    23,  1446,  1447,   631,   650,   804,   805,   810,
     811,   813, -1148, -1148, -1148, -1148,   777,   664, -1148, -1148,
   -1148,  1440, -1148, -1148, -1148, -1148, -1148, -1148, -1148,  -279,
   -1148,    48,    43,  1301, -1148,    54,  1474, -1148,    73,  1477,
   -1148,    89,  1478, -1148,    31,  1489, -1148,    10,  1491, -1148,
   -1148, -1148, -1148,  1490, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148,  1504, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148, -1148,   690, -1148, -1148, -1148, -1148,  1112,  1502, -1148,
    1492,  1493,  1129,  1726, -1148, -1148, -1148, -1148, -1148,  -253,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,  1500, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148,   690, -1148, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,  1544,  1545,
    1546, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148,  -157,  1514,  -157,
   -1148,  -207, -1148, 11221, -1148,  -207, 11221, -1148,  -207, 11221,
   -1148,  -207, 11221, -1148,  1511, -1148, -1148, -1148,  1576,  1529,
   11221,    47, -1148,  1519,  1537,  1536,  1532,   312,  1107, -1148,
    1112,   220,   314,  1547,   283,   285,   287, -1148, -1148, -1148,
    1533,    33,    35,    38,    41,    58, 10207, 10391, 10545, -1148,
      67,   100,   108,  1538,   110,   113,   115,   117,   139,   140,
     142,   143,  1540,   145,   147,   149,   151,  1542,  1543,  1548,
    1550,  1553, 10729,   152,   155,   156,  1554,  1569,  1570,  1571,
    5789, 10729,   157,   162,   163,   166,   167, -1148, -1148, -1148,
   -1148,   168, -1148, -1148, -1148,    56,  3446, -1148, -1148, -1148,
   -1148,  1026, -1148, -1148, -1148, -1148, -1148,  1588,  1549,   170,
   -1148,  1574,  1541,  3515,  1580,  3599,  1591,  3679,  1593,   196,
    1560,  3858, -1148,  1572,  1566,  1112, -1148, -1148, -1148, -1148,
   -1148, -1148,  1568,  1592, -1148, -1148, -1148, -1148, -1148,  1578,
   -1148, -1148, -1148, -1148, -1148, -1148,  1598, -1148,    17, -1148,
     109, -1148,   130, -1148,   138, -1148,   184,   851, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,   659,
   -1148,   659, -1148,   676, -1148, -1148,  1504, -1148, -1148,  5975,
    6129,  6315,  1601,  1610, -1148,  5109, 11069, -1148,   861, -1148,
     840, -1148,   871, -1148, -1148, -1148,  1026, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148,  6469,  1313,  5295,  1313,  5449,  1313,
   -1148,   267, -1148,   291, -1148,  6655,  1619, -1148,   293, -1148,
     296, -1148,   299, -1148,   300, -1148,   814, -1148,   818, -1148,
    1616, -1148,   206,  1617, -1148,   303, -1148,   304, -1148,   306,
   -1148,   307,  1618,  1626,  1639,   197,   824,  6809, 10053, -1148,
     261, -1148,   819, -1148,    37,  1640,  1641,  1642,  1643, -1148,
    1070, 10053, -1148,   308, -1148,   310, -1148,   -55, -1148,   508,
   -1148,   547, -1148,  1644, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,  1657,
   -1148,  1650, -1148, 10729, -1148, -1148,   228, -1148,  1663, -1148,
    1665, -1148,  1666, -1148,  1667, -1148,  1746,  1755,    10, -1148,
   11221,  1691, -1148,  -275,  1695,  -125, 11221,  1686,  -134, -1148,
    -124, -1148,   633,  -259,  1687,   639,   731,   771,   -79,  1708,
     885,   922,   928,   661,  1709,   958,   959,   966,   760,  1710,
     988,   989,   993,  1005, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148,  6995,  4769,  4955, -1148,  1227,  1704, -1148, -1148, -1148,
   -1148, -1148, -1148,  7149,  7335,  1711, -1148,  1756,  1757,  1766,
    1777,  1115,  1712,  1733,  3938, -1148,  7489, -1148, -1148, -1148,
   -1148, -1148,  7675,  7829, -1148,  2761,  1734, -1148, -1148,  8015,
    8169,  8355,  8509, 10729, 10729, 10729, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148,  8695,  8849,  9035,
    9189,  9375,  9529,  9715, -1148, -1148,  1737,  1742,  1749,  1750,
    1758,  1754,    95,  1193,  1764,  1778,  1779,  1780,  1781,  1782,
    1783,  1792,  1803,  1805,  1806,  1807,  1809, -1148,  1818, -1148,
    1819, -1148,  1823,  1824,  1825,  1832,  1833,  1834,  1836,  1837,
   -1148, -1148, -1148,  1838,  1839, -1148,  1840,  1841, 11221,  2046,
   -1148,  1842,  1843,  1844,  1845,  1846,  1770,  1867,  1847, -1148,
   -1148, -1148, -1148,    19, -1148,  1848,  1851,  1850,  1875,  1876,
    1877,  1878,  1879,  1881,  1882, 10729,  1892,  1880,  1313,  1004,
   -1148,  1026, -1148,  1888, -1148, 11221, 11221, 11221, 11221,  1894,
    1897,  1939,  4018,  1910, -1148, -1148,  1898,  1899,  4091, -1148,
     -12, -1148,  1911, -1148,  1912, -1148,   119,   128,  1913, -1148,
   -1148,   -11, -1148,  1915, -1148,  1916, -1148,  1917, -1148, -1148,
      -4, -1148,  1918, -1148,  1919, -1148,  1920, -1148, -1148,   118,
   -1148,  1921, -1148,  1922, -1148,  1923, -1148, -1148,   646, -1148,
    1924, -1148,  1925, -1148,  1926, -1148, -1148,  1962,  1263, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,  1263, -1148,
   -1148,  1263, -1148, -1148, -1148,  1914, -1148,  1930,  1943,  1552,
    1944,  2205, -1148, -1148, -1148, -1148, -1148, -1148,  2031,  1263,
   -1148,  1263, -1148,   962, -1148,  2100,   690,  1893,  1940, -1148,
    -245,  1263,  -142, -1148,  2901, -1148,  1091, -1148,  2921, -1148,
    1212,  1231,  3108,  1169, -1148,   845, -1148,   845, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148,  1263, -1148,   962, -1148,  1952,
   -1148, -1148,  1953, -1148, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148,  4197,  4875, -1148, -1148, -1148, -1148, -1148,
     355,  1112, -1148,  1945,  5635,  1942, -1148, -1148,   104, -1148,
   10883, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,  1313,
    1008, -1148, -1148, -1148,  -157, -1148, -1148,   268,  4277,  4430,
    4536,  4616, -1148, -1148,  -231, -1148,  1957, -1148, -1148, -1148,
    1950,  1951,  1954,  1955, -1148, -1148, -1148, -1148,  1956,  1959,
    1965,  1966,  1967,  1968,  1970,  1971,  1972,  1974,  1975,  1976,
    1977,  1978,  1979,  1980,  1981,  1982,  1983,  1984,  1985,   -87,
    1704, -1148, -1148, -1148, -1148,     9,  1947,  1986,  1987, -1148,
   -1148, -1148, -1148,  2005, -1148,  2006,  9869,  2007,  1313, 11221,
   -1148, -1148,  1988,  2438, 10729, -1148,  2015,  2016,  2017, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148,  2013,  2014, -1148, -1148,   690, -1148, -1148, -1148, -1148,
    -275, 11221,  2018,  2021,  2848,  2917, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148,  2997, 11221, 11221, -1148,  3107,
    3256,  3340
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     442,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   441,    22,    23,     0,     0,     4,     0,     0,     0,
       0,     0,     8,     9,     6,     0,   439,    10,     0,    15,
       7,   440,   489,     0,   490,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     105,     0,   107,     0,   109,     0,   111,     0,   113,     0,
     115,     0,   117,     0,   119,     0,   121,     0,   123,     0,
     125,     0,   127,     0,   129,     0,   131,     0,   133,     0,
     135,     0,   137,     0,   139,     0,   141,     0,   145,     0,
     143,     0,   147,     0,   149,     0,   151,     0,   153,     0,
     155,     0,   157,     0,   159,     0,   161,     0,   163,     0,
     165,     0,   167,     0,   169,     0,   171,     0,   173,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   454,   453,   456,     0,   455,   461,     0,   463,
       0,   462,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   262,     0,   264,     0,   266,     0,
     268,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   384,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    60,    66,    65,    59,    61,    63,    68,    71,
      67,    69,   506,   505,   508,   507,   510,   509,     1,     5,
       3,     0,     0,     0,    12,     0,     0,    14,     0,     0,
      17,     0,     0,    19,     0,     0,    21,     0,     0,   487,
     472,   473,   474,     0,   430,   429,   428,   427,   432,    31,
      32,    33,    34,    35,   431,   434,     0,    57,   433,   436,
     435,   438,   437,    73,    72,    75,    74,    77,    76,    79,
      78,    81,    80,    83,    82,    85,    84,    87,    86,    89,
      88,    91,    90,    93,    92,    95,    94,    97,    96,    99,
      98,   340,   588,   586,   587,    25,   469,     0,     0,    30,
      50,     0,    55,   338,    24,   466,   470,   467,   589,    26,
     342,   341,   344,   343,   101,   100,   103,   102,   104,   106,
     108,   110,   112,   114,   116,   118,   120,   122,   124,   126,
     128,   130,   132,   134,   136,   138,   140,   144,   142,   146,
     148,   150,   152,   154,   156,   158,   160,   162,   164,   166,
     168,   170,   172,   175,   174,   182,   176,   177,   184,   183,
     186,   185,   188,   187,   190,   189,   192,   191,   194,   193,
     196,   195,   198,   197,   200,   199,   202,   201,   204,   203,
     206,   205,   208,   207,   210,   209,   212,   211,   331,   330,
     333,   332,   335,   334,   337,   336,   458,   457,     0,   465,
     464,   179,   178,   181,   180,   217,   216,   215,   220,   219,
     218,   223,   222,   221,   226,   225,   224,   229,   228,   227,
     231,   230,   233,   232,   235,   234,   237,   236,   239,   238,
     241,   240,   243,   242,   246,   244,   245,   248,   247,   250,
     249,   252,   251,   254,     0,   253,   256,   255,   258,   257,
     260,   259,   261,   263,   265,   267,   270,   269,   272,   271,
     274,   273,   276,   275,   278,   277,   280,   279,   282,   281,
     284,   283,   286,   285,   288,   287,   290,   289,   292,   291,
     294,   293,   296,   295,   298,   297,   300,   299,   302,   301,
     304,   303,   309,   305,   306,   307,   308,   321,   320,   323,
     322,   311,   310,   313,   312,   315,   314,   317,   316,   319,
     318,   325,   324,   327,   326,   329,   328,   346,   345,   348,
     347,   350,   349,   352,   351,   354,   353,   356,   355,   358,
     357,   360,   359,   362,   361,   364,   363,   366,   365,   368,
     367,   370,   369,   372,   371,   374,   373,   376,   375,   379,
     377,   378,   382,   380,   381,   383,   386,   385,   388,   387,
     390,   389,   392,   391,   394,   393,   396,   395,   398,   397,
     214,   213,   400,   399,   402,   401,   404,   403,     0,     0,
       0,   411,   412,   416,   415,   414,   413,   418,   417,   420,
     419,   422,   421,   424,   423,   426,   425,     0,     0,     0,
     479,     0,   480,     0,   484,     0,     0,   497,     0,     0,
     501,     0,     0,   504,     0,   444,   445,   443,     0,     0,
       0,     0,    58,     0,    27,     0,     0,     0,     0,    56,
       0,     0,     0,     0,     0,     0,     0,    62,    64,    70,
       0,     0,     0,     0,     0,     0,   891,   888,   892,   895,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   844,   846,   848,
     851,     0,     0,     0,     0,     0,   865,   867,   869,   871,
       0,     0,     0,     0,     0,     0,     0,   721,   722,   723,
     648,     0,   660,   661,   606,     0,     0,   598,   601,   602,
     603,     0,   652,   653,   663,   664,   665,     0,     0,     0,
     594,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   493,     0,     0,     0,    29,   471,    54,    44,
      43,    51,    52,     0,   593,   588,   591,   592,   590,     0,
     406,   405,   408,   407,   410,   409,     0,   734,     0,   756,
       0,   767,     0,   778,     0,   745,     0,     0,   532,   533,
     534,   545,   538,   546,   539,   544,   536,   543,   535,     0,
     537,     0,   540,     0,   541,   634,   680,   678,   679,     0,
       0,     0,     0,     0,   667,     0,     0,   666,     0,   542,
       0,   547,     0,   673,   672,   671,     0,   654,   656,   655,
     668,   669,   670,   681,     0,   890,     0,   887,     0,   894,
     782,     0,   799,     0,   803,     0,     0,   807,     0,   826,
       0,   829,     0,   810,     0,   816,     0,   813,     0,   819,
       0,   822,     0,     0,   835,     0,   838,     0,   832,     0,
     841,     0,     0,     0,     0,     0,     0,     0,     0,   857,
       0,   860,     0,   863,     0,     0,     0,     0,     0,   626,
       0,     0,   874,     0,   877,     0,   786,     0,   789,     0,
     792,     0,   881,     0,   607,   600,   599,   477,   597,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,     0,
     646,   649,   662,     0,   605,   797,     0,   604,     0,   482,
       0,   495,     0,   499,     0,   450,   446,   447,     0,   488,
       0,     0,    28,     0,     0,     0,     0,     0,     0,   581,
       0,   724,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   551,   511,   512,   520,   513,   514,
     519,     0,     0,     0,   576,     0,     0,   719,   702,   704,
     683,   705,   684,     0,     0,     0,   889,   654,   655,   669,
     670,     0,     0,     0,     0,   555,     0,   560,   515,   516,
     517,   518,     0,     0,   572,     0,   649,   703,   682,     0,
       0,     0,     0,     0,     0,     0,   521,   522,   527,   523,
     524,   525,   526,   528,   529,   530,   531,     0,     0,     0,
       0,     0,     0,     0,   886,   893,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   818,     0,   821,
       0,   824,     0,     0,     0,     0,     0,     0,     0,     0,
     843,   845,   847,     0,     0,   850,     0,     0,     0,   608,
     595,     0,     0,     0,     0,     0,    45,     0,     0,   864,
     866,   868,   870,     0,   628,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   882,     0,     0,   720,     0,
     659,     0,   657,     0,   658,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    53,   339,     0,     0,     0,   735,
       0,   733,     0,   726,     0,   727,     0,     0,     0,   725,
     757,     0,   755,     0,   748,     0,   749,     0,   747,   768,
       0,   766,     0,   759,     0,   760,     0,   758,   779,     0,
     777,     0,   770,     0,   771,     0,   769,   746,     0,   744,
       0,   737,     0,   738,     0,   736,   550,     0,   548,   566,
      36,    37,    38,    39,    40,    41,    42,   564,   565,   563,
     561,   562,   575,   573,   574,   629,   633,   635,     0,     0,
       0,     0,   677,   699,   676,   675,   674,   554,     0,   552,
     559,   557,   558,   556,   571,     0,    57,     0,   579,   567,
     569,   568,     0,   716,   698,   715,   697,   711,   690,   712,
     691,   692,   693,   694,   706,   685,   707,   686,   708,   687,
     709,   688,   710,   689,   714,   696,   713,   695,   783,     0,
     780,   800,     0,   804,   802,   801,   805,   808,   806,   827,
     825,   830,   828,   811,   809,   817,   815,   814,   812,   823,
     820,   836,   834,   839,   837,   833,   831,   842,   840,   852,
     849,   854,   853,     0,     0,   856,   855,   859,   858,   862,
       0,     0,   861,     0,     0,     0,   625,   623,     0,   875,
       0,   878,   876,   784,   785,   787,   788,   790,   791,   885,
       0,   884,   647,   651,     0,   796,   649,     0,     0,     0,
       0,     0,   448,   449,     0,   492,     0,   459,   460,   478,
       0,     0,     0,     0,   585,   583,   584,   582,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   717,   700,   718,   701,     0,     0,     0,     0,   596,
     609,    49,    46,    47,   627,     0,     0,     0,   610,   616,
     624,   622,    57,     0,     0,   880,     0,     0,     0,   483,
     496,   500,   503,   451,   452,   468,   731,   732,   729,   730,
     728,   753,   754,   751,   752,   750,   764,   765,   762,   763,
     761,   775,   776,   773,   774,   772,   742,   743,   740,   741,
     739,     0,     0,   632,   580,   578,   577,   650,   781,   798,
       0,   619,     0,     0,     0,     0,   872,   873,   883,   795,
     794,   793,   631,   630,    48,     0,   620,   614,   621,     0,
       0,     0
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1148, -1148, -1148,  2163, -1148, -1148, -1148, -1148, -1148,  -399,
    1394,  1494,  -213,  1177, -1147, -1148, -1148,   -77,  -218, -1148,
    1524, -1148,  -186, -1148,  1534, -1148, -1148, -1148,  1224, -1148,
   -1148,  -973,  2019,  1849,  2020,   177, -1148, -1148, -1148, -1148,
   -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148, -1148,
   -1148,  -985, -1148,  -967, -1148, -1148,  1179, -1148, -1148, -1148,
    1180, -1148, -1148,   263,  -706, -1148,  -332, -1094,  -765,  -731,
   -1148,   781,   860, -1148, -1148, -1148,   803, -1148, -1148, -1148,
   -1148,  1056,  -813,  -550,  -838, -1148,  -761, -1148, -1148, -1148,
    -468,  -806, -1148, -1148, -1148, -1148,    40,  -202, -1148, -1148,
   -1148, -1148,   784, -1148
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,   194,   195,   196,   197,   198,   199,   200,   201,   539,
     865,   540,   541,  1407,   971,  1308,   542,   543,  1027,   202,
     445,   446,   447,   203,   450,   451,   204,   205,   858,   206,
     207,   544,   545,   546,   547,   483,   463,   464,   466,   467,
     208,   209,   860,   963,   469,   470,   472,   473,   475,   476,
     210,  1190,  1223,  1191,  1252,  1253,  1028,  1029,  1030,  1031,
    1032,  1033,  1439,  1163,   548,   549,  1034,  1299,   936,   937,
     938,  1597,  1517,  1518,   939,   940,  1416,  1417,  1035,  1196,
    1129,  1130,  1131,  1036,  1037,  1038,  1039,   944,  1040,  1333,
    1041,  1042,  1133,   947,  1043,  1044,  1211,   948,   949,   950,
    1113,  1530,  1531,   951
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     498,   449,   758,   504,   494,   942,  1344,  1314,   942,   337,
    1644,   942,   334,   212,   942,  1162,   211,  1167,  1157,  1172,
    1513,  1177,   942,  1182,  1192,   214,  1193,   240,  1195,   561,
     686,   562,   853,   563,   987,   564,   989,   946,  1305,   991,
     946,   969,   993,   946,   842,  1222,   946,   477,   962,   840,
    1550,  1559,   332,   970,   946,   844,  1356,  1114,  1564,   995,
     496,  1216,   871,   215,   478,  1225,  1357,   855,  1050,   216,
    1356,   757,   872,   497,   847,  1514,  1515,  1358,  1158,  1359,
    1357,   953,   943,   217,   955,   943,   513,   957,   943,   531,
     850,   943,   594,   465,   550,   961,  1112,  1613,   942,   943,
    1614,  1052,   613,   615,   617,   619,   621,   623,   625,  1054,
    1164,  1057,   452,   218,  1059,   942,  1061,   942,  1063,   942,
    1554,   480,   481,   942,   482,   489,   490,   491,   492,  1556,
     946,  1169,   219,   454,   339,   669,   671,   673,   864,  1174,
    1065,  1067,   220,  1069,  1071,   442,  1074,   946,  1076,   946,
    1078,   946,  1080,  1089,   221,   946,  1091,  1093,  1102,   551,
    1514,  1515,   222,  1104,  1106,   976,   978,  1108,  1110,  1112,
    1165,  1135,   443,   496,   444,   943,   489,   490,   491,   492,
    1569,   489,   490,   491,   492,  1179,   497,  1207,   942,   456,
     496,  1170,   943,   515,   943,   484,   943,  1145,  1293,  1175,
     943,  1533,  1350,   497,  1351,  1118,  1346,  1278,  1207,   223,
    1207,   448,  1352,   486,  1353,   645,   519,   824,   826,  1210,
     946,   974,  1118,  1226,  1118,   648,  1118,   499,   496,  1329,
    1118,   461,   462,   651,   523,   224,  1356,   654,   525,   527,
    1210,   497,  1210,   225,  1641,  1180,  1357,   226,   227,  1207,
     942,   228,  1438,   242,   657,   674,   229,  1367,   529,  1368,
     230,  1214,  1301,   942,  1208,   943,   789,   231,  1256,  1607,
     232,   630,   632,  1319,   443,   636,   444,   639,   745,   747,
     749,  1210,   946,   810,   980,  1208,   982,  1208,   984,   818,
     819,   820,  1259,   941,  1265,   946,   941,  1267,  1332,   941,
    1269,  1271,   941,   432,  1282,  1284,   335,  1286,  1288,  1315,
     941,  1317,   942,   968,   468,   977,  1551,  1560,   942,   792,
     233,   241,   495,   234,  1565,   501,  1208,   943,   505,   507,
    1334,   503,   509,   511,   593,   517,   612,  1645,   856,   857,
     943,   536,   336,   614,   946,   684,  1159,   338,  1160,   536,
     946,   538,  -485,   493,   213,  1161,  1591,  1300,   616,   538,
    1516,   536,   618,  1592,  -486,   532,   533,   534,   535,   536,
    1300,   538,   988,  -502,   990,   945,   942,   992,   945,   538,
     994,   945,   333,  -476,   945,  1342,   941,  -491,  -475,   943,
     841,  1348,   945,  1115,  -481,   943,   845,   996,   532,   533,
     534,   535,   536,   941,   493,   941,  1051,   941,   946,   493,
    1590,   941,   538,  -494,   514,   848,   532,   533,   534,   535,
     536,   532,   533,   534,   535,   536,   620,   537,   340,  -498,
     538,   851,   537,  1474,  -879,   538,   622,   684,  1159,  1053,
    1166,   536,   453,  1195,   624,  1600,  1570,  1055,  1555,  1058,
    1195,   538,  1060,   943,  1062,   521,  1064,  1557,   684,  1159,
     942,  1171,   536,   455,   341,   869,   684,  1159,   945,  1176,
     536,   973,   538,   443,   552,   444,   941,   668,  1066,  1068,
     538,  1070,  1072,  1118,  1075,   945,  1077,   945,  1079,   945,
    1081,  1090,   946,   945,  1092,  1094,  1103,   942,   942,   942,
     942,  1105,  1107,  1664,   942,  1109,  1111,  -879,   930,  1136,
     942,   935,   684,  1159,   935,  1181,   536,   935,  1536,   457,
     935,   496,   485,   516,  1146,  1294,   538,  1147,   935,   946,
     946,   946,   946,  1503,   497,  1295,   946,   943,   941,   443,
     487,   444,   946,   646,  1279,   647,   520,   243,   975,   533,
     534,   941,   670,   649,   500,   650,   554,  1209,   945,  1330,
     556,   652,   933,   653,   524,   655,   864,   656,   526,   528,
    1538,  1539,  1540,  1541,   943,   943,   943,   943,  1209,   235,
    1209,   943,   658,   675,   659,   676,  1331,   943,   530,   532,
     533,   534,   535,   536,   790,  1257,   791,   443,  1258,   444,
     941,   631,   633,   538,   935,   637,   941,   640,   746,   748,
     750,  1118,  1646,   811,   981,   672,   983,  1118,   985,  1209,
     945,   935,  1260,   935,  1266,   935,   244,  1268,   969,   935,
    1270,  1272,   823,   945,  1283,  1285,   496,  1287,  1289,  1316,
     970,  1318,   975,   533,   534,   496,   793,   794,   496,   497,
     496,   825,   502,   449,   595,   506,   508,   496,   497,   510,
     512,   497,   518,   497,   941,   942,   942,   598,   600,   602,
     497,   969,   496,   604,   606,   608,   496,  1194,   246,   248,
     610,   626,   945,   970,   628,   497,   634,   641,   945,   497,
     643,  1302,   660,   662,   935,  1306,   664,   946,   946,   666,
     942,   942,   942,   942,   677,   679,   681,   683,  1574,   236,
     688,   690,   696,   698,   700,   702,   704,   706,   708,   710,
     712,   714,   237,   716,   718,   720,   722,   724,   726,   728,
     730,   737,   946,   946,   946,   946,   739,   741,   743,   751,
     496,   753,   943,   943,   238,   239,   945,   755,   941,   759,
     496,   761,   763,   497,   765,   767,   935,   310,   496,   769,
     771,   942,   773,   497,   775,   777,   779,   781,   488,   935,
     783,   497,  1118,  1300,   311,   785,   787,   943,   943,   943,
     943,   796,   522,   798,   800,   941,   941,   941,   941,   312,
     313,   496,   941,   946,   250,   802,   804,   806,   941,   808,
     812,   553,   814,   816,   497,   827,   829,  1118,  1118,  1118,
    1118,   831,   833,   942,   835,  1273,   942,   942,   935,  1275,
    1303,   314,   315,  1212,   935,  1296,   316,   942,   942,   942,
     945,   942,   942,   942,  1655,   317,  1321,   443,   943,   444,
     252,  1217,   254,   256,  1212,   946,  1212,   318,   946,   946,
     474,   258,  1184,   319,  1280,   489,   490,   491,   492,   946,
     946,   946,  1215,   946,   946,   946,   496,   945,   945,   945,
     945,   320,  1224,  1297,   945,  1323,   443,   321,   444,   497,
     945,  1307,   935,   555,   260,  1212,  1665,   557,   262,  1669,
     943,   264,   322,   943,   943,   266,   268,   270,   272,   274,
     276,  1670,  1671,   323,   943,   943,   943,   324,   943,   943,
     943,   278,   489,   490,   491,   492,   280,   282,   284,   286,
     245,  1320,   288,  1322,  1118,  1324,  1045,  1047,  1049,   496,
     325,   290,   292,   294,  1118,   296,   298,  1347,  1118,  1118,
    1118,   300,   497,   302,   304,   306,   496,   308,   364,   326,
     327,   366,  1088,   941,   941,   368,   370,   419,   328,   497,
    1100,  1101,  1185,  1186,   329,   496,   935,  1188,  1189,  1354,
     330,  1355,   247,   249,  1575,  1361,  1356,  1362,   497,  1185,
    1186,   596,   331,   342,  1188,  1189,  1357,   471,   941,   941,
     941,   941,   343,   558,   599,   601,   603,  1376,   458,  1377,
     605,   607,   609,   935,   935,   935,   935,   611,   627,   838,
     935,   629,   559,   635,   642,   863,   935,   644,   880,   661,
     663,   479,   952,   665,   560,   954,   667,   344,   956,   345,
     565,   678,   680,   682,   684,   945,   945,   689,   691,   697,
     699,   701,   703,   705,   707,   709,   711,   713,   715,   941,
     717,   719,   721,   723,   725,   727,   729,   731,   738,  1198,
    1200,  1202,   732,   740,   742,   744,   752,  1363,   754,  1364,
     945,   945,   945,   945,   756,  1356,   760,   566,   762,   764,
     346,   766,   768,   493,  1228,  1357,   770,   772,   251,   774,
     567,   776,   778,   780,   782,  1263,  1385,   784,  1386,   597,
     568,   941,   786,   788,   941,   941,   569,  1365,   797,  1366,
     799,   801,  1593,   837,   570,   941,   941,   941,   347,   941,
     941,   941,   803,   805,   807,   348,   809,   813,   349,   815,
     817,   945,   828,   830,   253,   571,   255,   257,   832,   834,
     493,   836,  1274,  1185,  1186,   259,  1276,  1304,  1188,  1189,
    1218,  1219,  1220,  1221,  1185,  1186,  1187,   350,   351,  1188,
    1189,  1249,  1250,  1251,  1185,  1186,  1187,   352,   353,  1188,
    1189,   935,   935,  1328,  1185,  1186,  1187,   354,   261,  1188,
    1189,   355,   263,   945,   356,   265,   945,   945,   357,   267,
     269,   271,   273,   275,   277,   358,   359,   945,   945,   945,
     360,   945,   945,   945,   361,   279,   935,   935,   935,   935,
     281,   283,   285,   287,   362,   363,   289,   489,   490,   491,
     492,  1370,   372,  1371,  1586,   291,   293,   295,  1412,   297,
     299,  1398,  1408,  1411,   373,   301,   374,   303,   305,   307,
     375,   309,   365,  1419,  1421,   367,   376,   377,   378,   369,
     371,   420,   379,  1168,   572,  1173,  1429,  1178,  1372,  1183,
    1373,   573,  1431,  1433,  1374,  1441,  1375,   935,   380,  1444,
    1446,  1448,  1450,  1451,  1452,  1453,  1247,  1248,  1249,  1250,
    1251,   381,   382,   733,   734,   735,   736,  1455,  1457,  1459,
    1461,  1463,  1465,  1467,  1379,  1381,  1380,  1382,   998,   999,
    1000,  1001,  1383,  1003,  1384,  1005,   383,  1007,  1119,  1120,
    1121,  1122,  1123,  1124,  1125,  1126,  1127,   384,   385,   935,
    1356,   638,   935,   935,  1388,  1390,  1389,  1391,   386,  1392,
    1357,  1393,   387,   935,   935,   935,   388,   935,   935,   935,
    1534,  1394,  1535,  1395,  1604,   389,  1605,   390,  1606,   391,
     392,  1608,   393,   394,   395,  1128,   574,   396,   397,   398,
     399,  1642,   400,   401,   402,  1529,  1229,  1230,  1231,  1232,
    1233,  1234,  1235,  1236,  1237,  1238,  1239,  1240,  1241,  1242,
    1243,  1244,  1245,  1246,  1247,  1248,  1249,  1250,  1251,  1231,
    1232,  1233,  1234,  1235,  1236,  1237,  1238,  1239,  1240,  1241,
    1242,  1243,  1244,  1245,  1246,  1247,  1248,  1249,  1250,  1251,
    1313,  1229,  1230,  1231,  1232,  1233,  1234,  1235,  1236,  1237,
    1238,  1239,  1240,  1241,  1242,  1243,  1244,  1245,  1246,  1247,
    1248,  1249,  1250,  1251,   403,   532,   533,   534,   535,   536,
     532,   533,   534,   535,   536,   493,   537,   404,   405,   538,
     406,   407,   408,  1423,   538,   409,   410,   532,   533,   534,
     535,   536,   411,   412,   575,   413,   414,   415,   537,   416,
     417,   538,  1236,  1237,  1238,  1239,  1240,  1241,  1242,  1243,
    1244,  1245,  1246,  1247,  1248,  1249,  1250,  1251,  1440,  1229,
    1230,  1231,  1232,  1233,  1234,  1235,  1236,  1237,  1238,  1239,
    1240,  1241,  1242,  1243,  1244,  1245,  1246,  1247,  1248,  1249,
    1250,  1251,  1233,  1234,  1235,  1236,  1237,  1238,  1239,  1240,
    1241,  1242,  1243,  1244,  1245,  1246,  1247,  1248,  1249,  1250,
    1251,  1475,  1234,  1235,  1236,  1237,  1238,  1239,  1240,  1241,
    1242,  1243,  1244,  1245,  1246,  1247,  1248,  1249,  1250,  1251,
     418,    -2,   459,   421,  1598,   422,   423,   424,   576,   425,
    1603,   426,   427,   428,   429,   -11,   -11,   -13,     2,     3,
     -16,   -18,   -20,  1243,  1244,  1245,  1246,  1247,  1248,  1249,
    1250,  1251,   430,   431,   433,   434,   435,   436,   437,     4,
     438,   439,     5,     6,     7,     8,     9,   440,   441,   577,
     578,   579,   580,   581,   582,   583,   584,   585,    10,  1229,
    1230,  1231,  1232,  1233,  1234,  1235,  1236,  1237,  1238,  1239,
    1240,  1241,  1242,  1243,  1244,  1245,  1246,  1247,  1248,  1249,
    1250,  1251,   586,   587,   588,   589,  1598,   590,   591,   592,
     692,   843,   693,   694,  1529,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
     695,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   795,   821,   822,   839,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   846,   175,   176,   849,   852,   859,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   854,   862,   861,   536,   870,   873,   867,   868,   874,
     875,   876,   878,   188,   189,   190,   958,   964,  1229,  1230,
    1231,  1232,  1233,  1234,  1235,  1236,  1237,  1238,  1239,  1240,
    1241,  1242,  1243,  1244,  1245,  1246,  1247,  1248,  1249,  1250,
    1251,   959,   960,   965,   966,   967,   986,  1056,   979,  1073,
     191,  1082,  1083,  1132,  1138,  1148,  1134,  1084,   192,  1085,
    1582,  1151,  1086,  1095,  1112,   193,  -581,  -581,  -581,  -581,
    -581,  -581,  -581,  -581,  -581,  -581,  -581,  -581,  1096,  1097,
    1098,  1137,  1150,  1153,  1155,  -581,  -581,  -581,  -581,  -581,
    -581,  -581,  -581,  1140,  -581,  -581,  -581,  -581,  -581,  -581,
    -581,  -581,  -581,  -581,  1142,  -581,  1144,  1154,  1156,  -581,
    1203,  -581,  -581,  -581,  -581,  -581,  -581,  -581,  -581,  1204,
    1264,  -581,  -581,  -581,  1277,  1281,  1290,  -581,  -581,  -581,
    -581,  -581,  -581,  1112,  1291,  -549,  -549,  -549,  -549,  -549,
    -549,  -549,  -549,  -549,  -549,  -549,  -549,  1292,  1309,  1310,
    1311,  1312,  1326,  1325,  -549,  -549,  -549,  -549,  -549,  -549,
    -549,  -549,  1327,  -549,  -549,  -549,  -549,  -549,  -549,  -549,
    -549,  -549,  -549,  1335,  -549,  1336,  1337,  1338,  -549,  1339,
    -549,  -549,  -549,  -549,  -549,  -549,  -549,  -549,  1340,  1343,
    -549,  -549,  -549,  1345,  1349,  1360,  -549,  -549,  -549,  -549,
    -549,  -549,  1194,  1415,  -553,  -553,  -553,  -553,  -553,  -553,
    -553,  -553,  -553,  -553,  -553,  -553,  1369,  1378,  1387,  1422,
    1424,  -652,  -653,  -553,  -553,  -553,  -553,  -553,  -553,  -553,
    -553,  -664,  -553,  -553,  -553,  -553,  -553,  -553,  -553,  -553,
    -553,  -553,  -665,  -553,  1425,  1468,  1442,  -553,  1469,  -553,
    -553,  -553,  -553,  -553,  -553,  -553,  -553,  1470,  1471,  -553,
    -553,  -553,  1473,  1504,  1472,  -553,  -553,  -553,  -553,  -553,
    -553,  1194,  1476,  -570,  -570,  -570,  -570,  -570,  -570,  -570,
    -570,  -570,  -570,  -570,  -570,  1510,  1477,  1478,  1479,  1480,
    1481,  1482,  -570,  -570,  -570,  -570,  -570,  -570,  -570,  -570,
    1483,  -570,  -570,  -570,  -570,  -570,  -570,  -570,  -570,  -570,
    -570,  1484,  -570,  1485,  1486,  1487,  -570,  1488,  -570,  -570,
    -570,  -570,  -570,  -570,  -570,  -570,  1489,  1490,  -570,  -570,
    -570,  1491,  1492,  1493,  -570,  -570,  -570,  -570,  -570,  -570,
    1494,  1495,  1496,  -581,  1497,  1498,  1499,  1500,  1501,  1502,
    1505,  1506,  1507,  1508,  1509,  1512,  1519,  1520,  1521,  -581,
    -581,  -581,  -581,  -581,  -581,  -581,  -581,  -581,  -581,  -581,
    -581,  -581,  -581,  -581,  -581,  -581,  -581,  -581,  -581,  -581,
    -581,  -581,  1511,  1522,  1523,  1524,  1525,  1526,  -581,  1527,
    1528,  1128,  -581,  1533,  1537,  1542,  -581,  -581,  1543,  -581,
    -581,  -581,  -879,  -581,  1544,  1546,  1547,  1548,  -581,  1552,
    1553,  1558,  -549,  1561,  1562,  1563,  1566,  1567,  1568,  1571,
    1572,  1573,  1576,  1577,  1578,  1580,  1579,  1585,  -549,  -549,
    -549,  -549,  -549,  -549,  -549,  -549,  -549,  -549,  -549,  -549,
    -549,  -549,  -549,  -549,  -549,  -549,  -549,  -549,  -549,  -549,
    -549,  1581,  1583,  1587,  1588,  1615,  1594,  1599,  1616,  1617,
    1647,  -549,  1618,  1619,  1620,  -549,  -549,  1621,  -549,  -549,
    -549,  -879,  -549,  1622,  1623,  1624,  1625,  -549,  1626,  1627,
    1628,  -553,  1629,  1630,  1631,  1632,  1633,  1634,  1635,  1636,
    1637,  1638,  1639,  1640,  1648,  1649,  1656,  -553,  -553,  -553,
    -553,  -553,  -553,  -553,  -553,  -553,  -553,  -553,  -553,  -553,
    -553,  -553,  -553,  -553,  -553,  -553,  -553,  -553,  -553,  -553,
    1650,  1651,  1654,  1659,  1660,  1661,  1662,  1663,   460,  1152,
    -553,   877,   972,  1666,  -553,  -553,  1667,  -553,  -553,  -553,
    1410,  -553,  1341,   879,  1413,  1414,  -553,  1653,  1601,   685,
    -570,   687,  1532,  1643,     0,     0,     0,   866,  1658,     0,
       0,     0,     0,     0,     0,     0,  -570,  -570,  -570,  -570,
    -570,  -570,  -570,  -570,  -570,  -570,  -570,  -570,  -570,  -570,
    -570,  -570,  -570,  -570,  -570,  -570,  -570,  -570,  -570,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  -570,
       0,     0,     0,  -570,  -570,     1,  -570,  -570,  -570,     0,
    -570,     0,     0,     0,     0,  -570,     0,     0,   -11,   -11,
     -13,     2,     3,   -16,   -18,   -20,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     4,     0,     0,     5,     6,     7,     8,     9,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    10,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1229,  1230,  1231,  1232,  1233,  1234,  1235,  1236,  1237,
    1238,  1239,  1240,  1241,  1242,  1243,  1244,  1245,  1246,  1247,
    1248,  1249,  1250,  1251,     0,     0,     0,     0,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,  1584,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,     0,     0,     0,     0,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,     0,   175,   176,
       0,     0,     0,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   188,   189,   190,     0,
       0,     0,     0,     0,  1229,  1230,  1231,  1232,  1233,  1234,
    1235,  1236,  1237,  1238,  1239,  1240,  1241,  1242,  1243,  1244,
    1245,  1246,  1247,  1248,  1249,  1250,  1251,     0,     0,     0,
       0,     0,  1434,   191,   881,   882,   883,   884,   885,     0,
       0,   192,     0,   890,   891,   892,  1657,     0,   193,     0,
       0,     0,     0,   893,   894,   895,   896,   897,   898,   899,
     900,     0,   901,   902,   903,   904,   905,   906,   907,   908,
     909,   910,     0,   911,     0,     0,     0,     0,     0,   913,
     914,   915,   916,   917,   918,   919,     0,     0,     0,     0,
     922,   923,     0,     0,     0,   924,   925,   926,   927,   928,
     929,   997,   998,   999,  1000,  1001,  1002,  1003,  1004,  1005,
    1006,  1007,  1008,  1009,  1010,  1011,  1012,  1435,  1014,  1668,
       0,   881,   882,   883,   884,   885,   886,   887,   888,   889,
     890,   891,   892,     0,     0,     0,     0,     0,     0,     0,
     893,   894,   895,   896,   897,   898,   899,   900,     0,   901,
     902,   903,   904,   905,   906,   907,   908,   909,   910,     0,
     911,     0,     0,     0,   912,     0,   913,   914,   915,   916,
     917,   918,   919,   920,  -613,  -613,   921,   922,   923,     0,
       0,     0,   924,   925,   926,   927,   928,   929,  1116,     0,
     881,   882,   883,   884,   885,   886,   887,   888,   889,   890,
     891,   892,     0,     0,     0,     0,     0,     0,     0,   893,
     894,   895,   896,   897,   898,   899,   900,     0,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,     0,   911,
       0,     0,     0,   912,     0,   913,   914,   915,   916,   917,
     918,   919,   920,  -615,  -615,   921,   922,   923,     0,     0,
       0,   924,   925,   926,   927,   928,   929,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1116,     0,
     881,   882,   883,   884,   885,   886,   887,   888,   889,   890,
     891,   892,     0,     0,     0,     0,     0,     0,     0,   893,
     894,   895,   896,   897,   898,   899,   900,     0,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,     0,   911,
       0,   930,  1015,   912,     0,   913,   914,   915,   916,   917,
     918,   919,   920,  -617,  -617,   921,   922,   923,     0,     0,
       0,   924,   925,   926,   927,   928,   929,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1016,     0,     0,     0,
    1017,     0,  1018,  1019,  1020,  1021,     0,  1022,  1023,  1436,
    1437,     0,  1024,   536,   932,   933,     0,     0,     0,     0,
    1087,  1026,     0,   538,     0,     0,     0,     0,  1116,     0,
     881,   882,   883,   884,   885,   886,   887,   888,   889,   890,
     891,   892,     0,     0,     0,     0,     0,     0,   930,   893,
     894,   895,   896,   897,   898,   899,   900,     0,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,     0,   911,
       0,     0,     0,   912,     0,   913,   914,   915,   916,   917,
     918,   919,   920,  -611,  -611,   921,   922,   923,     0,     0,
       0,   924,   925,   926,   927,   928,   929,   931,     0,     0,
       0,   932,   933,     0,     0,   934,     0,     0,     0,  -613,
       0,     0,     0,     0,     0,     0,     0,   930,  1230,  1231,
    1232,  1233,  1234,  1235,  1236,  1237,  1238,  1239,  1240,  1241,
    1242,  1243,  1244,  1245,  1246,  1247,  1248,  1249,  1250,  1251,
    1232,  1233,  1234,  1235,  1236,  1237,  1238,  1239,  1240,  1241,
    1242,  1243,  1244,  1245,  1246,  1247,  1248,  1249,  1250,  1251,
       0,     0,     0,     0,     0,     0,   931,     0,     0,     0,
     932,   933,     0,     0,   934,     0,     0,  1116,  -615,   881,
     882,   883,   884,   885,   886,   887,   888,   889,   890,   891,
     892,     0,     0,     0,     0,     0,     0,   930,   893,   894,
     895,   896,   897,   898,   899,   900,     0,   901,   902,   903,
     904,   905,   906,   907,   908,   909,   910,     0,   911,     0,
       0,     0,   912,     0,   913,   914,   915,   916,   917,   918,
     919,   920,  -618,  -618,   921,   922,   923,     0,     0,     0,
     924,   925,   926,   927,   928,   929,   931,     0,     0,     0,
     932,   933,     0,     0,   934,     0,     0,     0,  -617,     0,
       0,  1116,     0,   881,   882,   883,   884,   885,   886,   887,
     888,   889,   890,   891,   892,     0,     0,     0,     0,     0,
       0,     0,   893,   894,   895,   896,   897,   898,   899,   900,
       0,   901,   902,   903,   904,   905,   906,   907,   908,   909,
     910,     0,   911,     0,     0,     0,   912,   930,   913,   914,
     915,   916,   917,   918,   919,   920,  -612,  -612,   921,   922,
     923,     0,     0,     0,   924,   925,   926,   927,   928,   929,
    1235,  1236,  1237,  1238,  1239,  1240,  1241,  1242,  1243,  1244,
    1245,  1246,  1247,  1248,  1249,  1250,  1251,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   931,     0,     0,     0,
     932,   933,     0,     0,   934,     0,     0,  1116,  -611,   881,
     882,   883,   884,   885,   886,   887,   888,   889,   890,   891,
     892,     0,     0,     0,     0,     0,     0,     0,   893,   894,
     895,   896,   897,   898,   899,   900,     0,   901,   902,   903,
     904,   905,   906,   907,   908,   909,   910,     0,   911,     0,
       0,     0,   912,     0,   913,   914,   915,   916,   917,   918,
     919,   920,     0,     0,   921,   922,   923,     0,     0,     0,
     924,   925,   926,   927,   928,   929,  1116,     0,   881,   882,
     883,   884,   885,   886,   887,   888,   889,   890,   891,   892,
       0,     0,     0,     0,     0,     0,   930,   893,   894,   895,
     896,   897,   898,   899,   900,     0,   901,   902,   903,   904,
     905,   906,   907,   908,   909,   910,     0,   911,     0,     0,
       0,   912,     0,   913,   914,   915,   916,   917,   918,   919,
     920,     0,     0,   921,   922,   923,     0,     0,     0,   924,
     925,   926,   927,   928,   929,   931,     0,     0,     0,   932,
     933,     0,     0,   934,     0,     0,     0,  -618,     0,     0,
    1116,     0,   881,   882,   883,   884,   885,   886,   887,   888,
     889,   890,   891,   892,     0,     0,     0,     0,     0,     0,
     930,   893,   894,   895,   896,   897,   898,   899,   900,     0,
     901,   902,   903,   904,   905,   906,   907,   908,   909,   910,
       0,   911,     0,     0,     0,   912,     0,   913,   914,   915,
     916,   917,   918,   919,   920,     0,     0,   921,   922,   923,
       0,     0,     0,   924,   925,   926,   927,   928,   929,   931,
       0,     0,     0,   932,   933,     0,     0,   934,     0,     0,
    1116,  -612,   881,   882,   883,   884,   885,   886,   887,   888,
     889,   890,   891,   892,     0,     0,     0,     0,     0,     0,
       0,   893,   894,   895,   896,   897,   898,   899,   900,     0,
     901,   902,   903,   904,   905,   906,   907,   908,   909,   910,
       0,   911,     0,     0,     0,   912,   930,   913,   914,   915,
     916,   917,   918,   919,   920,     0,     0,   921,   922,   923,
       0,     0,     0,   924,   925,   926,   927,   928,   929,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   931,     0,     0,     0,   932,
     933,     0,     0,   934,     0,     0,     0,  1117,     0,     0,
       0,     0,     0,     0,     0,   930,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   931,     0,     0,     0,   932,   933,
       0,     0,   934,     0,     0,     0,  1139,     0,     0,  1116,
       0,   881,   882,   883,   884,   885,   886,   887,   888,   889,
     890,   891,   892,     0,     0,     0,     0,     0,     0,   930,
     893,   894,   895,   896,   897,   898,   899,   900,     0,   901,
     902,   903,   904,   905,   906,   907,   908,   909,   910,     0,
     911,     0,     0,     0,   912,     0,   913,   914,   915,   916,
     917,   918,   919,   920,     0,     0,   921,   922,   923,     0,
       0,     0,   924,   925,   926,   927,   928,   929,   931,     0,
       0,     0,   932,   933,     0,     0,   934,     0,     0,  1116,
    1141,   881,   882,   883,   884,   885,   886,   887,   888,   889,
     890,   891,   892,     0,     0,     0,     0,     0,     0,   930,
     893,   894,   895,   896,   897,   898,   899,   900,     0,   901,
     902,   903,   904,   905,   906,   907,   908,   909,   910,     0,
     911,     0,     0,     0,   912,     0,   913,   914,   915,   916,
     917,   918,   919,   920,     0,     0,   921,   922,   923,     0,
       0,     0,   924,   925,   926,   927,   928,   929,   931,     0,
       0,     0,   932,   933,     0,     0,   934,     0,     0,  1116,
    1143,   881,   882,   883,   884,   885,   886,   887,   888,   889,
     890,   891,   892,     0,     0,     0,     0,     0,     0,     0,
     893,   894,   895,   896,   897,   898,   899,   900,     0,   901,
     902,   903,   904,   905,   906,   907,   908,   909,   910,     0,
     911,     0,     0,     0,   912,     0,   913,   914,   915,   916,
     917,   918,   919,   920,     0,     0,   921,   922,   923,     0,
       0,     0,   924,   925,   926,   927,   928,   929,     0,     0,
       0,     0,  1116,     0,   881,   882,   883,   884,   885,   886,
     887,   888,   889,   890,   891,   892,     0,     0,     0,     0,
       0,     0,     0,   893,   894,   895,   896,   897,   898,   899,
     900,     0,   901,   902,   903,   904,   905,   906,   907,   908,
     909,   910,     0,   911,     0,     0,     0,   912,   930,   913,
     914,   915,   916,   917,   918,   919,   920,     0,     0,   921,
     922,   923,     0,     0,     0,   924,   925,   926,   927,   928,
     929,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   931,     0,     0,
       0,   932,   933,     0,     0,   934,     0,     0,  1116,  1149,
     881,   882,   883,   884,   885,   886,   887,   888,   889,   890,
     891,   892,     0,     0,     0,     0,     0,     0,   930,   893,
     894,   895,   896,   897,   898,   899,   900,     0,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,     0,   911,
       0,     0,     0,   912,     0,   913,   914,   915,   916,   917,
     918,   919,   920,     0,     0,   921,   922,   923,     0,     0,
       0,   924,   925,   926,   927,   928,   929,   931,     0,     0,
       0,   932,   933,     0,     0,   934,     0,     0,  1116,  1426,
     881,   882,   883,   884,   885,   886,   887,   888,   889,   890,
     891,   892,     0,     0,     0,     0,     0,     0,   930,   893,
     894,   895,   896,   897,   898,   899,   900,     0,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,     0,   911,
       0,     0,     0,   912,     0,   913,   914,   915,   916,   917,
     918,   919,   920,     0,     0,   921,   922,   923,     0,     0,
       0,   924,   925,   926,   927,   928,   929,   931,     0,     0,
       0,   932,   933,     0,     0,   934,     0,     0,     0,  1545,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   930,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     931,     0,     0,     0,   932,   933,     0,     0,   934,     0,
       0,  1116,  1549,   881,   882,   883,   884,   885,   886,   887,
     888,   889,   890,   891,   892,     0,     0,     0,     0,     0,
       0,     0,   893,   894,   895,   896,   897,   898,   899,   900,
       0,   901,   902,   903,   904,   905,   906,   907,   908,   909,
     910,     0,   911,     0,     0,     0,   912,   930,   913,   914,
     915,   916,   917,   918,   919,   920,     0,     0,   921,   922,
     923,     0,     0,     0,   924,   925,   926,   927,   928,   929,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   931,     0,     0,     0,
     932,   933,     0,     0,   934,     0,     0,  1116,  1589,   881,
     882,   883,   884,   885,   886,   887,   888,   889,   890,   891,
     892,     0,     0,     0,     0,     0,     0,   930,   893,   894,
     895,   896,   897,   898,   899,   900,     0,   901,   902,   903,
     904,   905,   906,   907,   908,   909,   910,     0,   911,     0,
       0,     0,   912,     0,   913,   914,   915,   916,   917,   918,
     919,   920,     0,     0,   921,   922,   923,     0,     0,     0,
     924,   925,   926,   927,   928,   929,   931,     0,     0,     0,
     932,   933,     0,     0,   934,     0,     0,  1116,  1609,   881,
     882,   883,   884,   885,   886,   887,   888,   889,   890,   891,
     892,     0,     0,     0,     0,     0,     0,     0,   893,   894,
     895,   896,   897,   898,   899,   900,     0,   901,   902,   903,
     904,   905,   906,   907,   908,   909,   910,     0,   911,     0,
       0,     0,   912,     0,   913,   914,   915,   916,   917,   918,
     919,   920,     0,     0,   921,   922,   923,     0,     0,     0,
     924,   925,   926,   927,   928,   929,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     930,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   931,
       0,     0,     0,   932,   933,     0,     0,   934,     0,     0,
    1399,  1610,   881,   882,   883,   884,   885,     0,     0,     0,
       0,   890,   891,   892,     0,     0,     0,     0,     0,     0,
       0,   893,   894,   895,   896,   897,   898,   899,   900,     0,
     901,   902,   903,   904,   905,   906,   907,   908,   909,   910,
       0,   911,     0,     0,     0,     0,   930,   913,   914,   915,
     916,   917,   918,   919,     0,     0,     0,     0,   922,   923,
       0,     0,     0,   924,   925,   926,   927,   928,   929,   997,
     998,   999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,
    1008,  1009,  1010,  1011,  1012,  1013,  1014,  1400,  1401,  1402,
    1403,  1404,  1405,     0,     0,   931,     0,     0,     0,   932,
     933,     0,     0,   934,     0,     0,     0,  1611,   881,   882,
     883,   884,   885,   886,   887,   888,   889,   890,   891,   892,
       0,     0,     0,     0,     0,     0,   930,   893,   894,   895,
     896,   897,   898,   899,   900,     0,   901,   902,   903,   904,
     905,   906,   907,   908,   909,   910,     0,   911,     0,     0,
       0,   912,     0,   913,   914,   915,   916,   917,   918,   919,
     920,     0,     0,   921,   922,   923,     0,     0,     0,   924,
     925,   926,   927,   928,   929,   931,     0,     0,     0,   932,
     933,     0,     0,   934,     0,     0,  1409,  1612,   881,   882,
     883,   884,   885,     0,     0,     0,     0,   890,   891,   892,
       0,     0,     0,     0,     0,     0,     0,   893,   894,   895,
     896,   897,   898,   899,   900,     0,   901,   902,   903,   904,
     905,   906,   907,   908,   909,   910,     0,   911,     0,     0,
       0,     0,     0,   913,   914,   915,   916,   917,   918,   919,
       0,     0,     0,     0,   922,   923,     0,     0,     0,   924,
     925,   926,   927,   928,   929,   997,   998,   999,  1000,  1001,
    1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,
    1012,  1013,  1014,  1400,  1401,  1402,  1403,  1404,  1405,   930,
    1015,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1016,  1406,     0,     0,  1017,     0,
    1018,  1019,  1020,  1021,     0,  1022,  1023,   497,   931,     0,
    1024,     0,   932,   933,     0,     0,     0,     0,  1087,  1026,
    1205,     0,   881,   882,   883,   884,   885,     0,     0,     0,
       0,   890,   891,   892,     0,     0,     0,     0,     0,     0,
       0,   893,   894,   895,   896,   897,   898,   899,   900,     0,
     901,   902,   903,   904,   905,   906,   907,   908,   909,   910,
       0,   911,     0,     0,     0,   930,     0,   913,   914,   915,
     916,   917,   918,   919,     0,     0,     0,     0,   922,   923,
       0,     0,     0,   924,   925,   926,   927,   928,   929,   997,
     998,   999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,
    1008,  1009,  1010,  1011,  1012,  1013,  1014,     0,     0,     0,
       0,     0,     0,     0,   931,     0,     0,     0,   932,   933,
       0,     0,   934,     0,     0,  1298,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   930,  1015,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1016,  1406,     0,     0,  1017,     0,  1018,  1019,  1020,  1021,
       0,  1022,  1023,   497,   931,     0,  1024,     0,   932,   933,
       0,     0,     0,     0,  1087,  1026,  1205,     0,   881,   882,
     883,   884,   885,     0,     0,     0,     0,   890,   891,   892,
       0,     0,     0,     0,     0,     0,     0,   893,   894,   895,
     896,   897,   898,   899,   900,     0,   901,   902,   903,   904,
     905,   906,   907,   908,   909,   910,     0,   911,     0,     0,
       0,     0,     0,   913,   914,   915,   916,   917,   918,   919,
       0,     0,     0,     0,   922,   923,     0,     0,     0,   924,
     925,   926,   927,   928,   929,   997,   998,   999,  1000,  1001,
    1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,
    1012,  1013,  1014,     0,     0,     0,     0,     0,     0,   930,
    1015,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1016,     0,     0,     0,  1017,     0,
    1018,  1019,  1020,  1021,     0,  1022,  1023,   497,   931,     0,
    1024,     0,   932,   933,     0,     0,     0,  1206,  1087,  1026,
    1205,     0,   881,   882,   883,   884,   885,     0,     0,     0,
       0,   890,   891,   892,     0,     0,     0,     0,     0,     0,
       0,   893,   894,   895,   896,   897,   898,   899,   900,     0,
     901,   902,   903,   904,   905,   906,   907,   908,   909,   910,
       0,   911,     0,     0,     0,     0,     0,   913,   914,   915,
     916,   917,   918,   919,     0,     0,     0,     0,   922,   923,
       0,     0,     0,   924,   925,   926,   927,   928,   929,   997,
     998,   999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,
    1008,  1009,  1010,  1011,  1012,  1013,  1014,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   930,  1015,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1016,     0,     0,     0,  1017,     0,  1018,  1019,  1020,  1021,
       0,  1022,  1023,   497,   931,     0,  1024,     0,   932,   933,
       0,     0,     0,  1254,  1087,  1026,  1595,     0,   881,   882,
     883,   884,   885,     0,     0,     0,     0,   890,   891,   892,
       0,     0,     0,     0,     0,     0,     0,   893,   894,   895,
     896,   897,   898,   899,   900,     0,   901,   902,   903,   904,
     905,   906,   907,   908,   909,   910,     0,   911,     0,     0,
       0,     0,     0,   913,   914,   915,   916,   917,   918,   919,
       0,     0,     0,     0,   922,   923,     0,     0,     0,   924,
     925,   926,   927,   928,   929,   997,   998,   999,  1000,  1001,
    1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,
    1012,  1013,  1014,     0,     0,     0,     0,     0,     0,   930,
    1015,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1016,     0,     0,     0,  1017,     0,
    1018,  1019,  1020,  1021,     0,  1022,  1023,   497,   931,     0,
    1024,     0,   932,   933,     0,     0,     0,  1255,  1087,  1026,
    1099,     0,   881,   882,   883,   884,   885,     0,     0,     0,
       0,   890,   891,   892,     0,     0,     0,     0,     0,     0,
       0,   893,   894,   895,   896,   897,   898,   899,   900,     0,
     901,   902,   903,   904,   905,   906,   907,   908,   909,   910,
       0,   911,     0,     0,     0,     0,     0,   913,   914,   915,
     916,   917,   918,   919,     0,     0,     0,     0,   922,   923,
       0,     0,     0,   924,   925,   926,   927,   928,   929,   997,
     998,   999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,
    1008,  1009,  1010,  1011,  1012,  1013,  1014,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   930,  1015,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1016,     0,  1596,     0,  1017,     0,  1018,  1019,  1020,  1021,
       0,  1022,  1023,   497,   931,     0,  1024,     0,   932,   933,
       0,     0,     0,     0,  1087,  1026,  1197,     0,   881,   882,
     883,   884,   885,     0,     0,     0,     0,   890,   891,   892,
       0,     0,     0,     0,     0,     0,     0,   893,   894,   895,
     896,   897,   898,   899,   900,     0,   901,   902,   903,   904,
     905,   906,   907,   908,   909,   910,     0,   911,     0,     0,
       0,     0,     0,   913,   914,   915,   916,   917,   918,   919,
       0,     0,     0,     0,   922,   923,     0,     0,     0,   924,
     925,   926,   927,   928,   929,   997,   998,   999,  1000,  1001,
    1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,
    1012,  1013,  1014,     0,     0,     0,     0,     0,     0,   930,
    1015,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1016,     0,     0,     0,  1017,     0,
    1018,  1019,  1020,  1021,     0,  1022,  1023,   497,   931,     0,
    1024,     0,   932,   933,     0,     0,     0,     0,  1087,  1026,
    1199,     0,   881,   882,   883,   884,   885,     0,     0,     0,
       0,   890,   891,   892,     0,     0,     0,     0,     0,     0,
       0,   893,   894,   895,   896,   897,   898,   899,   900,     0,
     901,   902,   903,   904,   905,   906,   907,   908,   909,   910,
       0,   911,     0,     0,     0,     0,     0,   913,   914,   915,
     916,   917,   918,   919,     0,     0,     0,     0,   922,   923,
       0,     0,     0,   924,   925,   926,   927,   928,   929,   997,
     998,   999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,
    1008,  1009,  1010,  1011,  1012,  1013,  1014,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   930,  1015,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1016,     0,     0,     0,  1017,     0,  1018,  1019,  1020,  1021,
       0,  1022,  1023,   497,   931,     0,  1024,     0,   932,   933,
       0,     0,     0,     0,  1087,  1026,  1201,     0,   881,   882,
     883,   884,   885,     0,     0,     0,     0,   890,   891,   892,
       0,     0,     0,     0,     0,     0,     0,   893,   894,   895,
     896,   897,   898,   899,   900,     0,   901,   902,   903,   904,
     905,   906,   907,   908,   909,   910,     0,   911,     0,     0,
       0,     0,     0,   913,   914,   915,   916,   917,   918,   919,
       0,     0,     0,     0,   922,   923,     0,     0,     0,   924,
     925,   926,   927,   928,   929,   997,   998,   999,  1000,  1001,
    1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,
    1012,  1013,  1014,     0,     0,     0,     0,     0,     0,   930,
    1015,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1016,     0,     0,     0,  1017,     0,
    1018,  1019,  1020,  1021,     0,  1022,  1023,   497,   931,     0,
    1024,     0,   932,   933,     0,     0,     0,     0,  1087,  1026,
    1227,     0,   881,   882,   883,   884,   885,     0,     0,     0,
       0,   890,   891,   892,     0,     0,     0,     0,     0,     0,
       0,   893,   894,   895,   896,   897,   898,   899,   900,     0,
     901,   902,   903,   904,   905,   906,   907,   908,   909,   910,
       0,   911,     0,     0,     0,     0,     0,   913,   914,   915,
     916,   917,   918,   919,     0,     0,     0,     0,   922,   923,
       0,     0,     0,   924,   925,   926,   927,   928,   929,   997,
     998,   999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,
    1008,  1009,  1010,  1011,  1012,  1013,  1014,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   930,  1015,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1016,     0,     0,     0,  1017,     0,  1018,  1019,  1020,  1021,
       0,  1022,  1023,   497,   931,     0,  1024,     0,   932,   933,
       0,     0,     0,     0,  1087,  1026,  1261,     0,   881,   882,
     883,   884,   885,     0,     0,     0,     0,   890,   891,   892,
       0,     0,     0,     0,     0,     0,     0,   893,   894,   895,
     896,   897,   898,   899,   900,     0,   901,   902,   903,   904,
     905,   906,   907,   908,   909,   910,     0,   911,     0,     0,
       0,     0,     0,   913,   914,   915,   916,   917,   918,   919,
       0,     0,     0,     0,   922,   923,     0,     0,     0,   924,
     925,   926,   927,   928,   929,   997,   998,   999,  1000,  1001,
    1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,
    1012,  1013,  1014,     0,     0,     0,     0,     0,     0,   930,
    1015,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1016,     0,     0,     0,  1017,     0,
    1018,  1019,  1020,  1021,     0,  1022,  1023,   497,   931,     0,
    1024,     0,   932,   933,     0,     0,     0,     0,  1087,  1026,
    1205,     0,   881,   882,   883,   884,   885,     0,     0,     0,
       0,   890,   891,   892,     0,     0,     0,     0,     0,     0,
       0,   893,   894,   895,   896,   897,   898,   899,   900,     0,
     901,   902,   903,   904,   905,   906,   907,   908,   909,   910,
       0,   911,     0,     0,     0,     0,     0,   913,   914,   915,
     916,   917,   918,   919,     0,     0,     0,     0,   922,   923,
       0,     0,     0,   924,   925,   926,   927,   928,   929,   997,
     998,   999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,
    1008,  1009,  1010,  1011,  1012,  1013,  1014,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   930,  1015,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1016,     0,     0,     0,  1017,     0,  1018,  1019,  1020,  1021,
       0,  1022,  1023,   497,  1262,     0,  1024,     0,   932,   933,
       0,     0,     0,     0,  1087,  1026,  1396,     0,   881,   882,
     883,   884,   885,     0,     0,     0,     0,   890,   891,   892,
       0,     0,     0,     0,     0,     0,     0,   893,   894,   895,
     896,   897,   898,   899,   900,     0,   901,   902,   903,   904,
     905,   906,   907,   908,   909,   910,     0,   911,     0,     0,
       0,     0,     0,   913,   914,   915,   916,   917,   918,   919,
       0,     0,     0,     0,   922,   923,     0,     0,     0,   924,
     925,   926,   927,   928,   929,   997,   998,   999,  1000,  1001,
    1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,
    1012,  1013,  1014,     0,     0,     0,     0,     0,     0,   930,
    1015,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1016,     0,     0,     0,  1017,     0,
    1018,  1019,  1020,  1021,     0,  1022,  1023,   497,   931,     0,
    1024,     0,   932,   933,     0,     0,     0,     0,  1087,  1026,
    1418,     0,   881,   882,   883,   884,   885,     0,     0,     0,
       0,   890,   891,   892,     0,     0,     0,     0,     0,     0,
       0,   893,   894,   895,   896,   897,   898,   899,   900,     0,
     901,   902,   903,   904,   905,   906,   907,   908,   909,   910,
       0,   911,     0,     0,     0,     0,     0,   913,   914,   915,
     916,   917,   918,   919,     0,     0,     0,     0,   922,   923,
       0,     0,     0,   924,   925,   926,   927,   928,   929,   997,
     998,   999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,
    1008,  1009,  1010,  1011,  1012,  1013,  1014,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   930,  1015,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1016,     0,     0,     0,  1017,     0,  1018,  1019,  1020,  1021,
       0,  1022,  1023,   497,  1397,     0,  1024,     0,   932,   933,
       0,     0,     0,     0,  1087,  1026,  1420,     0,   881,   882,
     883,   884,   885,     0,     0,     0,     0,   890,   891,   892,
       0,     0,     0,     0,     0,     0,     0,   893,   894,   895,
     896,   897,   898,   899,   900,     0,   901,   902,   903,   904,
     905,   906,   907,   908,   909,   910,     0,   911,     0,     0,
       0,     0,     0,   913,   914,   915,   916,   917,   918,   919,
       0,     0,     0,     0,   922,   923,     0,     0,     0,   924,
     925,   926,   927,   928,   929,   997,   998,   999,  1000,  1001,
    1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,
    1012,  1013,  1014,     0,     0,     0,     0,     0,     0,   930,
    1015,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1016,     0,     0,     0,  1017,     0,
    1018,  1019,  1020,  1021,     0,  1022,  1023,   497,   931,     0,
    1024,     0,   932,   933,     0,     0,     0,     0,  1087,  1026,
    1427,     0,   881,   882,   883,   884,   885,     0,     0,     0,
       0,   890,   891,   892,     0,     0,     0,     0,     0,     0,
       0,   893,   894,   895,   896,   897,   898,   899,   900,     0,
     901,   902,   903,   904,   905,   906,   907,   908,   909,   910,
       0,   911,     0,     0,     0,     0,     0,   913,   914,   915,
     916,   917,   918,   919,     0,     0,     0,     0,   922,   923,
       0,     0,     0,   924,   925,   926,   927,   928,   929,   997,
     998,   999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,
    1008,  1009,  1010,  1011,  1012,  1428,  1014,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   930,  1015,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1016,     0,     0,     0,  1017,     0,  1018,  1019,  1020,  1021,
       0,  1022,  1023,   497,   931,     0,  1024,     0,   932,   933,
       0,     0,     0,     0,  1087,  1026,  1430,     0,   881,   882,
     883,   884,   885,     0,     0,     0,     0,   890,   891,   892,
       0,     0,     0,     0,     0,     0,     0,   893,   894,   895,
     896,   897,   898,   899,   900,     0,   901,   902,   903,   904,
     905,   906,   907,   908,   909,   910,     0,   911,     0,     0,
       0,     0,     0,   913,   914,   915,   916,   917,   918,   919,
       0,     0,     0,     0,   922,   923,     0,     0,     0,   924,
     925,   926,   927,   928,   929,   997,   998,   999,  1000,  1001,
    1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,
    1012,  1013,  1014,     0,     0,     0,     0,     0,     0,   930,
    1015,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1016,     0,     0,     0,  1017,     0,
    1018,  1019,  1020,  1021,     0,  1022,  1023,   497,   931,     0,
    1024,     0,   932,   933,     0,     0,     0,     0,  1087,  1026,
    1432,     0,   881,   882,   883,   884,   885,     0,     0,     0,
       0,   890,   891,   892,     0,     0,     0,     0,     0,     0,
       0,   893,   894,   895,   896,   897,   898,   899,   900,     0,
     901,   902,   903,   904,   905,   906,   907,   908,   909,   910,
       0,   911,     0,     0,     0,     0,     0,   913,   914,   915,
     916,   917,   918,   919,     0,     0,     0,     0,   922,   923,
       0,     0,     0,   924,   925,   926,   927,   928,   929,   997,
     998,   999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,
    1008,  1009,  1010,  1011,  1012,  1013,  1014,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   930,  1015,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1016,     0,     0,     0,  1017,     0,  1018,  1019,  1020,  1021,
       0,  1022,  1023,   497,   931,     0,  1024,     0,   932,   933,
       0,     0,     0,     0,  1087,  1026,  1443,     0,   881,   882,
     883,   884,   885,     0,     0,     0,     0,   890,   891,   892,
       0,     0,     0,     0,     0,     0,     0,   893,   894,   895,
     896,   897,   898,   899,   900,     0,   901,   902,   903,   904,
     905,   906,   907,   908,   909,   910,     0,   911,     0,     0,
       0,     0,     0,   913,   914,   915,   916,   917,   918,   919,
       0,     0,     0,     0,   922,   923,     0,     0,     0,   924,
     925,   926,   927,   928,   929,   997,   998,   999,  1000,  1001,
    1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,
    1012,  1013,  1014,     0,     0,     0,     0,     0,     0,   930,
    1015,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1016,     0,     0,     0,  1017,     0,
    1018,  1019,  1020,  1021,     0,  1022,  1023,   497,   931,     0,
    1024,     0,   932,   933,     0,     0,     0,     0,  1087,  1026,
    1445,     0,   881,   882,   883,   884,   885,     0,     0,     0,
       0,   890,   891,   892,     0,     0,     0,     0,     0,     0,
       0,   893,   894,   895,   896,   897,   898,   899,   900,     0,
     901,   902,   903,   904,   905,   906,   907,   908,   909,   910,
       0,   911,     0,     0,     0,     0,     0,   913,   914,   915,
     916,   917,   918,   919,     0,     0,     0,     0,   922,   923,
       0,     0,     0,   924,   925,   926,   927,   928,   929,   997,
     998,   999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,
    1008,  1009,  1010,  1011,  1012,  1013,  1014,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   930,  1015,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1016,     0,     0,     0,  1017,     0,  1018,  1019,  1020,  1021,
       0,  1022,  1023,   497,   931,     0,  1024,     0,   932,   933,
       0,     0,     0,     0,  1087,  1026,  1447,     0,   881,   882,
     883,   884,   885,     0,     0,     0,     0,   890,   891,   892,
       0,     0,     0,     0,     0,     0,     0,   893,   894,   895,
     896,   897,   898,   899,   900,     0,   901,   902,   903,   904,
     905,   906,   907,   908,   909,   910,     0,   911,     0,     0,
       0,     0,     0,   913,   914,   915,   916,   917,   918,   919,
       0,     0,     0,     0,   922,   923,     0,     0,     0,   924,
     925,   926,   927,   928,   929,   997,   998,   999,  1000,  1001,
    1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,
    1012,  1013,  1014,     0,     0,     0,     0,     0,     0,   930,
    1015,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1016,     0,     0,     0,  1017,     0,
    1018,  1019,  1020,  1021,     0,  1022,  1023,   497,   931,     0,
    1024,     0,   932,   933,     0,     0,     0,     0,  1087,  1026,
    1449,     0,   881,   882,   883,   884,   885,     0,     0,     0,
       0,   890,   891,   892,     0,     0,     0,     0,     0,     0,
       0,   893,   894,   895,   896,   897,   898,   899,   900,     0,
     901,   902,   903,   904,   905,   906,   907,   908,   909,   910,
       0,   911,     0,     0,     0,     0,     0,   913,   914,   915,
     916,   917,   918,   919,     0,     0,     0,     0,   922,   923,
       0,     0,     0,   924,   925,   926,   927,   928,   929,   997,
     998,   999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,
    1008,  1009,  1010,  1011,  1012,  1013,  1014,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   930,  1015,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1016,     0,     0,     0,  1017,     0,  1018,  1019,  1020,  1021,
       0,  1022,  1023,   497,   931,     0,  1024,     0,   932,   933,
       0,     0,     0,     0,  1087,  1026,  1454,     0,   881,   882,
     883,   884,   885,     0,     0,     0,     0,   890,   891,   892,
       0,     0,     0,     0,     0,     0,     0,   893,   894,   895,
     896,   897,   898,   899,   900,     0,   901,   902,   903,   904,
     905,   906,   907,   908,   909,   910,     0,   911,     0,     0,
       0,     0,     0,   913,   914,   915,   916,   917,   918,   919,
       0,     0,     0,     0,   922,   923,     0,     0,     0,   924,
     925,   926,   927,   928,   929,   997,   998,   999,  1000,  1001,
    1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,
    1012,  1013,  1014,     0,     0,     0,     0,     0,     0,   930,
    1015,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1016,     0,     0,     0,  1017,     0,
    1018,  1019,  1020,  1021,     0,  1022,  1023,   497,   931,     0,
    1024,     0,   932,   933,     0,     0,     0,     0,  1087,  1026,
    1456,     0,   881,   882,   883,   884,   885,     0,     0,     0,
       0,   890,   891,   892,     0,     0,     0,     0,     0,     0,
       0,   893,   894,   895,   896,   897,   898,   899,   900,     0,
     901,   902,   903,   904,   905,   906,   907,   908,   909,   910,
       0,   911,     0,     0,     0,     0,     0,   913,   914,   915,
     916,   917,   918,   919,     0,     0,     0,     0,   922,   923,
       0,     0,     0,   924,   925,   926,   927,   928,   929,   997,
     998,   999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,
    1008,  1009,  1010,  1011,  1012,  1013,  1014,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   930,  1015,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1016,     0,     0,     0,  1017,     0,  1018,  1019,  1020,  1021,
       0,  1022,  1023,   497,   931,     0,  1024,     0,   932,   933,
       0,     0,     0,     0,  1087,  1026,  1458,     0,   881,   882,
     883,   884,   885,     0,     0,     0,     0,   890,   891,   892,
       0,     0,     0,     0,     0,     0,     0,   893,   894,   895,
     896,   897,   898,   899,   900,     0,   901,   902,   903,   904,
     905,   906,   907,   908,   909,   910,     0,   911,     0,     0,
       0,     0,     0,   913,   914,   915,   916,   917,   918,   919,
       0,     0,     0,     0,   922,   923,     0,     0,     0,   924,
     925,   926,   927,   928,   929,   997,   998,   999,  1000,  1001,
    1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,
    1012,  1013,  1014,     0,     0,     0,     0,     0,     0,   930,
    1015,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1016,     0,     0,     0,  1017,     0,
    1018,  1019,  1020,  1021,     0,  1022,  1023,   497,   931,     0,
    1024,     0,   932,   933,     0,     0,     0,     0,  1087,  1026,
    1460,     0,   881,   882,   883,   884,   885,     0,     0,     0,
       0,   890,   891,   892,     0,     0,     0,     0,     0,     0,
       0,   893,   894,   895,   896,   897,   898,   899,   900,     0,
     901,   902,   903,   904,   905,   906,   907,   908,   909,   910,
       0,   911,     0,     0,     0,     0,     0,   913,   914,   915,
     916,   917,   918,   919,     0,     0,     0,     0,   922,   923,
       0,     0,     0,   924,   925,   926,   927,   928,   929,   997,
     998,   999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,
    1008,  1009,  1010,  1011,  1012,  1013,  1014,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   930,  1015,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1016,     0,     0,     0,  1017,     0,  1018,  1019,  1020,  1021,
       0,  1022,  1023,   497,   931,     0,  1024,     0,   932,   933,
       0,     0,     0,     0,  1087,  1026,  1462,     0,   881,   882,
     883,   884,   885,     0,     0,     0,     0,   890,   891,   892,
       0,     0,     0,     0,     0,     0,     0,   893,   894,   895,
     896,   897,   898,   899,   900,     0,   901,   902,   903,   904,
     905,   906,   907,   908,   909,   910,     0,   911,     0,     0,
       0,     0,     0,   913,   914,   915,   916,   917,   918,   919,
       0,     0,     0,     0,   922,   923,     0,     0,     0,   924,
     925,   926,   927,   928,   929,   997,   998,   999,  1000,  1001,
    1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,
    1012,  1013,  1014,     0,     0,     0,     0,     0,     0,   930,
    1015,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1016,     0,     0,     0,  1017,     0,
    1018,  1019,  1020,  1021,     0,  1022,  1023,   497,   931,     0,
    1024,     0,   932,   933,     0,     0,     0,     0,  1087,  1026,
    1464,     0,   881,   882,   883,   884,   885,     0,     0,     0,
       0,   890,   891,   892,     0,     0,     0,     0,     0,     0,
       0,   893,   894,   895,   896,   897,   898,   899,   900,     0,
     901,   902,   903,   904,   905,   906,   907,   908,   909,   910,
       0,   911,     0,     0,     0,     0,     0,   913,   914,   915,
     916,   917,   918,   919,     0,     0,     0,     0,   922,   923,
       0,     0,     0,   924,   925,   926,   927,   928,   929,   997,
     998,   999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,
    1008,  1009,  1010,  1011,  1012,  1013,  1014,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   930,  1015,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1016,     0,     0,     0,  1017,     0,  1018,  1019,  1020,  1021,
       0,  1022,  1023,   497,   931,     0,  1024,     0,   932,   933,
       0,     0,     0,     0,  1087,  1026,  1466,     0,   881,   882,
     883,   884,   885,     0,     0,     0,     0,   890,   891,   892,
       0,     0,     0,     0,     0,     0,     0,   893,   894,   895,
     896,   897,   898,   899,   900,     0,   901,   902,   903,   904,
     905,   906,   907,   908,   909,   910,     0,   911,     0,     0,
       0,     0,     0,   913,   914,   915,   916,   917,   918,   919,
       0,     0,     0,     0,   922,   923,     0,     0,     0,   924,
     925,   926,   927,   928,   929,   997,   998,   999,  1000,  1001,
    1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,
    1012,  1013,  1014,     0,     0,     0,     0,     0,     0,   930,
    1015,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1016,     0,     0,     0,  1017,     0,
    1018,  1019,  1020,  1021,     0,  1022,  1023,   497,   931,     0,
    1024,     0,   932,   933,     0,     0,     0,     0,  1087,  1026,
    1652,     0,   881,   882,   883,   884,   885,     0,     0,     0,
       0,   890,   891,   892,     0,     0,     0,     0,     0,     0,
       0,   893,   894,   895,   896,   897,   898,   899,   900,     0,
     901,   902,   903,   904,   905,   906,   907,   908,   909,   910,
       0,   911,     0,     0,     0,     0,     0,   913,   914,   915,
     916,   917,   918,   919,     0,     0,     0,     0,   922,   923,
       0,     0,     0,   924,   925,   926,   927,   928,   929,   997,
     998,   999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,
    1008,  1009,  1010,  1011,  1012,  1013,  1014,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   930,  1015,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1016,     0,     0,     0,  1017,     0,  1018,  1019,  1020,  1021,
       0,  1022,  1023,   497,   931,     0,  1024,     0,   932,   933,
       0,     0,     0,     0,  1087,  1026,   881,   882,   883,   884,
     885,   886,   887,   888,   889,   890,   891,   892,     0,     0,
       0,     0,     0,     0,     0,   893,   894,   895,   896,   897,
     898,   899,   900,     0,   901,   902,   903,   904,   905,   906,
     907,   908,   909,   910,     0,   911,     0,     0,     0,   912,
       0,   913,   914,   915,   916,   917,   918,   919,   920,     0,
       0,   921,   922,   923,     0,     0,     0,   924,   925,   926,
     927,   928,   929,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   930,
    1015,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1016,     0,     0,     0,  1017,     0,
    1018,  1019,  1020,  1021,     0,  1022,  1023,   497,   931,     0,
    1024,     0,   932,   933,     0,     0,     0,     0,  1087,  1026,
     881,   882,   883,   884,   885,     0,     0,     0,     0,   890,
     891,   892,     0,     0,     0,     0,     0,     0,     0,   893,
     894,   895,   896,   897,   898,   899,   900,     0,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,     0,   911,
       0,     0,     0,     0,     0,   913,   914,   915,   916,   917,
     918,   919,     0,     0,     0,     0,   922,   923,     0,     0,
       0,   924,   925,   926,   927,   928,   929,   997,   998,   999,
    1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,
    1010,  1011,  1012,  1013,  1014,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   930,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1229,
    1230,  1231,  1232,  1233,  1234,  1235,  1236,  1237,  1238,  1239,
    1240,  1241,  1242,  1243,  1244,  1245,  1246,  1247,  1248,  1249,
    1250,  1251,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   931,     0,     0,     0,   932,   933,     0,     0,
     934,     0,     0,  1298,   881,   882,   883,   884,   885,     0,
       0,     0,     0,   890,   891,   892,     0,     0,     0,     0,
       0,     0,     0,   893,   894,   895,   896,   897,   898,   899,
     900,     0,   901,   902,   903,   904,   905,   906,   907,   908,
     909,   910,     0,   911,     0,     0,     0,     0,     0,   913,
     914,   915,   916,   917,   918,   919,     0,     0,     0,     0,
     922,   923,     0,     0,     0,   924,   925,   926,   927,   928,
     929,   997,   998,   999,  1000,  1001,  1002,  1003,  1004,  1005,
    1006,  1007,  1008,  1009,  1010,  1011,  1012,  1013,  1014,     0,
       0,     0,     0,     0,     0,     0,     0,   930,  1015,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1016,     0,     0,     0,  1017,     0,  1018,  1019,
    1020,  1021,     0,  1022,  1023,   497,   931,     0,  1024,     0,
     932,   933,     0,     0,     0,     0,  1025,  1026,   881,   882,
     883,   884,   885,     0,     0,     0,     0,   890,   891,   892,
       0,     0,     0,     0,     0,     0,     0,   893,   894,   895,
     896,   897,   898,   899,   900,     0,   901,   902,   903,   904,
     905,   906,   907,   908,   909,   910,     0,   911,     0,     0,
       0,     0,     0,   913,   914,   915,   916,   917,   918,   919,
       0,     0,     0,     0,   922,   923,     0,     0,     0,   924,
     925,   926,   927,   928,   929,   997,   998,   999,  1000,  1001,
    1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,
    1012,  1013,  1014,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   930,  1015,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1016,     0,     0,     0,
    1017,     0,  1018,  1019,  1020,  1021,     0,  1022,  1023,   497,
     931,     0,  1024,     0,   932,   933,     0,     0,     0,     0,
    1046,  1026,   881,   882,   883,   884,   885,     0,     0,     0,
       0,   890,   891,   892,     0,     0,     0,     0,     0,     0,
       0,   893,   894,   895,   896,   897,   898,   899,   900,     0,
     901,   902,   903,   904,   905,   906,   907,   908,   909,   910,
       0,   911,     0,     0,     0,     0,     0,   913,   914,   915,
     916,   917,   918,   919,     0,     0,     0,     0,   922,   923,
       0,     0,     0,   924,   925,   926,   927,   928,   929,   997,
     998,   999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,
    1008,  1009,  1010,  1011,  1012,  1013,  1014,     0,     0,     0,
       0,     0,     0,     0,     0,   930,  1015,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1016,     0,     0,     0,  1017,     0,  1018,  1019,  1020,  1021,
       0,  1022,  1023,   497,   931,     0,  1024,     0,   932,   933,
       0,     0,     0,     0,  1048,  1026,   881,   882,   883,   884,
     885,     0,     0,     0,     0,   890,   891,   892,     0,     0,
       0,     0,     0,     0,     0,   893,   894,   895,   896,   897,
     898,   899,   900,     0,   901,   902,   903,   904,   905,   906,
     907,   908,   909,   910,     0,   911,     0,     0,     0,     0,
       0,   913,   914,   915,   916,   917,   918,   919,     0,     0,
       0,     0,   922,   923,     0,     0,     0,   924,   925,   926,
     927,   928,   929,   997,   998,   999,  1000,  1001,  1002,  1003,
    1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,  1013,
    1014,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   930,
    1015,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1016,     0,     0,     0,  1017,     0,
    1018,  1019,  1020,  1021,     0,  1022,  1023,   497,   931,     0,
    1024,     0,   932,   933,     0,     0,     0,     0,  1087,  1026,
    1213,     0,   881,   882,   883,   884,   885,   886,   887,   888,
     889,   890,   891,   892,     0,     0,     0,     0,     0,     0,
       0,   893,   894,   895,   896,   897,   898,   899,   900,     0,
     901,   902,   903,   904,   905,   906,   907,   908,   909,   910,
       0,   911,     0,     0,     0,   912,     0,   913,   914,   915,
     916,   917,   918,   919,   920,     0,     0,   921,   922,   923,
       0,     0,     0,   924,   925,   926,   927,   928,   929,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   930,  1015,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1016,     0,
       0,     0,  1017,     0,  1018,  1019,  1020,  1021,     0,  1022,
    1023,  1602,   931,     0,  1024,     0,   932,   933,     0,     0,
       0,     0,  1087,  1026,   881,   882,   883,   884,   885,   886,
     887,   888,   889,   890,   891,   892,     0,     0,     0,     0,
       0,     0,     0,   893,   894,   895,   896,   897,   898,   899,
     900,     0,   901,   902,   903,   904,   905,   906,   907,   908,
     909,   910,     0,   911,     0,     0,     0,   912,     0,   913,
     914,   915,   916,   917,   918,   919,   920,     0,     0,   921,
     922,   923,     0,     0,     0,   924,   925,   926,   927,   928,
     929,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   930,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   931,     0,
       0,     0,   932,   933,     0,     0,   934,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   930,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     931,     0,     0,     0,   932,   933,     0,     0,   934
};

static const yytype_int16 yycheck[] =
{
     218,   187,   401,   221,   217,   843,  1153,  1101,   846,     1,
       1,   849,     1,     1,   852,   988,   295,   990,     1,   992,
       1,   994,   860,   996,  1009,     1,  1011,     1,  1013,   247,
       1,   249,     1,   251,     1,   253,     1,   843,     1,     1,
     846,   316,     1,   849,     1,  1030,   852,   325,     1,     1,
      62,    62,     1,   328,   860,     1,   315,     1,    62,     1,
     315,  1028,   315,   295,   342,  1032,   325,    57,     1,   295,
     315,     1,   325,   328,     1,    56,    57,   336,    61,   338,
     325,   846,   843,   295,   849,   846,     1,   852,   849,     1,
       1,   852,   310,    16,     1,   860,     1,   328,   936,   860,
     331,     1,   320,   321,   322,   323,   324,   325,   326,     1,
       1,     1,     1,   295,     1,   953,     1,   955,     1,   957,
       1,   328,   329,   961,   331,    88,    89,    90,    91,     1,
     936,     1,   295,     1,     1,   353,   354,   355,   537,     1,
       1,     1,   295,     1,     1,     1,     1,   953,     1,   955,
       1,   957,     1,     1,   295,   961,     1,     1,     1,   236,
      56,    57,   295,     1,     1,   871,   872,     1,     1,     1,
      61,     1,   329,   315,   331,   936,    88,    89,    90,    91,
      62,    88,    89,    90,    91,     1,   328,  1025,  1026,     1,
     315,    61,   953,     1,   955,     1,   957,     1,     1,    61,
     961,   343,   336,   328,   338,   936,   331,     1,  1046,   295,
    1048,     1,   336,     1,   338,     1,     1,   435,   436,  1025,
    1026,     1,   953,  1036,   955,     1,   957,     1,   315,     1,
     961,    14,    15,     1,     1,   295,   315,     1,     1,     1,
    1046,   328,  1048,   295,   331,    61,   325,   295,   295,  1087,
    1088,   295,  1225,     1,     1,     1,   295,   336,     1,   338,
     295,  1026,     1,  1101,  1025,  1026,     1,   295,     1,     1,
     295,     1,     1,   328,   329,     1,   331,     1,     1,     1,
       1,  1087,  1088,     1,     1,  1046,     1,  1048,     1,   266,
     267,   268,     1,   843,     1,  1101,   846,     1,  1136,   849,
       1,     1,   852,   325,     1,     1,   295,     1,     1,     1,
     860,     1,  1150,     1,    19,     1,   328,   328,  1156,     1,
     295,   295,     1,   295,   328,     1,  1087,  1088,     1,     1,
    1136,     1,     1,     1,     1,     1,     1,   328,   328,   329,
    1101,   332,   331,     1,  1150,   328,   329,   339,   331,   332,
    1156,   342,   340,   316,   342,   338,     1,  1088,     1,   342,
     341,   332,     1,  1510,   340,   328,   329,   330,   331,   332,
    1101,   342,   339,   342,   339,   843,  1214,   339,   846,   342,
     339,   849,   331,   340,   852,  1150,   936,   340,   340,  1150,
     342,  1156,   860,   337,   340,  1156,   342,   339,   328,   329,
     330,   331,   332,   953,   316,   955,   339,   957,  1214,   316,
    1504,   961,   342,   340,   329,   342,   328,   329,   330,   331,
     332,   328,   329,   330,   331,   332,     1,   339,   295,   340,
     342,   342,   339,   338,   339,   342,     1,   328,   329,   339,
     331,   332,   331,  1428,     1,   341,   328,   339,   329,   339,
    1435,   342,   339,  1214,   339,     1,   339,   329,   328,   329,
    1298,   331,   332,   331,   331,   542,   328,   329,   936,   331,
     332,   870,   342,   329,     1,   331,  1026,     1,   339,   339,
     342,   339,   339,  1214,   339,   953,   339,   955,   339,   957,
     339,   339,  1298,   961,   339,   339,   339,  1335,  1336,  1337,
    1338,   339,   339,  1650,  1342,   339,   339,   339,   280,   339,
    1348,   843,   328,   329,   846,   331,   332,   849,  1331,   331,
     852,   315,   328,   331,   328,   328,   342,   331,   860,  1335,
    1336,  1337,  1338,  1298,   328,   338,  1342,  1298,  1088,   329,
     328,   331,  1348,   329,   338,   331,   331,   295,   328,   329,
     330,  1101,     1,   329,   328,   331,     1,  1025,  1026,   331,
       1,   329,   334,   331,   331,   329,   965,   331,   331,   331,
    1335,  1336,  1337,  1338,  1335,  1336,  1337,  1338,  1046,   295,
    1048,  1342,   329,   329,   331,   331,  1136,  1348,   331,   328,
     329,   330,   331,   332,   329,   328,   331,   329,   331,   331,
    1150,   331,   331,   342,   936,   331,  1156,   331,   331,   331,
     331,  1342,  1585,   331,   331,     1,   331,  1348,   331,  1087,
    1088,   953,   331,   955,   331,   957,     1,   331,   316,   961,
     331,   331,     1,  1101,   331,   331,   315,   331,   331,   331,
     328,   331,   328,   329,   330,   315,   328,   329,   315,   328,
     315,     1,   328,   839,     1,   328,   328,   315,   328,   328,
     328,   328,   328,   328,  1214,  1503,  1504,     1,     1,     1,
     328,   316,   315,     1,     1,     1,   315,     1,     1,     1,
       1,     1,  1150,   328,     1,   328,     1,     1,  1156,   328,
       1,  1090,     1,     1,  1026,  1094,     1,  1503,  1504,     1,
    1538,  1539,  1540,  1541,     1,     1,     1,     1,    62,   295,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,   295,     1,     1,     1,     1,     1,     1,     1,
       1,     1,  1538,  1539,  1540,  1541,     1,     1,     1,     1,
     315,     1,  1503,  1504,   295,   295,  1214,     1,  1298,     1,
     315,     1,     1,   328,     1,     1,  1088,   295,   315,     1,
       1,  1599,     1,   328,     1,     1,     1,     1,     1,  1101,
       1,   328,  1503,  1504,   295,     1,     1,  1538,  1539,  1540,
    1541,     1,   328,     1,     1,  1335,  1336,  1337,  1338,   295,
     295,   315,  1342,  1599,     1,     1,     1,     1,  1348,     1,
       1,   328,     1,     1,   328,     1,     1,  1538,  1539,  1540,
    1541,     1,     1,  1651,     1,     1,  1654,  1655,  1150,     1,
       1,   295,   295,  1025,  1156,     1,   295,  1665,  1666,  1667,
    1298,  1669,  1670,  1671,  1599,   295,   328,   329,  1599,   331,
       1,     1,     1,     1,  1046,  1651,  1048,   295,  1654,  1655,
      21,     1,     1,   295,  1072,    88,    89,    90,    91,  1665,
    1666,  1667,     1,  1669,  1670,  1671,   315,  1335,  1336,  1337,
    1338,   295,     1,  1086,  1342,   328,   329,   295,   331,   328,
    1348,  1094,  1214,   328,     1,  1087,  1651,   328,     1,  1654,
    1651,     1,   295,  1654,  1655,     1,     1,     1,     1,     1,
       1,  1666,  1667,   295,  1665,  1666,  1667,   295,  1669,  1670,
    1671,     1,    88,    89,    90,    91,     1,     1,     1,     1,
     295,  1107,     1,  1109,  1655,  1111,   886,   887,   888,   315,
     295,     1,     1,     1,  1665,     1,     1,  1155,  1669,  1670,
    1671,     1,   328,     1,     1,     1,   315,     1,     1,   295,
     295,     1,   912,  1503,  1504,     1,     1,     1,   295,   328,
     920,   921,   303,   304,   295,   315,  1298,   308,   309,   336,
     295,   338,   295,   295,   328,   336,   315,   338,   328,   303,
     304,   328,   295,   295,   308,   309,   325,    20,  1538,  1539,
    1540,  1541,   295,   328,   328,   328,   328,   336,     0,   338,
     328,   328,   328,  1335,  1336,  1337,  1338,   328,   328,   345,
    1342,   328,   328,   328,   328,   325,  1348,   328,   841,   328,
     328,   340,   845,   328,   328,   848,   328,   295,   851,   295,
     328,   328,   328,   328,   328,  1503,  1504,   328,   328,   328,
     328,   328,   328,   328,   328,   328,   328,   328,   328,  1599,
     328,   328,   328,   328,   328,   328,   328,   328,   328,  1019,
    1020,  1021,     1,   328,   328,   328,   328,   336,   328,   338,
    1538,  1539,  1540,  1541,   328,   315,   328,   328,   328,   328,
     295,   328,   328,   316,  1044,   325,   328,   328,   295,   328,
     328,   328,   328,   328,   328,  1055,   336,   328,   338,   331,
     328,  1651,   328,   328,  1654,  1655,   328,   336,   328,   338,
     328,   328,  1511,   336,   328,  1665,  1666,  1667,   295,  1669,
    1670,  1671,   328,   328,   328,   295,   328,   328,   295,   328,
     328,  1599,   328,   328,   295,   328,   295,   295,   328,   328,
     316,   328,   328,   303,   304,   295,   328,   328,   308,   309,
     310,   311,   312,   313,   303,   304,   305,   295,   295,   308,
     309,   316,   317,   318,   303,   304,   305,   295,   295,   308,
     309,  1503,  1504,  1133,   303,   304,   305,   295,   295,   308,
     309,   295,   295,  1651,   295,   295,  1654,  1655,   295,   295,
     295,   295,   295,   295,   295,   295,   295,  1665,  1666,  1667,
     295,  1669,  1670,  1671,   295,   295,  1538,  1539,  1540,  1541,
     295,   295,   295,   295,   295,   295,   295,    88,    89,    90,
      91,   336,   295,   338,  1442,   295,   295,   295,     1,   295,
     295,  1191,  1192,  1193,   295,   295,   295,   295,   295,   295,
     295,   295,   295,  1203,  1204,   295,   295,   295,   295,   295,
     295,   295,   295,   990,   328,   992,  1216,   994,   336,   996,
     338,   328,  1222,  1223,   336,  1225,   338,  1599,   295,  1229,
    1230,  1231,  1232,  1233,  1234,  1235,   314,   315,   316,   317,
     318,   295,   295,   222,   223,   224,   225,  1247,  1248,  1249,
    1250,  1251,  1252,  1253,   336,   336,   338,   338,    71,    72,
      73,    74,   336,    76,   338,    78,   295,    80,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   295,   295,  1651,
     315,   331,  1654,  1655,   336,   336,   338,   338,   295,   336,
     325,   338,   295,  1665,  1666,  1667,   295,  1669,  1670,  1671,
     336,   336,   338,   338,   336,   295,   338,   295,  1534,   295,
     295,  1537,   295,   295,   295,   329,   328,   295,   295,   295,
     295,  1579,   295,   295,   295,  1325,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     340,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   295,   328,   329,   330,   331,   332,
     328,   329,   330,   331,   332,   316,   339,   295,   295,   342,
     295,   295,   295,   338,   342,   295,   295,   328,   329,   330,
     331,   332,   295,   295,   328,   295,   295,   295,   339,   295,
     295,   342,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,  1225,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   338,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     295,     0,     1,   295,  1514,   295,   295,   295,   328,   295,
    1520,   295,   295,   295,   295,    14,    15,    16,    17,    18,
      19,    20,    21,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   295,   295,   295,   295,   295,   295,   295,    38,
     295,   295,    41,    42,    43,    44,    45,   295,   295,   328,
     328,   328,   328,   328,   328,   328,   328,   328,    57,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   328,   328,   328,   328,  1596,   328,   328,   328,
     328,   340,   328,   328,  1604,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     328,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   328,   328,   328,   336,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   340,   264,   265,   340,   340,   328,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   342,   328,   343,   332,   109,   336,   345,   345,   295,
     295,   295,   328,   292,   293,   294,   335,   328,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   295,   343,   336,   338,   343,   343,   339,   331,   339,
     329,   339,   339,   295,   343,   325,   337,   339,   337,   339,
     338,   325,   339,   339,     1,   344,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,   339,   339,
     339,   337,   340,   345,   336,    22,    23,    24,    25,    26,
      27,    28,    29,   343,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,   343,    42,   343,   345,   340,    46,
     339,    48,    49,    50,    51,    52,    53,    54,    55,   339,
     331,    58,    59,    60,   338,   338,   338,    64,    65,    66,
      67,    68,    69,     1,   338,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,   338,   338,   338,
     338,   338,   325,   339,    22,    23,    24,    25,    26,    27,
      28,    29,   342,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,   340,    42,   340,   340,   340,    46,   263,
      48,    49,    50,    51,    52,    53,    54,    55,   263,   328,
      58,    59,    60,   328,   338,   338,    64,    65,    66,    67,
      68,    69,     1,   329,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,   338,   338,   338,   338,
     338,   295,   295,    22,    23,    24,    25,    26,    27,    28,
      29,   295,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,   295,    42,   341,   338,   342,    46,   336,    48,
      49,    50,    51,    52,    53,    54,    55,   338,   338,    58,
      59,    60,   338,    47,   336,    64,    65,    66,    67,    68,
      69,     1,   338,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,   345,   338,   338,   338,   338,
     338,   338,    22,    23,    24,    25,    26,    27,    28,    29,
     338,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,   338,    42,   338,   338,   338,    46,   338,    48,    49,
      50,    51,    52,    53,    54,    55,   338,   338,    58,    59,
      60,   338,   338,   338,    64,    65,    66,    67,    68,    69,
     338,   338,   338,   280,   338,   338,   338,   338,   338,   338,
     338,   338,   338,   338,   338,   338,   338,   336,   338,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   345,   338,   338,   338,   338,   338,   325,   338,
     338,   329,   329,   343,   336,   331,   333,   334,   331,   336,
     337,   338,   339,   340,   295,   325,   338,   338,   345,   328,
     328,   328,   280,   328,   328,   328,   328,   328,   328,   328,
     328,   328,   328,   328,   328,   325,   342,   317,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   338,   338,   331,   331,   328,   341,   345,   338,   338,
     343,   329,   338,   338,   338,   333,   334,   338,   336,   337,
     338,   339,   340,   338,   338,   338,   338,   345,   338,   338,
     338,   280,   338,   338,   338,   338,   338,   338,   338,   338,
     338,   338,   338,   338,   338,   338,   338,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     345,   345,   345,   338,   338,   338,   343,   343,   195,   965,
     329,   837,   868,   345,   333,   334,   345,   336,   337,   338,
    1193,   340,  1148,   839,  1195,  1195,   345,  1596,  1518,   360,
     280,   361,  1326,  1580,    -1,    -1,    -1,   538,  1604,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   329,
      -1,    -1,    -1,   333,   334,     1,   336,   337,   338,    -1,
     340,    -1,    -1,    -1,    -1,   345,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    38,    -1,    -1,    41,    42,    43,    44,    45,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    57,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   338,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,    -1,    -1,    -1,    -1,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
      -1,    -1,    -1,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   292,   293,   294,    -1,
      -1,    -1,    -1,    -1,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,    -1,    -1,
      -1,    -1,     1,   329,     3,     4,     5,     6,     7,    -1,
      -1,   337,    -1,    12,    13,    14,   338,    -1,   344,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,
      49,    50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,
      59,    60,    -1,    -1,    -1,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,     1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,     1,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    -1,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    -1,    -1,
      -1,    64,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,   280,   281,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    -1,    -1,
      -1,    64,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   315,    -1,    -1,    -1,
     319,    -1,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,    -1,   331,   332,   333,   334,    -1,    -1,    -1,    -1,
     339,   340,    -1,   342,    -1,    -1,    -1,    -1,     1,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,   280,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    -1,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    -1,    -1,
      -1,    64,    65,    66,    67,    68,    69,   329,    -1,    -1,
      -1,   333,   334,    -1,    -1,   337,    -1,    -1,    -1,   341,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   280,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,    -1,    -1,    -1,    -1,    -1,   329,    -1,    -1,    -1,
     333,   334,    -1,    -1,   337,    -1,    -1,     1,   341,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,   280,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    -1,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    -1,    -1,    -1,
      64,    65,    66,    67,    68,    69,   329,    -1,    -1,    -1,
     333,   334,    -1,    -1,   337,    -1,    -1,    -1,   341,    -1,
      -1,     1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    46,   280,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   329,    -1,    -1,    -1,
     333,   334,    -1,    -1,   337,    -1,    -1,     1,   341,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    -1,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    -1,    58,    59,    60,    -1,    -1,    -1,
      64,    65,    66,    67,    68,    69,     1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,   280,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    -1,    -1,    58,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,   329,    -1,    -1,    -1,   333,
     334,    -1,    -1,   337,    -1,    -1,    -1,   341,    -1,    -1,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
     280,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    -1,    -1,    58,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,   329,
      -1,    -1,    -1,   333,   334,    -1,    -1,   337,    -1,    -1,
       1,   341,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    46,   280,    48,    49,    50,
      51,    52,    53,    54,    55,    -1,    -1,    58,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   329,    -1,    -1,    -1,   333,
     334,    -1,    -1,   337,    -1,    -1,    -1,   341,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   280,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   329,    -1,    -1,    -1,   333,   334,
      -1,    -1,   337,    -1,    -1,    -1,   341,    -1,    -1,     1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,   280,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    -1,    58,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,   329,    -1,
      -1,    -1,   333,   334,    -1,    -1,   337,    -1,    -1,     1,
     341,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,   280,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    -1,    58,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,   329,    -1,
      -1,    -1,   333,   334,    -1,    -1,   337,    -1,    -1,     1,
     341,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    -1,    58,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    -1,     1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    46,   280,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    -1,    58,
      59,    60,    -1,    -1,    -1,    64,    65,    66,    67,    68,
      69,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   329,    -1,    -1,
      -1,   333,   334,    -1,    -1,   337,    -1,    -1,     1,   341,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,   280,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    -1,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    -1,    -1,    58,    59,    60,    -1,    -1,
      -1,    64,    65,    66,    67,    68,    69,   329,    -1,    -1,
      -1,   333,   334,    -1,    -1,   337,    -1,    -1,     1,   341,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,   280,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    -1,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    -1,    -1,    58,    59,    60,    -1,    -1,
      -1,    64,    65,    66,    67,    68,    69,   329,    -1,    -1,
      -1,   333,   334,    -1,    -1,   337,    -1,    -1,    -1,   341,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   280,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     329,    -1,    -1,    -1,   333,   334,    -1,    -1,   337,    -1,
      -1,     1,   341,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    46,   280,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    -1,    58,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   329,    -1,    -1,    -1,
     333,   334,    -1,    -1,   337,    -1,    -1,     1,   341,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,   280,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    -1,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    -1,    58,    59,    60,    -1,    -1,    -1,
      64,    65,    66,    67,    68,    69,   329,    -1,    -1,    -1,
     333,   334,    -1,    -1,   337,    -1,    -1,     1,   341,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    -1,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    -1,    58,    59,    60,    -1,    -1,    -1,
      64,    65,    66,    67,    68,    69,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     280,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   329,
      -1,    -1,    -1,   333,   334,    -1,    -1,   337,    -1,    -1,
       1,   341,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,   280,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    -1,    -1,   329,    -1,    -1,    -1,   333,
     334,    -1,    -1,   337,    -1,    -1,    -1,   341,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,   280,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    -1,    -1,    58,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,   329,    -1,    -1,    -1,   333,
     334,    -1,    -1,   337,    -1,    -1,     1,   341,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,   280,
     281,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   315,   316,    -1,    -1,   319,    -1,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,    -1,   333,   334,    -1,    -1,    -1,    -1,   339,   340,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,   280,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   329,    -1,    -1,    -1,   333,   334,
      -1,    -1,   337,    -1,    -1,   340,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   280,   281,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     315,   316,    -1,    -1,   319,    -1,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,    -1,   333,   334,
      -1,    -1,    -1,    -1,   339,   340,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,   280,
     281,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   315,    -1,    -1,    -1,   319,    -1,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,    -1,   333,   334,    -1,    -1,    -1,   338,   339,   340,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   280,   281,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     315,    -1,    -1,    -1,   319,    -1,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,    -1,   333,   334,
      -1,    -1,    -1,   338,   339,   340,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,   280,
     281,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   315,    -1,    -1,    -1,   319,    -1,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,    -1,   333,   334,    -1,    -1,    -1,   338,   339,   340,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   280,   281,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     315,    -1,   317,    -1,   319,    -1,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,    -1,   333,   334,
      -1,    -1,    -1,    -1,   339,   340,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,   280,
     281,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   315,    -1,    -1,    -1,   319,    -1,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,    -1,   333,   334,    -1,    -1,    -1,    -1,   339,   340,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   280,   281,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     315,    -1,    -1,    -1,   319,    -1,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,    -1,   333,   334,
      -1,    -1,    -1,    -1,   339,   340,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,   280,
     281,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   315,    -1,    -1,    -1,   319,    -1,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,    -1,   333,   334,    -1,    -1,    -1,    -1,   339,   340,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   280,   281,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     315,    -1,    -1,    -1,   319,    -1,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,    -1,   333,   334,
      -1,    -1,    -1,    -1,   339,   340,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,   280,
     281,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   315,    -1,    -1,    -1,   319,    -1,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,    -1,   333,   334,    -1,    -1,    -1,    -1,   339,   340,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   280,   281,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     315,    -1,    -1,    -1,   319,    -1,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,    -1,   333,   334,
      -1,    -1,    -1,    -1,   339,   340,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,   280,
     281,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   315,    -1,    -1,    -1,   319,    -1,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,    -1,   333,   334,    -1,    -1,    -1,    -1,   339,   340,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   280,   281,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     315,    -1,    -1,    -1,   319,    -1,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,    -1,   333,   334,
      -1,    -1,    -1,    -1,   339,   340,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,   280,
     281,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   315,    -1,    -1,    -1,   319,    -1,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,    -1,   333,   334,    -1,    -1,    -1,    -1,   339,   340,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   280,   281,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     315,    -1,    -1,    -1,   319,    -1,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,    -1,   333,   334,
      -1,    -1,    -1,    -1,   339,   340,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,   280,
     281,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   315,    -1,    -1,    -1,   319,    -1,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,    -1,   333,   334,    -1,    -1,    -1,    -1,   339,   340,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   280,   281,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     315,    -1,    -1,    -1,   319,    -1,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,    -1,   333,   334,
      -1,    -1,    -1,    -1,   339,   340,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,   280,
     281,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   315,    -1,    -1,    -1,   319,    -1,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,    -1,   333,   334,    -1,    -1,    -1,    -1,   339,   340,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   280,   281,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     315,    -1,    -1,    -1,   319,    -1,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,    -1,   333,   334,
      -1,    -1,    -1,    -1,   339,   340,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,   280,
     281,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   315,    -1,    -1,    -1,   319,    -1,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,    -1,   333,   334,    -1,    -1,    -1,    -1,   339,   340,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   280,   281,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     315,    -1,    -1,    -1,   319,    -1,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,    -1,   333,   334,
      -1,    -1,    -1,    -1,   339,   340,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,   280,
     281,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   315,    -1,    -1,    -1,   319,    -1,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,    -1,   333,   334,    -1,    -1,    -1,    -1,   339,   340,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   280,   281,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     315,    -1,    -1,    -1,   319,    -1,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,    -1,   333,   334,
      -1,    -1,    -1,    -1,   339,   340,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,   280,
     281,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   315,    -1,    -1,    -1,   319,    -1,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,    -1,   333,   334,    -1,    -1,    -1,    -1,   339,   340,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   280,   281,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     315,    -1,    -1,    -1,   319,    -1,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,    -1,   333,   334,
      -1,    -1,    -1,    -1,   339,   340,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,   280,
     281,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   315,    -1,    -1,    -1,   319,    -1,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,    -1,   333,   334,    -1,    -1,    -1,    -1,   339,   340,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   280,   281,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     315,    -1,    -1,    -1,   319,    -1,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,    -1,   333,   334,
      -1,    -1,    -1,    -1,   339,   340,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,   280,
     281,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   315,    -1,    -1,    -1,   319,    -1,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,    -1,   333,   334,    -1,    -1,    -1,    -1,   339,   340,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   280,   281,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     315,    -1,    -1,    -1,   319,    -1,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,    -1,   333,   334,
      -1,    -1,    -1,    -1,   339,   340,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    -1,
      -1,    58,    59,    60,    -1,    -1,    -1,    64,    65,    66,
      67,    68,    69,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   280,
     281,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   315,    -1,    -1,    -1,   319,    -1,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,    -1,   333,   334,    -1,    -1,    -1,    -1,   339,   340,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,
      53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,
      -1,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   280,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   329,    -1,    -1,    -1,   333,   334,    -1,    -1,
     337,    -1,    -1,   340,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,
      49,    50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,
      59,    60,    -1,    -1,    -1,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   280,   281,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   315,    -1,    -1,    -1,   319,    -1,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,    -1,   331,    -1,
     333,   334,    -1,    -1,    -1,    -1,   339,   340,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   280,   281,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   315,    -1,    -1,    -1,
     319,    -1,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,    -1,   331,    -1,   333,   334,    -1,    -1,    -1,    -1,
     339,   340,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   280,   281,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     315,    -1,    -1,    -1,   319,    -1,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,    -1,   333,   334,
      -1,    -1,    -1,    -1,   339,   340,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,
      -1,    48,    49,    50,    51,    52,    53,    54,    -1,    -1,
      -1,    -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   280,
     281,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   315,    -1,    -1,    -1,   319,    -1,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,    -1,   333,   334,    -1,    -1,    -1,    -1,   339,   340,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    -1,    -1,    58,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   280,   281,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   315,    -1,
      -1,    -1,   319,    -1,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,    -1,   331,    -1,   333,   334,    -1,    -1,
      -1,    -1,   339,   340,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    -1,    58,
      59,    60,    -1,    -1,    -1,    64,    65,    66,    67,    68,
      69,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   280,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   329,    -1,
      -1,    -1,   333,   334,    -1,    -1,   337,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   280,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     329,    -1,    -1,    -1,   333,   334,    -1,    -1,   337
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     1,    17,    18,    38,    41,    42,    43,    44,    45,
      57,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   264,   265,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   292,   293,
     294,   329,   337,   344,   347,   348,   349,   350,   351,   352,
     353,   354,   365,   369,   372,   373,   375,   376,   386,   387,
     396,   295,     1,   342,     1,   295,   295,   295,   295,   295,
     295,   295,   295,   295,   295,   295,   295,   295,   295,   295,
     295,   295,   295,   295,   295,   295,   295,   295,   295,   295,
       1,   295,     1,   295,     1,   295,     1,   295,     1,   295,
       1,   295,     1,   295,     1,   295,     1,   295,     1,   295,
       1,   295,     1,   295,     1,   295,     1,   295,     1,   295,
       1,   295,     1,   295,     1,   295,     1,   295,     1,   295,
       1,   295,     1,   295,     1,   295,     1,   295,     1,   295,
       1,   295,     1,   295,     1,   295,     1,   295,     1,   295,
       1,   295,     1,   295,     1,   295,     1,   295,     1,   295,
     295,   295,   295,   295,   295,   295,   295,   295,   295,   295,
     295,   295,   295,   295,   295,   295,   295,   295,   295,   295,
     295,   295,     1,   331,     1,   295,   331,     1,   339,     1,
     295,   331,   295,   295,   295,   295,   295,   295,   295,   295,
     295,   295,   295,   295,   295,   295,   295,   295,   295,   295,
     295,   295,   295,   295,     1,   295,     1,   295,     1,   295,
       1,   295,   295,   295,   295,   295,   295,   295,   295,   295,
     295,   295,   295,   295,   295,   295,   295,   295,   295,   295,
     295,   295,   295,   295,   295,   295,   295,   295,   295,   295,
     295,   295,   295,   295,   295,   295,   295,   295,   295,   295,
     295,   295,   295,   295,   295,   295,   295,   295,   295,     1,
     295,   295,   295,   295,   295,   295,   295,   295,   295,   295,
     295,   295,   325,   295,   295,   295,   295,   295,   295,   295,
     295,   295,     1,   329,   331,   366,   367,   368,     1,   368,
     370,   371,     1,   331,     1,   331,     1,   331,     0,     1,
     349,    14,    15,   382,   383,    16,   384,   385,    19,   390,
     391,    20,   392,   393,    21,   394,   395,   325,   342,   340,
     328,   329,   331,   381,     1,   328,     1,   328,     1,    88,
      89,    90,    91,   316,   358,     1,   315,   328,   364,     1,
     328,     1,   328,     1,   364,     1,   328,     1,   328,     1,
     328,     1,   328,     1,   329,     1,   331,     1,   328,     1,
     331,     1,   328,     1,   331,     1,   331,     1,   331,     1,
     331,     1,   328,   329,   330,   331,   332,   339,   342,   355,
     357,   358,   362,   363,   377,   378,   379,   380,   410,   411,
       1,   363,     1,   328,     1,   328,     1,   328,   328,   328,
     328,   364,   364,   364,   364,   328,   328,   328,   328,   328,
     328,   328,   328,   328,   328,   328,   328,   328,   328,   328,
     328,   328,   328,   328,   328,   328,   328,   328,   328,   328,
     328,   328,   328,     1,   364,     1,   328,   331,     1,   328,
       1,   328,     1,   328,     1,   328,     1,   328,     1,   328,
       1,   328,     1,   364,     1,   364,     1,   364,     1,   364,
       1,   364,     1,   364,     1,   364,     1,   328,     1,   328,
       1,   331,     1,   331,     1,   328,     1,   331,   331,     1,
     331,     1,   328,     1,   328,     1,   329,   331,     1,   329,
     331,     1,   329,   331,     1,   329,   331,     1,   329,   331,
       1,   328,     1,   328,     1,   328,     1,   328,     1,   364,
       1,   364,     1,   364,     1,   329,   331,     1,   328,     1,
     328,     1,   328,     1,   328,   378,     1,   380,     1,   328,
       1,   328,   328,   328,   328,   328,     1,   328,     1,   328,
       1,   328,     1,   328,     1,   328,     1,   328,     1,   328,
       1,   328,     1,   328,     1,   328,     1,   328,     1,   328,
       1,   328,     1,   328,     1,   328,     1,   328,     1,   328,
       1,   328,     1,   222,   223,   224,   225,     1,   328,     1,
     328,     1,   328,     1,   328,     1,   331,     1,   331,     1,
     331,     1,   328,     1,   328,     1,   328,     1,   355,     1,
     328,     1,   328,     1,   328,     1,   328,     1,   328,     1,
     328,     1,   328,     1,   328,     1,   328,     1,   328,     1,
     328,     1,   328,     1,   328,     1,   328,     1,   328,     1,
     329,   331,     1,   328,   329,   328,     1,   328,     1,   328,
       1,   328,     1,   328,     1,   328,     1,   328,     1,   328,
       1,   331,     1,   328,     1,   328,     1,   328,   266,   267,
     268,   328,   328,     1,   364,     1,   364,     1,   328,     1,
     328,     1,   328,     1,   328,     1,   328,   336,   345,   336,
       1,   342,     1,   340,     1,   342,   340,     1,   342,   340,
       1,   342,   340,     1,   342,    57,   328,   329,   374,   328,
     388,   343,   328,   325,   355,   356,   379,   345,   345,   363,
     109,   315,   325,   336,   295,   295,   295,   366,   328,   370,
     381,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    22,    23,    24,    25,    26,    27,    28,
      29,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    42,    46,    48,    49,    50,    51,    52,    53,    54,
      55,    58,    59,    60,    64,    65,    66,    67,    68,    69,
     280,   329,   333,   334,   337,   412,   414,   415,   416,   420,
     421,   429,   430,   432,   433,   436,   437,   439,   443,   444,
     445,   449,   381,   414,   381,   414,   381,   414,   335,   295,
     343,   414,     1,   389,   328,   336,   338,   343,     1,   316,
     328,   360,   357,   355,     1,   328,   410,     1,   410,   331,
       1,   331,     1,   331,     1,   331,   343,     1,   339,     1,
     339,     1,   339,     1,   339,     1,   339,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,   281,   315,   319,   321,   322,
     323,   324,   326,   327,   331,   339,   340,   364,   402,   403,
     404,   405,   406,   407,   412,   424,   429,   430,   431,   432,
     434,   436,   437,   440,   441,   442,   339,   442,   339,   442,
       1,   339,     1,   339,     1,   339,   339,     1,   339,     1,
     339,     1,   339,     1,   339,     1,   339,     1,   339,     1,
     339,     1,   339,   339,     1,   339,     1,   339,     1,   339,
       1,   339,   339,   339,   339,   339,   339,   339,   442,     1,
     339,     1,   339,     1,   339,   339,   339,   339,   339,     1,
     442,   442,     1,   339,     1,   339,     1,   339,     1,   339,
       1,   339,     1,   446,     1,   337,     1,   341,   415,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   329,   426,
     427,   428,   295,   438,   337,     1,   339,   337,   343,   341,
     343,   341,   343,   341,   343,     1,   328,   331,   325,   341,
     340,   325,   356,   345,   345,   336,   340,     1,    61,   329,
     331,   338,   377,   409,     1,    61,   331,   377,   409,     1,
      61,   331,   377,   409,     1,    61,   331,   377,   409,     1,
      61,   331,   377,   409,     1,   303,   304,   305,   308,   309,
     397,   399,   397,   397,     1,   397,   425,     1,   442,     1,
     442,     1,   442,   339,   339,     1,   338,   430,   432,   436,
     437,   442,   443,     1,   414,     1,   399,     1,   310,   311,
     312,   313,   397,   398,     1,   399,   428,     1,   442,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   400,   401,   338,   338,     1,   328,   331,     1,
     331,     1,   329,   442,   331,     1,   331,     1,   331,     1,
     331,     1,   331,     1,   328,     1,   328,   338,     1,   338,
     364,   338,     1,   331,     1,   331,     1,   331,     1,   331,
     338,   338,   338,     1,   328,   338,     1,   358,   340,   413,
     415,     1,   355,     1,   328,     1,   355,   358,   361,   338,
     338,   338,   338,   340,   413,     1,   331,     1,   331,   328,
     368,   328,   368,   328,   368,   339,   325,   342,   442,     1,
     331,   429,   430,   435,   437,   340,   340,   340,   340,   263,
     263,   374,   414,   328,   360,   328,   331,   364,   414,   338,
     336,   338,   336,   338,   336,   338,   315,   325,   336,   338,
     338,   336,   338,   336,   338,   336,   338,   336,   338,   338,
     336,   338,   336,   338,   336,   338,   336,   338,   338,   336,
     338,   336,   338,   336,   338,   336,   338,   338,   336,   338,
     336,   338,   336,   338,   336,   338,     1,   329,   442,     1,
      88,    89,    90,    91,    92,    93,   316,   359,   442,     1,
     359,   442,     1,   402,   406,   329,   422,   423,     1,   442,
       1,   442,   338,   338,   338,   341,   341,     1,    86,   442,
       1,   442,     1,   442,     1,    86,   328,   329,   377,   408,
     409,   442,   342,     1,   442,     1,   442,     1,   442,     1,
     442,   442,   442,   442,     1,   442,     1,   442,     1,   442,
       1,   442,     1,   442,     1,   442,     1,   442,   338,   336,
     338,   338,   336,   338,   338,   338,   338,   338,   338,   338,
     338,   338,   338,   338,   338,   338,   338,   338,   338,   338,
     338,   338,   338,   338,   338,   338,   338,   338,   338,   338,
     338,   338,   338,   414,    47,   338,   338,   338,   338,   338,
     345,   345,   338,     1,    56,    57,   341,   418,   419,   338,
     336,   338,   338,   338,   338,   338,   338,   338,   338,   442,
     447,   448,   427,   343,   336,   338,   428,   336,   414,   414,
     414,   414,   331,   331,   295,   341,   325,   338,   338,   341,
      62,   328,   328,   328,     1,   329,     1,   329,   328,    62,
     328,   328,   328,   328,    62,   328,   328,   328,   328,    62,
     328,   328,   328,   328,    62,   328,   328,   328,   328,   342,
     325,   338,   338,   338,   338,   317,   364,   331,   331,   341,
     413,     1,   360,   355,   341,     1,   317,   417,   442,   345,
     341,   418,   328,   442,   336,   338,   368,     1,   368,   341,
     341,   341,   341,   328,   331,   328,   338,   338,   338,   338,
     338,   338,   338,   338,   338,   338,   338,   338,   338,   338,
     338,   338,   338,   338,   338,   338,   338,   338,   338,   338,
     338,   331,   364,   422,     1,   328,   377,   343,   338,   338,
     345,   345,     1,   417,   345,   414,   338,   338,   448,   338,
     338,   338,   343,   343,   360,   414,   345,   345,     1,   414,
     414,   414
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   346,   347,   348,   348,   348,   349,   349,   349,   349,
     349,   350,   349,   351,   349,   349,   352,   349,   353,   349,
     354,   349,   349,   349,   355,   355,   355,   356,   356,   357,
     357,   358,   358,   358,   358,   358,   359,   359,   359,   359,
     359,   359,   359,   360,   360,   361,   361,   361,   361,   361,
     362,   362,   362,   362,   362,   363,   363,   364,   364,   365,
     365,   366,   366,   367,   367,   368,   368,   369,   369,   370,
     370,   371,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   373,   373,   374,   374,   374,   375,   375,   375,   375,
     375,   375,   375,   376,   376,   376,   376,   376,   376,   376,
     376,   376,   376,   376,   376,   376,   377,   377,   378,   379,
     380,   380,   381,   381,   381,   382,   382,   383,   383,   383,
     383,   384,   385,   385,   385,   386,   386,   388,   387,   387,
     387,   389,   387,   387,   390,   391,   391,   391,   392,   393,
     393,   393,   394,   395,   395,   396,   396,   396,   396,   396,
     396,   397,   397,   397,   397,   398,   398,   398,   398,   399,
     399,   400,   400,   400,   400,   400,   400,   400,   401,   401,
     401,   401,   402,   402,   402,   403,   403,   403,   404,   404,
     404,   404,   404,   405,   405,   406,   406,   406,   407,   407,
     407,   407,   407,   407,   407,   407,   407,   407,   407,   407,
     407,   407,   407,   407,   407,   407,   407,   407,   407,   407,
     407,   407,   407,   407,   407,   407,   407,   408,   408,   408,
     408,   409,   409,   409,   409,   409,   410,   410,   410,   411,
     411,   411,   411,   411,   412,   413,   413,   414,   414,   414,
     415,   415,   415,   415,   415,   415,   415,   415,   416,   416,
     417,   418,   418,   418,   418,   418,   418,   418,   418,   418,
     418,   418,   419,   419,   420,   420,   420,   420,   421,   422,
     422,   422,   423,   423,   425,   424,   426,   426,   426,   426,
     426,   426,   426,   426,   426,   427,   428,   428,   429,   430,
     431,   432,   433,   433,   434,   434,   434,   435,   435,   435,
     436,   437,   438,   439,   439,   439,   440,   440,   440,   440,
     440,   440,   440,   440,   440,   440,   440,   440,   441,   441,
     441,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     443,   444,   444,   444,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   446,
     445,   445,   447,   447,   447,   448,   449,   449,   449,   449,
     449,   449,   449,   449,   449,   449
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     1,     2,     1,     1,     1,     1,
       1,     0,     2,     0,     2,     1,     0,     2,     0,     2,
       0,     2,     1,     1,     1,     1,     1,     1,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     5,     3,
       1,     3,     3,     5,     3,     1,     2,     1,     2,     2,
       2,     1,     3,     1,     3,     1,     1,     2,     2,     1,
       3,     1,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     3,     2,     3,     2,     3,     2,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     7,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     5,     5,     5,     5,     5,
       5,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     1,
       2,     1,     1,     1,     1,     1,     5,     5,     7,     7,
       5,     8,     8,     2,     2,     2,     2,     3,     3,     8,
       8,     2,     2,     2,     3,     3,     1,     1,     7,     1,
       1,     3,     1,     1,     1,     1,     1,     4,     7,     2,
       2,     1,     4,     7,     2,     1,     1,     0,     5,     2,
       2,     0,     8,     5,     1,     4,     7,     2,     1,     4,
       7,     2,     1,     7,     2,     2,     2,     2,     2,     2,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     3,
       3,     2,     3,     3,     3,     2,     3,     3,     3,     3,
       2,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     3,     3,     3,     2,     3,     3,     1,
       3,     1,     3,     3,     3,     3,     1,     1,     1,     1,
       3,     3,     3,     3,     1,     1,     3,     2,     1,     2,
       2,     1,     1,     1,     2,     2,     1,     2,     3,     5,
       1,     4,     5,     3,     4,     3,     2,     4,     5,     3,
       4,     4,     2,     1,     5,     4,     2,     5,     3,     1,
       4,     4,     3,     1,     0,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     1,     2,
       5,     4,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     3,     3,     3,     1,     1,
       1,     1,     2,     2,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       4,     4,     2,     2,     2,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     4,     4,     2,
       3,     1,     1,     1,     3,     4,     4,     4,     6,     6,
       6,     6,     6,     4,     2,     4,     4,     4,     4,     6,
       6,     6,     6,     6,     4,     2,     4,     4,     4,     4,
       6,     6,     6,     6,     6,     4,     2,     4,     4,     4,
       4,     6,     6,     6,     6,     6,     4,     2,     4,     4,
       4,     4,     6,     6,     6,     6,     6,     4,     2,     4,
       4,     6,     2,     4,     4,     4,     2,     4,     4,     2,
       4,     4,     2,     6,     6,     6,     4,     2,     6,     2,
       4,     4,     4,     2,     4,     4,     4,     2,     4,     4,
       2,     4,     4,     2,     4,     4,     2,     4,     3,     2,
       4,     3,     2,     4,     3,     4,     2,     4,     4,     2,
       4,     4,     2,     4,     4,     2,     4,     4,     2,     4,
       4,     2,     4,     3,     1,     3,     1,     3,     1,     4,
       3,     1,     4,     4,     4,     4,     4,     2,     4,     4,
       2,     4,     4,     2,     3,     1,     3,     1,     3,     1,
       3,     1,     6,     6,     2,     4,     4,     2,     4,     0,
       5,     2,     0,     3,     1,     1,     3,     2,     1,     3,
       2,     1,     1,     3,     2,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
#line 623 "core/cfg.y" /* yacc.c:1646  */
    {}
#line 4980 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 4:
#line 624 "core/cfg.y" /* yacc.c:1646  */
    {}
#line 4986 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 5:
#line 625 "core/cfg.y" /* yacc.c:1646  */
    { yyerror(""); YYABORT;}
#line 4992 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 633 "core/cfg.y" /* yacc.c:1646  */
    {rt=REQUEST_ROUTE;}
#line 4998 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 634 "core/cfg.y" /* yacc.c:1646  */
    {rt=FAILURE_ROUTE;}
#line 5004 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 636 "core/cfg.y" /* yacc.c:1646  */
    {rt=BRANCH_ROUTE;}
#line 5010 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 637 "core/cfg.y" /* yacc.c:1646  */
    {rt=ONSEND_ROUTE;}
#line 5016 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 638 "core/cfg.y" /* yacc.c:1646  */
    {rt=EVENT_ROUTE;}
#line 5022 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 643 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].ipaddr)){
			tmp=ip_addr2a((yyvsp[0].ipaddr));
			if (tmp==0) {
				LM_CRIT("cfg. parser: bad ip address.\n");
				(yyval.strval)=0;
			} else {
				(yyval.strval)=pkg_malloc(strlen(tmp)+1);
				if ((yyval.strval)==0) {
					PKG_MEM_CRITICAL;
				} else {
					strncpy((yyval.strval), tmp, strlen(tmp)+1);
				}
			}
		}
	}
#line 5043 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 659 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
		if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
		} else {
				strncpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
		}
	}
#line 5056 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 667 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].strval)){
			(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
					PKG_MEM_CRITICAL;
			} else {
					strncpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
			}
		}
	}
#line 5071 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 681 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.name_l)=mk_name_lst((yyvsp[0].strval), SI_IS_MHOMED); }
#line 5077 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 682 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.name_l)=mk_name_lst((yyvsp[-2].strval), SI_IS_MHOMED);
										if ((yyval.name_l)) (yyval.name_l)->next=(yyvsp[0].name_l);
									}
#line 5085 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 688 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.name_l)=(yyvsp[-1].name_l); }
#line 5091 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 689 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.name_l)=mk_name_lst((yyvsp[0].strval), 0); }
#line 5097 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 693 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_UDP; }
#line 5103 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 694 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_TCP; }
#line 5109 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 695 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_TLS; }
#line 5115 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 696 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_SCTP; }
#line 5121 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 697 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=0; }
#line 5127 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 700 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_UDP; }
#line 5133 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 701 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_TCP; }
#line 5139 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 702 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_TLS; }
#line 5145 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 703 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_SCTP; }
#line 5151 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 704 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_WS; }
#line 5157 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 705 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_WSS; }
#line 5163 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 706 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=0; }
#line 5169 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 709 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=(yyvsp[0].intval); }
#line 5175 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 710 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=0; }
#line 5181 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 713 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id((yyvsp[0].strval), 0, 0); }
#line 5187 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 714 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id((yyvsp[-2].strval), 0, (yyvsp[0].intval)); }
#line 5193 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 715 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id((yyvsp[0].strval), (yyvsp[-2].intval), 0); }
#line 5199 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 716 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id((yyvsp[-2].strval), (yyvsp[-4].intval), (yyvsp[0].intval));}
#line 5205 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 717 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=0; yyerror("port number expected"); }
#line 5211 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 721 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id2((yyvsp[0].name_l), 0, 0); }
#line 5217 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 722 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id2((yyvsp[-2].name_l), 0, (yyvsp[0].intval)); }
#line 5223 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 723 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id2((yyvsp[0].name_l), (yyvsp[-2].intval), 0); }
#line 5229 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 724 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id2((yyvsp[-2].name_l), (yyvsp[-4].intval), (yyvsp[0].intval));}
#line 5235 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 725 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=0; yyerror("port number expected"); }
#line 5241 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 729 "core/cfg.y" /* yacc.c:1646  */
    {  (yyval.sockid)=(yyvsp[0].sockid) ; }
#line 5247 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 730 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=(yyvsp[-1].sockid);  if ((yyval.sockid)) (yyval.sockid)->next=(yyvsp[0].sockid); }
#line 5253 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 734 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=-(yyvsp[0].intval); }
#line 5259 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 738 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("flag list expected\n"); }
#line 5265 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 744 "core/cfg.y" /* yacc.c:1646  */
    { if (register_flag((yyvsp[0].strval),-1)<0)
								yyerror("register flag failed");
						}
#line 5273 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 747 "core/cfg.y" /* yacc.c:1646  */
    {
						if (register_flag((yyvsp[-2].strval), (yyvsp[0].intval))<0)
								yyerror("register flag failed");
										}
#line 5282 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 753 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=(yyvsp[0].strval); }
#line 5288 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 754 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=(yyvsp[0].strval); }
#line 5294 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 759 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("avpflag list expected\n"); }
#line 5300 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 766 "core/cfg.y" /* yacc.c:1646  */
    {
		if (register_avpflag((yyvsp[0].strval))==0)
			yyerror("cannot declare avpflag");
	}
#line 5309 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 772 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.debug=(yyvsp[0].intval); }
#line 5315 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 773 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 5321 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 774 "core/cfg.y" /* yacc.c:1646  */
    { dont_fork= ! (yyvsp[0].intval); }
#line 5327 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 775 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5333 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 776 "core/cfg.y" /* yacc.c:1646  */
    { set_fork_delay((yyvsp[0].intval)); }
#line 5339 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 777 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5345 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 778 "core/cfg.y" /* yacc.c:1646  */
    { set_modinit_delay((yyvsp[0].intval)); }
#line 5351 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 779 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5357 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 780 "core/cfg.y" /* yacc.c:1646  */
    { if (!config_check)  /* if set from cmd line, don't overwrite from yyparse()*/
					if(log_stderr == 0) log_stderr=(yyvsp[0].intval);
				   }
#line 5365 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 783 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5371 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 784 "core/cfg.y" /* yacc.c:1646  */
    {
		if ( (i_tmp=str2facility((yyvsp[0].strval)))==-1)
			yyerror("bad facility (see syslog(3) man page)");
		if (!config_check)
			default_core_cfg.log_facility=i_tmp;
	}
#line 5382 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 790 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("ID expected"); }
#line 5388 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 791 "core/cfg.y" /* yacc.c:1646  */
    { log_name=(yyvsp[0].strval); }
#line 5394 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 792 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5400 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 793 "core/cfg.y" /* yacc.c:1646  */
    { log_color=(yyvsp[0].intval); }
#line 5406 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 794 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5412 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 795 "core/cfg.y" /* yacc.c:1646  */
    { log_prefix_fmt=(yyvsp[0].strval); }
#line 5418 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 796 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5424 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 797 "core/cfg.y" /* yacc.c:1646  */
    { log_prefix_mode=(yyvsp[0].intval); }
#line 5430 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 798 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5436 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 799 "core/cfg.y" /* yacc.c:1646  */
    { _km_log_engine_type=(yyvsp[0].strval); }
#line 5442 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 800 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5448 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 801 "core/cfg.y" /* yacc.c:1646  */
    { _km_log_engine_data=(yyvsp[0].strval); }
#line 5454 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 802 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5460 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 803 "core/cfg.y" /* yacc.c:1646  */
    { _ksr_xavp_via_params.s=(yyvsp[0].strval);
			_ksr_xavp_via_params.len=strlen((yyvsp[0].strval));
		}
#line 5468 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 806 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5474 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 807 "core/cfg.y" /* yacc.c:1646  */
    { _ksr_xavp_via_params.s=(yyvsp[0].strval);
			_ksr_xavp_via_fields.len=strlen((yyvsp[0].strval));
		}
#line 5482 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 810 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5488 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 811 "core/cfg.y" /* yacc.c:1646  */
    { received_dns|= ((yyvsp[0].intval))?DO_DNS:0; }
#line 5494 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 812 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5500 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 813 "core/cfg.y" /* yacc.c:1646  */
    { received_dns|= ((yyvsp[0].intval))?DO_REV_DNS:0; }
#line 5506 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 814 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5512 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 815 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_try_ipv6=(yyvsp[0].intval); }
#line 5518 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 816 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5524 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 817 "core/cfg.y" /* yacc.c:1646  */
    { IF_NAPTR(default_core_cfg.dns_try_naptr=(yyvsp[0].intval)); }
#line 5530 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 818 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5536 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 819 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_FAILOVER(default_core_cfg.dns_srv_lb=(yyvsp[0].intval)); }
#line 5542 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 820 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5548 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 821 "core/cfg.y" /* yacc.c:1646  */
    { IF_NAPTR(default_core_cfg.dns_udp_pref=(yyvsp[0].intval));}
#line 5554 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 822 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5560 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 823 "core/cfg.y" /* yacc.c:1646  */
    { IF_NAPTR(default_core_cfg.dns_tcp_pref=(yyvsp[0].intval));}
#line 5566 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 824 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5572 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 825 "core/cfg.y" /* yacc.c:1646  */
    { IF_NAPTR(default_core_cfg.dns_tls_pref=(yyvsp[0].intval));}
#line 5578 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 826 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5584 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 827 "core/cfg.y" /* yacc.c:1646  */
    {
								IF_NAPTR(default_core_cfg.dns_sctp_pref=(yyvsp[0].intval)); }
#line 5591 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 829 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5597 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 830 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_retr_time=(yyvsp[0].intval); }
#line 5603 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 831 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5609 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 832 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_slow_query_ms=(yyvsp[0].intval); }
#line 5615 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 833 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5621 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 834 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_retr_no=(yyvsp[0].intval); }
#line 5627 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 835 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5633 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 836 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_servers_no=(yyvsp[0].intval); }
#line 5639 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 837 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5645 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 838 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_search_list=(yyvsp[0].intval); }
#line 5651 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 839 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5657 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 840 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_search_fmatch=(yyvsp[0].intval); }
#line 5663 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 841 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5669 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 842 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_naptr_ignore_rfc=(yyvsp[0].intval); }
#line 5675 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 843 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5681 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 844 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(dns_cache_init=(yyvsp[0].intval)); }
#line 5687 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 845 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5693 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 846 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.use_dns_cache=(yyvsp[0].intval)); }
#line 5699 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 847 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5705 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 848 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_FAILOVER(default_core_cfg.use_dns_failover=(yyvsp[0].intval));}
#line 5711 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 849 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5717 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 850 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_flags=(yyvsp[0].intval)); }
#line 5723 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 851 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5729 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 852 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_neg_cache_ttl=(yyvsp[0].intval)); }
#line 5735 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 853 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5741 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 854 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_max_ttl=(yyvsp[0].intval)); }
#line 5747 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 855 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5753 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 856 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_min_ttl=(yyvsp[0].intval)); }
#line 5759 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 857 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5765 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 858 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_max_mem=(yyvsp[0].intval)); }
#line 5771 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 859 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5777 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 860 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(dns_timer_interval=(yyvsp[0].intval)); }
#line 5783 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 861 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5789 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 862 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_del_nonexp=(yyvsp[0].intval)); }
#line 5795 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 863 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5801 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 152:
#line 864 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_rec_pref=(yyvsp[0].intval)); }
#line 5807 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 153:
#line 865 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5813 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 866 "core/cfg.y" /* yacc.c:1646  */
    {IF_AUTO_BIND_IPV6(auto_bind_ipv6 = (yyvsp[0].intval));}
#line 5819 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 867 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5825 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 868 "core/cfg.y" /* yacc.c:1646  */
    { IF_DST_BLACKLIST(dst_blacklist_init=(yyvsp[0].intval)); }
#line 5831 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 869 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5837 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 870 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLACKLIST(default_core_cfg.use_dst_blacklist=(yyvsp[0].intval));
	}
#line 5845 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 873 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5851 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 160:
#line 874 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_max_mem=(yyvsp[0].intval));
	}
#line 5859 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 877 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5865 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 162:
#line 878 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_timeout=(yyvsp[0].intval));
	}
#line 5873 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 881 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5879 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 882 "core/cfg.y" /* yacc.c:1646  */
    { IF_DST_BLACKLIST(blst_timer_interval=(yyvsp[0].intval));}
#line 5885 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 165:
#line 883 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5891 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 166:
#line 884 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_udp_imask=(yyvsp[0].intval));
	}
#line 5899 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 887 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number(flags) expected"); }
#line 5905 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 888 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_tcp_imask=(yyvsp[0].intval));
	}
#line 5913 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 169:
#line 891 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number(flags) expected"); }
#line 5919 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 892 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_tls_imask=(yyvsp[0].intval));
	}
#line 5927 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 171:
#line 895 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number(flags) expected"); }
#line 5933 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 896 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_sctp_imask=(yyvsp[0].intval));
	}
#line 5941 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 899 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number(flags) expected"); }
#line 5947 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 174:
#line 900 "core/cfg.y" /* yacc.c:1646  */
    { _sr_ip_free_bind=(yyvsp[0].intval); }
#line 5953 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 901 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 5959 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 902 "core/cfg.y" /* yacc.c:1646  */
    { port_no=(yyvsp[0].intval); }
#line 5965 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 903 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef STATS
				stat_file=(yyvsp[0].strval);
		#endif
	}
#line 5975 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 178:
#line 908 "core/cfg.y" /* yacc.c:1646  */
    { maxbuffer=(yyvsp[0].intval); }
#line 5981 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 909 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5987 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 910 "core/cfg.y" /* yacc.c:1646  */
    { sql_buffer_size=(yyvsp[0].intval); }
#line 5993 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 911 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5999 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 182:
#line 912 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6005 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 183:
#line 913 "core/cfg.y" /* yacc.c:1646  */
    { children_no=(yyvsp[0].intval); }
#line 6011 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 184:
#line 914 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6017 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 185:
#line 915 "core/cfg.y" /* yacc.c:1646  */
    { socket_workers=(yyvsp[0].intval); }
#line 6023 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 916 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6029 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 917 "core/cfg.y" /* yacc.c:1646  */
    { async_task_set_workers((yyvsp[0].intval)); }
#line 6035 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 188:
#line 918 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6041 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 189:
#line 919 "core/cfg.y" /* yacc.c:1646  */
    { async_task_set_usleep((yyvsp[0].intval)); }
#line 6047 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 190:
#line 920 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6053 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 191:
#line 921 "core/cfg.y" /* yacc.c:1646  */
    { async_task_set_nonblock((yyvsp[0].intval)); }
#line 6059 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 192:
#line 922 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6065 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 193:
#line 923 "core/cfg.y" /* yacc.c:1646  */
    { check_via=(yyvsp[0].intval); }
#line 6071 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 194:
#line 924 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6077 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 195:
#line 925 "core/cfg.y" /* yacc.c:1646  */
    { phone2tel=(yyvsp[0].intval); }
#line 6083 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 926 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6089 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 197:
#line 927 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.memlog=(yyvsp[0].intval); }
#line 6095 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 198:
#line 928 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6101 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 929 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.memdbg=(yyvsp[0].intval); }
#line 6107 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 930 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6113 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 931 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.mem_summary=(yyvsp[0].intval); }
#line 6119 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 932 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6125 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 933 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.mem_safety=(yyvsp[0].intval); }
#line 6131 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 934 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6137 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 935 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.mem_join=(yyvsp[0].intval); }
#line 6143 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 936 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6149 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 937 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.mem_status_mode=(yyvsp[0].intval); }
#line 6155 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 938 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6161 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 939 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.corelog=(yyvsp[0].intval); }
#line 6167 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 940 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6173 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 941 "core/cfg.y" /* yacc.c:1646  */
    { sip_warning=(yyvsp[0].intval); }
#line 6179 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 942 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6185 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 943 "core/cfg.y" /* yacc.c:1646  */
    { version_table.s=(yyvsp[0].strval);
			version_table.len=strlen(version_table.s);
	}
#line 6193 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 946 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6199 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 947 "core/cfg.y" /* yacc.c:1646  */
    {
		if (shm_initialized())
			yyerror("user must be before any modparam or the"
					" route blocks");
		else if (user==0)
			user=(yyvsp[0].strval);
	}
#line 6211 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 954 "core/cfg.y" /* yacc.c:1646  */
    {
		if (shm_initialized())
			yyerror("user must be before any modparam or the"
					" route blocks");
		else if (user==0)
			user=(yyvsp[0].strval);
	}
#line 6223 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 961 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6229 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 962 "core/cfg.y" /* yacc.c:1646  */
    { group=(yyvsp[0].strval); }
#line 6235 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 963 "core/cfg.y" /* yacc.c:1646  */
    { group=(yyvsp[0].strval); }
#line 6241 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 964 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6247 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 965 "core/cfg.y" /* yacc.c:1646  */
    { chroot_dir=(yyvsp[0].strval); }
#line 6253 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 966 "core/cfg.y" /* yacc.c:1646  */
    { chroot_dir=(yyvsp[0].strval); }
#line 6259 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 223:
#line 967 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6265 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 968 "core/cfg.y" /* yacc.c:1646  */
    { working_dir=(yyvsp[0].strval); }
#line 6271 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 969 "core/cfg.y" /* yacc.c:1646  */
    { working_dir=(yyvsp[0].strval); }
#line 6277 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 970 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6283 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 227:
#line 971 "core/cfg.y" /* yacc.c:1646  */
    { runtime_dir=(yyvsp[0].strval); }
#line 6289 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 972 "core/cfg.y" /* yacc.c:1646  */
    { runtime_dir=(yyvsp[0].strval); }
#line 6295 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 973 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6301 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 974 "core/cfg.y" /* yacc.c:1646  */
    { mhomed=(yyvsp[0].intval); }
#line 6307 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 975 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6313 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 976 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_disable=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6325 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 983 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6331 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 984 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.accept_aliases=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6343 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 235:
#line 991 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6349 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 992 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_cfg_children_no=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6361 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 999 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6367 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1000 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.connect_timeout_s=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6379 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1007 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6385 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1008 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.send_timeout=S_TO_TICKS((yyvsp[0].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6397 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1015 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6403 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1016 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			if ((yyvsp[0].intval)<0)
				tcp_default_cfg.con_lifetime=-1;
			else
				tcp_default_cfg.con_lifetime=S_TO_TICKS((yyvsp[0].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6418 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1026 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6424 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1027 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_poll_method=get_poll_type((yyvsp[0].strval));
			if (tcp_poll_method==POLL_NONE) {
				LOG(L_CRIT, "bad poll method name:"
						" %s\n, try one of %s.\n",
						(yyvsp[0].strval), poll_support);
				yyerror("bad tcp_poll_method "
						"value");
			}
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6443 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1041 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_poll_method=get_poll_type((yyvsp[0].strval));
			if (tcp_poll_method==POLL_NONE) {
				LOG(L_CRIT, "bad poll method name:"
						" %s\n, try one of %s.\n",
						(yyvsp[0].strval), poll_support);
				yyerror("bad tcp_poll_method "
						"value");
			}
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6462 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1055 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("poll method name expected"); }
#line 6468 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1056 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_max_connections=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6480 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1063 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6486 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1064 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			tls_max_connections=(yyvsp[0].intval);
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 6498 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1071 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6504 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1072 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.no_connect=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6516 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1079 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6522 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1080 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			if (tcp_set_src_addr((yyvsp[0].ipaddr))<0)
				warn("tcp_source_ipv4 failed");
		#else
			warn("tcp support not compiled in");
		#endif
		pkg_free((yyvsp[0].ipaddr));
	}
#line 6536 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1089 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("IPv4 address expected"); }
#line 6542 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1090 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
				if (tcp_set_src_addr((yyvsp[0].ipaddr))<0)
					warn("tcp_source_ipv6 failed");
		#else
			warn("tcp support not compiled in");
		#endif
		pkg_free((yyvsp[0].ipaddr));
	}
#line 6556 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1099 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("IPv6 address expected"); }
#line 6562 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1100 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.fd_cache=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6574 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1107 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6580 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1108 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.async=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6592 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1115 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6598 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1116 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.tcpconn_wq_max=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6610 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1123 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6616 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1124 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.tcp_wq_max=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6628 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1131 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6634 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1132 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.rd_buf_size=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6646 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1139 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6652 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1140 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.wq_blk_size=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6664 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1147 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6670 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1148 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.defer_accept=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6682 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1155 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6688 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1156 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.delayed_ack=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6700 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1163 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6706 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1164 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.syncnt=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6718 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1171 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6724 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1172 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.linger2=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6736 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1179 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6742 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1180 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepalive=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6754 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1187 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected");}
#line 6760 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1188 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepidle=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6772 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1195 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6778 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1196 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepintvl=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6790 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1203 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6796 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1204 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepcnt=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6808 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1211 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6814 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1212 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.crlf_ping=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6826 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 286:
#line 1219 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6832 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 287:
#line 1220 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.accept_no_cl=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6844 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 288:
#line 1227 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6850 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 289:
#line 1228 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			ksr_tcp_accept_hep3=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6862 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 290:
#line 1235 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6868 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 291:
#line 1236 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			ksr_tcp_accept_haproxy=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6880 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 292:
#line 1243 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6886 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 293:
#line 1245 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_set_clone_rcvbuf((yyvsp[0].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6898 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 294:
#line 1252 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6904 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 295:
#line 1253 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
		#ifdef SO_REUSEPORT
			tcp_default_cfg.reuse_port=(yyvsp[0].intval);
		#else
			warn("support for SO_REUSEPORT not compiled in");
		#endif
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6920 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 296:
#line 1264 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6926 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 297:
#line 1265 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			tls_disable=(yyvsp[0].intval);
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 6938 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 298:
#line 1272 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6944 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 299:
#line 1273 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			tls_disable=!((yyvsp[0].intval));
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 6956 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 300:
#line 1280 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6962 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 301:
#line 1281 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_log=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 6974 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 1288 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6980 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 303:
#line 1289 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			tls_port_no=(yyvsp[0].intval);
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 6992 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 1296 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6998 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 305:
#line 1297 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv23;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7010 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 306:
#line 1304 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv2;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7022 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 307:
#line 1311 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv3;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7034 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 308:
#line 1318 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_TLSv1;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7046 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 309:
#line 1325 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			yyerror("SSLv23, SSLv2, SSLv3 or TLSv1 expected");
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7058 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 310:
#line 1332 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_verify_cert=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7070 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 311:
#line 1339 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7076 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 312:
#line 1340 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_require_cert=(yyvsp[0].intval);
		#else
			warn( "tls-in-core support not compiled in");
		#endif
	}
#line 7088 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 313:
#line 1347 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7094 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 314:
#line 1348 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_cert_file=(yyvsp[0].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7106 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 315:
#line 1355 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7112 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 316:
#line 1356 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_pkey_file=(yyvsp[0].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7124 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 317:
#line 1363 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7130 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 318:
#line 1364 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_ca_file=(yyvsp[0].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7142 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 319:
#line 1371 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7148 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 320:
#line 1372 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_handshake_timeout=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7160 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 321:
#line 1379 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7166 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 322:
#line 1380 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_send_timeout=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7178 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 323:
#line 1387 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7184 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 324:
#line 1388 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			sctp_disable=(yyvsp[0].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
#line 7196 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 325:
#line 1395 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7202 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 326:
#line 1396 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			sctp_disable=((yyvsp[0].intval)<=1)?!(yyvsp[0].intval):(yyvsp[0].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
#line 7214 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 327:
#line 1403 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean or number expected"); }
#line 7220 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 328:
#line 1404 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			sctp_children_no=(yyvsp[0].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
#line 7232 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 329:
#line 1411 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7238 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 330:
#line 1412 "core/cfg.y" /* yacc.c:1646  */
    { server_signature=(yyvsp[0].intval); }
#line 7244 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 331:
#line 1413 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7250 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 332:
#line 1414 "core/cfg.y" /* yacc.c:1646  */
    { server_hdr.s=(yyvsp[0].strval);
			server_hdr.len=strlen(server_hdr.s);
	}
#line 7258 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 333:
#line 1417 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7264 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 334:
#line 1418 "core/cfg.y" /* yacc.c:1646  */
    { user_agent_hdr.s=(yyvsp[0].strval);
			user_agent_hdr.len=strlen(user_agent_hdr.s);
	}
#line 7272 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 335:
#line 1421 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7278 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 336:
#line 1422 "core/cfg.y" /* yacc.c:1646  */
    { reply_to_via=(yyvsp[0].intval); }
#line 7284 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 337:
#line 1423 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7290 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 338:
#line 1424 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[0].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_iface(	lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[0].sockid));
	}
#line 7307 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 339:
#line 1436 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[-4].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface(	lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									(yyvsp[-2].strval), (yyvsp[0].intval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-4].sockid));
	}
#line 7325 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 340:
#line 1449 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("ip address, interface name or"
									" hostname expected"); }
#line 7332 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 341:
#line 1451 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[0].sockid); lst_tmp; lst_tmp=lst_tmp->next){
			add_alias(	lst_tmp->addr_lst->name,
						strlen(lst_tmp->addr_lst->name),
						lst_tmp->port, lst_tmp->proto);
			for (nl_tmp=lst_tmp->addr_lst->next; nl_tmp; nl_tmp=nl_tmp->next)
				add_alias(nl_tmp->name, strlen(nl_tmp->name),
							lst_tmp->port, lst_tmp->proto);
		}
		free_socket_id_lst((yyvsp[0].sockid));
	}
#line 7348 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 342:
#line 1462 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("hostname expected"); }
#line 7354 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 343:
#line 1463 "core/cfg.y" /* yacc.c:1646  */
    { sr_auto_aliases=(yyvsp[0].intval); }
#line 7360 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 344:
#line 1464 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7366 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 345:
#line 1465 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].strval)){
			default_global_address.s=(yyvsp[0].strval);
			default_global_address.len=strlen((yyvsp[0].strval));
		}
	}
#line 7377 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 346:
#line 1471 "core/cfg.y" /* yacc.c:1646  */
    {yyerror("ip address or hostname expected"); }
#line 7383 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 347:
#line 1472 "core/cfg.y" /* yacc.c:1646  */
    {
		tmp=int2str((yyvsp[0].intval), &i_tmp);
		if ((default_global_port.s=pkg_malloc(i_tmp))==0) {
			PKG_MEM_CRITICAL;
			default_global_port.len=0;
		} else {
			default_global_port.len=i_tmp;
			memcpy(default_global_port.s, tmp, default_global_port.len);
		};
	}
#line 7398 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 348:
#line 1482 "core/cfg.y" /* yacc.c:1646  */
    {yyerror("ip address or hostname expected"); }
#line 7404 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 349:
#line 1483 "core/cfg.y" /* yacc.c:1646  */
    { disable_core_dump=(yyvsp[0].intval); }
#line 7410 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 350:
#line 1484 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7416 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 351:
#line 1485 "core/cfg.y" /* yacc.c:1646  */
    { open_files_limit=(yyvsp[0].intval); }
#line 7422 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 352:
#line 1486 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7428 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 353:
#line 1487 "core/cfg.y" /* yacc.c:1646  */
    {
		if (shm_initialized())
			yyerror("shm/shm_mem_size must be before any modparam or the"
					" route blocks");
		else if (shm_mem_size == 0 || shm_mem_size == SHM_MEM_POOL_SIZE)
			shm_mem_size=(yyvsp[0].intval) * 1024 * 1024;
	}
#line 7440 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 354:
#line 1494 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7446 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 355:
#line 1495 "core/cfg.y" /* yacc.c:1646  */
    {
		if (shm_initialized())
			yyerror("shm_force_alloc must be before any modparam or the"
					" route blocks");
		else
			shm_force_alloc=(yyvsp[0].intval);
	}
#line 7458 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 356:
#line 1502 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7464 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 357:
#line 1503 "core/cfg.y" /* yacc.c:1646  */
    { mlock_pages=(yyvsp[0].intval); }
#line 7470 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 358:
#line 1504 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7476 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 359:
#line 1505 "core/cfg.y" /* yacc.c:1646  */
    { real_time=(yyvsp[0].intval); }
#line 7482 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 360:
#line 1506 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7488 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 361:
#line 1507 "core/cfg.y" /* yacc.c:1646  */
    { rt_prio=(yyvsp[0].intval); }
#line 7494 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 362:
#line 1508 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7500 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 363:
#line 1509 "core/cfg.y" /* yacc.c:1646  */
    { rt_policy=(yyvsp[0].intval); }
#line 7506 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 364:
#line 1510 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7512 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 365:
#line 1511 "core/cfg.y" /* yacc.c:1646  */
    { rt_timer1_prio=(yyvsp[0].intval); }
#line 7518 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 366:
#line 1512 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7524 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 367:
#line 1513 "core/cfg.y" /* yacc.c:1646  */
    { rt_timer1_policy=(yyvsp[0].intval); }
#line 7530 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 368:
#line 1514 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7536 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 369:
#line 1515 "core/cfg.y" /* yacc.c:1646  */
    { rt_timer2_prio=(yyvsp[0].intval); }
#line 7542 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 370:
#line 1516 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7548 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 371:
#line 1517 "core/cfg.y" /* yacc.c:1646  */
    { rt_timer2_policy=(yyvsp[0].intval); }
#line 7554 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 372:
#line 1518 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7560 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 373:
#line 1519 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_MCAST
			mcast_loopback=(yyvsp[0].intval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 7572 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 374:
#line 1526 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7578 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 375:
#line 1527 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_MCAST
			mcast_ttl=(yyvsp[0].intval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 7590 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 376:
#line 1534 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7596 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 377:
#line 1535 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_MCAST
			mcast=(yyvsp[0].strval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 7608 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 378:
#line 1542 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_MCAST
			mcast=(yyvsp[0].strval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 7620 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 379:
#line 1549 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 7626 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 380:
#line 1550 "core/cfg.y" /* yacc.c:1646  */
    { tos=(yyvsp[0].intval); }
#line 7632 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 381:
#line 1551 "core/cfg.y" /* yacc.c:1646  */
    { if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWDELAY")) {
			tos=IPTOS_LOWDELAY;
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_THROUGHPUT")) {
			tos=IPTOS_THROUGHPUT;
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_RELIABILITY")) {
			tos=IPTOS_RELIABILITY;
#if defined(IPTOS_MINCOST)
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_MINCOST")) {
			tos=IPTOS_MINCOST;
#endif
#if defined(IPTOS_LOWCOST)
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWCOST")) {
			tos=IPTOS_LOWCOST;
#endif
		} else {
			yyerror("invalid tos value - allowed: "
				"IPTOS_LOWDELAY,IPTOS_THROUGHPUT,"
				"IPTOS_RELIABILITY"
#if defined(IPTOS_LOWCOST)
				",IPTOS_LOWCOST"
#endif
#if !defined(IPTOS_MINCOST)
				",IPTOS_MINCOST"
#endif
				"\n");
		}
	}
#line 7664 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 382:
#line 1578 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7670 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 383:
#line 1579 "core/cfg.y" /* yacc.c:1646  */
    { pmtu_discovery=(yyvsp[0].intval); }
#line 7676 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 384:
#line 1580 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7682 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 385:
#line 1581 "core/cfg.y" /* yacc.c:1646  */
    { ser_kill_timeout=(yyvsp[0].intval); }
#line 7688 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 386:
#line 1582 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7694 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 387:
#line 1583 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.max_while_loops=(yyvsp[0].intval); }
#line 7700 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 388:
#line 1584 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7706 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 389:
#line 1585 "core/cfg.y" /* yacc.c:1646  */
    { pv_set_buffer_size((yyvsp[0].intval)); }
#line 7712 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 390:
#line 1586 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7718 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 391:
#line 1587 "core/cfg.y" /* yacc.c:1646  */
    { pv_set_buffer_slots((yyvsp[0].intval)); }
#line 7724 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 392:
#line 1588 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7730 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 393:
#line 1589 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.pv_cache_limit=(yyvsp[0].intval); }
#line 7736 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 394:
#line 1590 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7742 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 395:
#line 1591 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.pv_cache_action=(yyvsp[0].intval); }
#line 7748 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 396:
#line 1592 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7754 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 397:
#line 1593 "core/cfg.y" /* yacc.c:1646  */
    { http_reply_parse=(yyvsp[0].intval); }
#line 7760 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 398:
#line 1594 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7766 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 399:
#line 1595 "core/cfg.y" /* yacc.c:1646  */
    { ksr_verbose_startup=(yyvsp[0].intval); }
#line 7772 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 400:
#line 1596 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7778 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 401:
#line 1597 "core/cfg.y" /* yacc.c:1646  */
    { ksr_route_locks_size=(yyvsp[0].intval); }
#line 7784 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 402:
#line 1598 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7790 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 403:
#line 1599 "core/cfg.y" /* yacc.c:1646  */
    { server_id=(yyvsp[0].intval); }
#line 7796 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 404:
#line 1600 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7802 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 405:
#line 1601 "core/cfg.y" /* yacc.c:1646  */
    {
			kemi_onsend_route_callback.s = (yyvsp[0].strval);
			kemi_onsend_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_onsend_route_callback.len==4
					&& strcasecmp(kemi_onsend_route_callback.s, "none")==0) {
				kemi_onsend_route_callback.s = "";
				kemi_onsend_route_callback.len = 0;
			}
		}
#line 7816 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 406:
#line 1610 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 7822 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 407:
#line 1611 "core/cfg.y" /* yacc.c:1646  */
    {
			kemi_reply_route_callback.s = (yyvsp[0].strval);
			kemi_reply_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_reply_route_callback.len==4
					&& strcasecmp(kemi_reply_route_callback.s, "none")==0) {
				kemi_reply_route_callback.s = "";
				kemi_reply_route_callback.len = 0;
			}
		}
#line 7836 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 408:
#line 1620 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 7842 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 409:
#line 1621 "core/cfg.y" /* yacc.c:1646  */
    {
			kemi_event_route_callback.s = (yyvsp[0].strval);
			kemi_event_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_event_route_callback.len==4
					&& strcasecmp(kemi_event_route_callback.s, "none")==0) {
				kemi_event_route_callback.s = "";
				kemi_event_route_callback.len = 0;
			}
		}
#line 7856 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 410:
#line 1630 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 7862 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 411:
#line 1631 "core/cfg.y" /* yacc.c:1646  */
    { set_max_recursive_level((yyvsp[0].intval)); }
#line 7868 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 412:
#line 1632 "core/cfg.y" /* yacc.c:1646  */
    { sr_dst_max_branches = (yyvsp[0].intval); }
#line 7874 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 413:
#line 1633 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.latency_log=(yyvsp[0].intval); }
#line 7880 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 414:
#line 1634 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 7886 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 415:
#line 1635 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.latency_cfg_log=(yyvsp[0].intval); }
#line 7892 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 416:
#line 1636 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 7898 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 417:
#line 1637 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.latency_limit_db=(yyvsp[0].intval); }
#line 7904 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 418:
#line 1638 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 7910 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 419:
#line 1639 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.latency_limit_action=(yyvsp[0].intval); }
#line 7916 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 420:
#line 1640 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 7922 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 421:
#line 1641 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.latency_limit_cfg=(yyvsp[0].intval); }
#line 7928 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 422:
#line 1642 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 7934 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 423:
#line 1643 "core/cfg.y" /* yacc.c:1646  */
    { sr_msg_time=(yyvsp[0].intval); }
#line 7940 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 424:
#line 1644 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 7946 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 425:
#line 1645 "core/cfg.y" /* yacc.c:1646  */
    { onsend_route_reply=(yyvsp[0].intval); }
#line 7952 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 426:
#line 1646 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 7958 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 427:
#line 1647 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.udp_mtu=(yyvsp[0].intval); }
#line 7964 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 428:
#line 1648 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7970 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 429:
#line 1650 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.force_rport=(yyvsp[0].intval); fix_global_req_flags(0, 0); }
#line 7976 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 430:
#line 1651 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7982 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 431:
#line 1653 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.udp_mtu_try_proto=(yyvsp[0].intval); fix_global_req_flags(0, 0); }
#line 7988 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 432:
#line 1655 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("TCP, TLS, SCTP or UDP expected"); }
#line 7994 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 433:
#line 1656 "core/cfg.y" /* yacc.c:1646  */
    { IF_RAW_SOCKS(default_core_cfg.udp4_raw=(yyvsp[0].intval)); }
#line 8000 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 434:
#line 1657 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8006 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 435:
#line 1658 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_RAW_SOCKS(default_core_cfg.udp4_raw_mtu=(yyvsp[0].intval));
	}
#line 8014 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 436:
#line 1661 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8020 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 437:
#line 1662 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_RAW_SOCKS(default_core_cfg.udp4_raw_ttl=(yyvsp[0].intval));
	}
#line 8028 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 438:
#line 1665 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8034 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 440:
#line 1667 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("unknown config variable"); }
#line 8040 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 442:
#line 1671 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)="default" ; }
#line 8046 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 444:
#line 1675 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)="default" ; }
#line 8052 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 445:
#line 1676 "core/cfg.y" /* yacc.c:1646  */
    {
		yyerror("cfg var field name - use of number or reserved token not allowed: %s",
				yy_number_str);
		YYERROR;
	}
#line 8062 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 446:
#line 1684 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_declare_int((yyvsp[-4].strval), (yyvsp[-2].strval), (yyvsp[0].intval), 0, 0, NULL)) {
			yyerror("variable cannot be declared");
		}
	}
#line 8072 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 447:
#line 1689 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_declare_str((yyvsp[-4].strval), (yyvsp[-2].strval), (yyvsp[0].strval), NULL)) {
			yyerror("variable cannot be declared");
		}
	}
#line 8082 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 448:
#line 1694 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_declare_int((yyvsp[-6].strval), (yyvsp[-4].strval), (yyvsp[-2].intval), 0, 0, (yyvsp[0].strval))) {
			yyerror("variable cannot be declared");
		}
	}
#line 8092 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 449:
#line 1699 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_declare_str((yyvsp[-6].strval), (yyvsp[-4].strval), (yyvsp[-2].strval), (yyvsp[0].strval))) {
			yyerror("variable cannot be declared");
		}
	}
#line 8102 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 450:
#line 1704 "core/cfg.y" /* yacc.c:1646  */
    {
		yyerror("number or string expected");
	}
#line 8110 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 451:
#line 1707 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_ginst_var_int((yyvsp[-7].strval), (yyvsp[-5].intval), (yyvsp[-2].strval), (yyvsp[0].intval))) {
			yyerror("variable cannot be added to the group instance");
		}
	}
#line 8120 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 452:
#line 1712 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_ginst_var_string((yyvsp[-7].strval), (yyvsp[-5].intval), (yyvsp[-2].strval), (yyvsp[0].strval))) {
			yyerror("variable cannot be added to the group instance");
		}
	}
#line 8130 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 453:
#line 1720 "core/cfg.y" /* yacc.c:1646  */
    {
		LM_DBG("loading module %s\n", (yyvsp[0].strval));
			if (load_module((yyvsp[0].strval))!=0) {
				yyerror("failed to load module");
			}
	}
#line 8141 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 454:
#line 1726 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8147 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 455:
#line 1727 "core/cfg.y" /* yacc.c:1646  */
    {
		if(mods_dir_cmd==0) {
			LM_DBG("loading modules under %s\n", (yyvsp[0].strval));
			printf("loading modules under config path: %s\n", (yyvsp[0].strval));
			mods_dir = (yyvsp[0].strval);
		} else {
			LM_DBG("ignoring mod path given in config: %s\n", (yyvsp[0].strval));
			printf("loading modules under command line path: %s\n", mods_dir);
		}
	}
#line 8162 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 456:
#line 1737 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8168 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 457:
#line 1738 "core/cfg.y" /* yacc.c:1646  */
    {
		if(mods_dir_cmd==0) {
			LM_DBG("loading modules under %s\n", (yyvsp[0].strval));
			printf("loading modules under config path: %s\n", (yyvsp[0].strval));
			mods_dir = (yyvsp[0].strval);
		} else {
			LM_DBG("ignoring mod path given in config: %s\n", (yyvsp[0].strval));
			printf("loading modules under command line path: %s\n", mods_dir);
		}
	}
#line 8183 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 458:
#line 1748 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8189 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 459:
#line 1749 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), PARAM_STRING, (yyvsp[-1].strval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	}
#line 8203 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 460:
#line 1758 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), PARAM_INT, (void*)(yyvsp[-1].intval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	}
#line 8217 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 461:
#line 1767 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("Invalid arguments"); }
#line 8223 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 462:
#line 1768 "core/cfg.y" /* yacc.c:1646  */
    {
		if(sr_kemi_eng_setz((yyvsp[0].strval), NULL)) {
			yyerror("Can't set config routing engine");
			YYABORT;
		}
	}
#line 8234 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 463:
#line 1774 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8240 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 464:
#line 1775 "core/cfg.y" /* yacc.c:1646  */
    {
		if(sr_kemi_eng_setz((yyvsp[0].strval), NULL)) {
			yyerror("Can't set config routing engine");
			YYABORT;
		}
	}
#line 8251 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 465:
#line 1781 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8257 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 466:
#line 1785 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 8263 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 467:
#line 1786 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 8269 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 468:
#line 1789 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
		if ((yyval.ipaddr)==0) {
			PKG_MEM_CRITICAL;
		} else {
			memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
			(yyval.ipaddr)->af=AF_INET;
			(yyval.ipaddr)->len=4;
			if (((yyvsp[-6].intval)>255) || ((yyvsp[-6].intval)<0) ||
				((yyvsp[-4].intval)>255) || ((yyvsp[-4].intval)<0) ||
				((yyvsp[-2].intval)>255) || ((yyvsp[-2].intval)<0) ||
				((yyvsp[0].intval)>255) || ((yyvsp[0].intval)<0)) {
				yyerror("invalid ipv4 address");
				(yyval.ipaddr)->u.addr32[0]=0;
				/* $$=0; */
			} else {
				(yyval.ipaddr)->u.addr[0]=(yyvsp[-6].intval);
				(yyval.ipaddr)->u.addr[1]=(yyvsp[-4].intval);
				(yyval.ipaddr)->u.addr[2]=(yyvsp[-2].intval);
				(yyval.ipaddr)->u.addr[3]=(yyvsp[0].intval);
				/*
				$$=htonl( ($1<<24)|
				($3<<16)| ($5<<8)|$7 );
				*/
			}
		}
	}
#line 8301 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 469:
#line 1818 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
		if ((yyval.ipaddr)==0) {
			PKG_MEM_CRITICAL;
		} else {
			memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
			(yyval.ipaddr)->af=AF_INET6;
			(yyval.ipaddr)->len=16;
			if (inet_pton(AF_INET6, (yyvsp[0].strval), (yyval.ipaddr)->u.addr)<=0) {
				yyerror("bad ipv6 address");
			}
		}
	}
#line 8319 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 470:
#line 1833 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 8325 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 471:
#line 1834 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.ipaddr)=(yyvsp[-1].ipaddr); }
#line 8331 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 472:
#line 1838 "core/cfg.y" /* yacc.c:1646  */
    {
					tmp=int2str((yyvsp[0].intval), &i_tmp);
					if (((yyval.strval)=pkg_malloc(i_tmp+1))==0) {
						yyerror("out of  memory");
						YYABORT;
					} else {
						memcpy((yyval.strval), tmp, i_tmp);
						(yyval.strval)[i_tmp]=0;
					}
					routename = tmp;
						}
#line 8347 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 473:
#line 1849 "core/cfg.y" /* yacc.c:1646  */
    { routename = (yyvsp[0].strval); (yyval.strval)=(yyvsp[0].strval); }
#line 8353 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 474:
#line 1850 "core/cfg.y" /* yacc.c:1646  */
    { routename = (yyvsp[0].strval); (yyval.strval)=(yyvsp[0].strval); }
#line 8359 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 475:
#line 1854 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8365 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 476:
#line 1855 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8371 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 477:
#line 1859 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &main_rt.rlist[DEFAULT_RT]);
	}
#line 8383 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 478:
#line 1866 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&main_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (main_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &main_rt.rlist[i_tmp]);
	}
#line 8404 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 479:
#line 1882 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid  route  statement"); }
#line 8410 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 480:
#line 1883 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid  request_route  statement"); }
#line 8416 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 481:
#line 1886 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8422 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 482:
#line 1889 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &failure_rt.rlist[DEFAULT_RT]);
	}
#line 8434 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 483:
#line 1896 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&failure_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (failure_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &failure_rt.rlist[i_tmp]);
	}
#line 8455 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 484:
#line 1912 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid failure_route statement"); }
#line 8461 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 485:
#line 1916 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8467 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 486:
#line 1917 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8473 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 487:
#line 1922 "core/cfg.y" /* yacc.c:1646  */
    {rt=CORE_ONREPLY_ROUTE;}
#line 8479 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 488:
#line 1922 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &onreply_rt.rlist[DEFAULT_RT]);
	}
#line 8491 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 489:
#line 1929 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid onreply_route statement"); }
#line 8497 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 490:
#line 1930 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid onreply_route statement"); }
#line 8503 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 491:
#line 1932 "core/cfg.y" /* yacc.c:1646  */
    {rt=(*(yyvsp[-1].strval)=='0' && (yyvsp[-1].strval)[1]==0)?CORE_ONREPLY_ROUTE:TM_ONREPLY_ROUTE;}
#line 8509 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 492:
#line 1933 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (*(yyvsp[-5].strval)=='0' && (yyvsp[-5].strval)[1]==0){
			/* onreply_route[0] {} is equivalent with onreply_route {}*/
			push((yyvsp[-1].action), &onreply_rt.rlist[DEFAULT_RT]);
		}else{
			i_tmp=route_get(&onreply_rt, (yyvsp[-5].strval));
			if (i_tmp==-1){
				yyerror("internal error");
				YYABORT;
			}
			if (onreply_rt.rlist[i_tmp]){
				yyerror("duplicate route");
				YYABORT;
			}
			push((yyvsp[-1].action), &onreply_rt.rlist[i_tmp]);
		}
	}
#line 8535 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 493:
#line 1954 "core/cfg.y" /* yacc.c:1646  */
    {
		yyerror("invalid onreply_route statement");
	}
#line 8543 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 494:
#line 1959 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8549 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 495:
#line 1962 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &branch_rt.rlist[DEFAULT_RT]);
	}
#line 8561 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 496:
#line 1969 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&branch_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (branch_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &branch_rt.rlist[i_tmp]);
	}
#line 8582 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 497:
#line 1985 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid branch_route statement"); }
#line 8588 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 498:
#line 1988 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8594 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 499:
#line 1991 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &onsend_rt.rlist[DEFAULT_RT]);
	}
#line 8606 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 500:
#line 1998 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&onsend_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (onsend_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &onsend_rt.rlist[i_tmp]);
	}
#line 8627 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 501:
#line 2014 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid onsend_route statement"); }
#line 8633 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 502:
#line 2017 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8639 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 503:
#line 2020 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&event_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (event_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &event_rt.rlist[i_tmp]);
	}
#line 8660 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 504:
#line 2037 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid event_route statement"); }
#line 8666 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 505:
#line 2040 "core/cfg.y" /* yacc.c:1646  */
    { if(pp_subst_add((yyvsp[0].strval))<0) YYERROR; }
#line 8672 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 506:
#line 2041 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid subst preprocess statement"); }
#line 8678 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 507:
#line 2042 "core/cfg.y" /* yacc.c:1646  */
    { if(pp_substdef_add((yyvsp[0].strval), 0)<0) YYERROR; }
#line 8684 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 508:
#line 2043 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid substdef preprocess statement"); }
#line 8690 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 509:
#line 2044 "core/cfg.y" /* yacc.c:1646  */
    { if(pp_substdef_add((yyvsp[0].strval), 1)<0) YYERROR; }
#line 8696 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 510:
#line 2045 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid substdefs preprocess statement"); }
#line 8702 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 511:
#line 2067 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=EQUAL_OP; }
#line 8708 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 512:
#line 2068 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=DIFF_OP; }
#line 8714 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 513:
#line 2069 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=EQUAL_OP; }
#line 8720 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 514:
#line 2070 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=DIFF_OP; }
#line 8726 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 515:
#line 2073 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=GT_OP; }
#line 8732 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 516:
#line 2074 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=LT_OP; }
#line 8738 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 517:
#line 2075 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=GTE_OP; }
#line 8744 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 518:
#line 2076 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=LTE_OP; }
#line 8750 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 519:
#line 2079 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 8756 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 520:
#line 2080 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=MATCH_OP; }
#line 8762 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 521:
#line 2086 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_EQ_OP; }
#line 8768 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 522:
#line 2087 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_DIFF_OP; }
#line 8774 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 523:
#line 2088 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_IEQ_OP; }
#line 8780 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 524:
#line 2089 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_IDIFF_OP; }
#line 8786 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 525:
#line 2090 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_STREQ_OP; }
#line 8792 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 526:
#line 2091 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_STRDIFF_OP; }
#line 8798 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 527:
#line 2092 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_MATCH_OP; }
#line 8804 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 528:
#line 2095 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_GT_OP; }
#line 8810 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 529:
#line 2096 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_LT_OP; }
#line 8816 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 530:
#line 2097 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_GTE_OP; }
#line 8822 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 531:
#line 2098 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_LTE_OP; }
#line 8828 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 532:
#line 2105 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=URI_O;}
#line 8834 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 533:
#line 2106 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=FROM_URI_O;}
#line 8840 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 534:
#line 2107 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=TO_URI_O;}
#line 8846 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 535:
#line 2114 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=SNDPORT_O; }
#line 8852 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 536:
#line 2115 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=TOPORT_O; }
#line 8858 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 537:
#line 2116 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=SNDAF_O; }
#line 8864 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 538:
#line 2120 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=SRCPORT_O; }
#line 8870 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 539:
#line 2121 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=DSTPORT_O; }
#line 8876 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 540:
#line 2122 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=AF_O; }
#line 8882 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 541:
#line 2123 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=MSGLEN_O; }
#line 8888 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 543:
#line 2129 "core/cfg.y" /* yacc.c:1646  */
    { onsend_check("snd_ip"); (yyval.intval)=SNDIP_O; }
#line 8894 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 544:
#line 2130 "core/cfg.y" /* yacc.c:1646  */
    { onsend_check("to_ip");  (yyval.intval)=TOIP_O; }
#line 8900 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 545:
#line 2133 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=SRCIP_O; }
#line 8906 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 546:
#line 2134 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=DSTIP_O; }
#line 8912 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 548:
#line 2142 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.expr)= mk_elem((yyvsp[-1].intval), METHOD_O, 0, RVE_ST, (yyvsp[0].rv_expr));}
#line 8918 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 549:
#line 2144 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.expr) = mk_elem((yyvsp[-1].intval), METHOD_O, 0, STRING_ST,(yyvsp[0].strval)); }
#line 8924 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 550:
#line 2145 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("string expected"); }
#line 8930 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 551:
#line 2147 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("invalid operator,== , !=, or =~ expected"); }
#line 8936 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 552:
#line 2149 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.expr) = mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr)); }
#line 8942 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 553:
#line 2151 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, MYSELF_ST, 0); }
#line 8948 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 554:
#line 2153 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("string or MYSELF expected"); }
#line 8954 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 555:
#line 2155 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("invalid operator, == , != or =~ expected"); }
#line 8960 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 556:
#line 2156 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 8966 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 557:
#line 2158 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 8972 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 558:
#line 2159 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("number expected"); }
#line 8978 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 559:
#line 2160 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("number expected"); }
#line 8984 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 560:
#line 2161 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("==, !=, <,>, >= or <=  expected"); }
#line 8990 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 561:
#line 2163 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), PROTO_O, 0, NUMBER_ST, (void*)(yyvsp[0].intval) ); }
#line 8996 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 562:
#line 2165 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), PROTO_O, 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 9002 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 563:
#line 2167 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("protocol expected (udp, tcp, tls, sctp, ws, or wss)"); }
#line 9008 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 564:
#line 2169 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), SNDPROTO_O, 0, NUMBER_ST, (void*)(yyvsp[0].intval) ); }
#line 9014 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 565:
#line 2171 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), SNDPROTO_O, 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 9020 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 566:
#line 2173 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("protocol expected (udp, tcp, tls, sctp, ws, or wss)"); }
#line 9026 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 567:
#line 2174 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, NET_ST, (yyvsp[0].ipnet)); }
#line 9032 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 568:
#line 2175 "core/cfg.y" /* yacc.c:1646  */
    {
			s_tmp.s=0;
			(yyval.expr)=0;
			if (rve_is_constant((yyvsp[0].rv_expr))){
				i_tmp=rve_guess_type((yyvsp[0].rv_expr));
				if (i_tmp==RV_INT)
					yyerror("string expected");
				else if (i_tmp==RV_STR){
					if (((rval_tmp=rval_expr_eval(0, 0, (yyvsp[0].rv_expr)))==0) ||
								(rval_get_str(0, 0, &s_tmp, rval_tmp, 0)<0)){
						rval_destroy(rval_tmp);
						yyerror("bad rvalue expression");
					}else{
						rval_destroy(rval_tmp);
					}
				}else{
					yyerror("BUG: unexpected dynamic type");
				}
			}else{
					/* warn("non constant rvalue in ip comparison") */;
			}
			if (s_tmp.s){
				ip_tmp=str2ip(&s_tmp);
				if (ip_tmp==0)
					ip_tmp=str2ip6(&s_tmp);
				pkg_free(s_tmp.s);
				if (ip_tmp) {
					(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, NET_ST,
								mk_new_net_bitlen(ip_tmp, ip_tmp->len*8) );
				} else {
					(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr));
				}
			}else{
				(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr));
			}
		}
#line 9073 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 569:
#line 2212 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, STRING_ST, (yyvsp[0].strval)); }
#line 9079 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 570:
#line 2214 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, MYSELF_ST, 0); }
#line 9085 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 571:
#line 2216 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror( "ip address or hostname expected" ); }
#line 9091 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 572:
#line 2218 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("invalid operator, ==, != or =~ expected");}
#line 9097 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 573:
#line 2221 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[0].intval), 0, MYSELF_ST, 0); }
#line 9103 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 574:
#line 2223 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[0].intval), 0, MYSELF_ST, 0); }
#line 9109 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 575:
#line 2225 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("URI, SRCIP or DSTIP expected"); }
#line 9115 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 576:
#line 2226 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror ("invalid operator, == or != expected"); }
#line 9121 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 577:
#line 2230 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipnet)=mk_new_net((yyvsp[-2].ipaddr), (yyvsp[0].ipaddr)); }
#line 9127 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 578:
#line 2231 "core/cfg.y" /* yacc.c:1646  */
    {
		if (((yyvsp[0].intval)<0) || ((yyvsp[0].intval)>(yyvsp[-2].ipaddr)->len*8)) {
			yyerror("invalid bit number in netmask");
			(yyval.ipnet)=0;
		} else {
			(yyval.ipnet)=mk_new_net_bitlen((yyvsp[-2].ipaddr), (yyvsp[0].intval));
		/*
			$$=mk_new_net($1, htonl( ($3)?~( (1<<(32-$3))-1 ):0 ) );
		*/
		}
	}
#line 9143 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 579:
#line 2242 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipnet)=mk_new_net_bitlen((yyvsp[0].ipaddr), (yyvsp[0].ipaddr)->len*8); }
#line 9149 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 580:
#line 2243 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipnet)=0; yyerror("netmask (eg:255.0.0.0 or 8) expected"); }
#line 9155 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 581:
#line 2247 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=(yyvsp[0].strval); }
#line 9161 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 582:
#line 2248 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='.';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 9181 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 583:
#line 2263 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='-';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 9201 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 584:
#line 2278 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=0; pkg_free((yyvsp[-2].strval)); yyerror("invalid hostname"); }
#line 9207 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 585:
#line 2279 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=0; pkg_free((yyvsp[-2].strval)); yyerror("invalid hostname"); }
#line 9213 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 588:
#line 2284 "core/cfg.y" /* yacc.c:1646  */
    {
			/* get string version */
			(yyval.strval)=pkg_malloc(strlen(yy_number_str)+1);
			if ((yyval.strval)==0) {
				PKG_MEM_ERROR;
			} else {
				strcpy((yyval.strval), yy_number_str);
			}
		}
#line 9227 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 589:
#line 2296 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=(yyvsp[0].strval); }
#line 9233 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 590:
#line 2297 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='.';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 9253 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 591:
#line 2312 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='-';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 9273 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 592:
#line 2327 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=0; pkg_free((yyvsp[-2].strval));
								yyerror("invalid host or interface name"); }
#line 9280 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 593:
#line 2329 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=0; pkg_free((yyvsp[-2].strval));
								yyerror("invalid host or interface name"); }
#line 9287 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 594:
#line 2336 "core/cfg.y" /* yacc.c:1646  */
    {
		/* check if allowed */
		if ((yyvsp[0].action) && rt==ONSEND_ROUTE) {
			switch((yyvsp[0].action)->type) {
				case DROP_T:
				case LOG_T:
				case SETFLAG_T:
				case RESETFLAG_T:
				case ISFLAGSET_T:
				case IF_T:
				case MODULE0_T:
				case MODULE1_T:
				case MODULE2_T:
				case MODULE3_T:
				case MODULE4_T:
				case MODULE5_T:
				case MODULE6_T:
				case MODULEX_T:
				case SET_FWD_NO_CONNECT_T:
				case SET_RPL_NO_CONNECT_T:
				case SET_FWD_CLOSE_T:
				case SET_RPL_CLOSE_T:
					(yyval.action)=(yyvsp[0].action);
					break;
				default:
					(yyval.action)=0;
					yyerror("command not allowed in onsend_route\n");
			}
		} else {
			(yyval.action)=(yyvsp[0].action);
		}
	}
#line 9324 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 595:
#line 2378 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 9330 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 596:
#line 2379 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[-1].action); }
#line 9336 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 597:
#line 2382 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 9342 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 598:
#line 2383 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 9348 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 599:
#line 2384 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command"); }
#line 9354 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 600:
#line 2387 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 9360 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 601:
#line 2388 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 9366 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 602:
#line 2389 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 9372 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 603:
#line 2390 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 9378 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 604:
#line 2391 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[-1].action); }
#line 9384 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 605:
#line 2392 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 9390 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 606:
#line 2393 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0;}
#line 9396 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 607:
#line 2394 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command: missing ';'?"); }
#line 9402 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 608:
#line 2397 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].rv_expr) && rval_expr_int_check((yyvsp[-1].rv_expr))>=0){
			warn_ct_rve((yyvsp[-1].rv_expr), "if");
			(yyval.action)=mk_action( IF_T, 3, RVE_ST, (yyvsp[-1].rv_expr), ACTIONS_ST, (yyvsp[0].action), NOSUBTYPE, 0);
			set_cfg_pos((yyval.action));
		}else
			YYERROR;
	}
#line 9415 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 609:
#line 2405 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-3].rv_expr) && rval_expr_int_check((yyvsp[-3].rv_expr))>=0){
			warn_ct_rve((yyvsp[-3].rv_expr), "if");
			(yyval.action)=mk_action( IF_T, 3, RVE_ST, (yyvsp[-3].rv_expr), ACTIONS_ST, (yyvsp[-2].action), ACTIONS_ST, (yyvsp[0].action));
			set_cfg_pos((yyval.action));
		}else
			YYERROR;
	}
#line 9428 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 610:
#line 2415 "core/cfg.y" /* yacc.c:1646  */
    {
			(yyval.rv_expr)=0;
			if ((yyvsp[0].rv_expr) && !rve_is_constant((yyvsp[0].rv_expr))){
				yyerror("constant expected");
				YYERROR;
			/*
			} else if ($1 &&
						!rve_check_type((enum rval_type*)&i_tmp, $1, 0, 0 ,0)){
				yyerror("invalid expression (bad type)");
			}else if ($1 && i_tmp!=RV_INT){
				yyerror("invalid expression type, int expected\n");
			*/
			}else
				(yyval.rv_expr)=(yyvsp[0].rv_expr);
		}
#line 9448 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 611:
#line 2432 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=0;
		if ((yyvsp[-2].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-2].rv_expr), 0, (yyvsp[0].action), &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 9460 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 612:
#line 2439 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=0;
		if ((yyvsp[-2].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-2].rv_expr), 1, (yyvsp[0].action), &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 9472 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 613:
#line 2446 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=0;
		if ((yyvsp[-1].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-1].rv_expr), 0, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 9484 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 614:
#line 2453 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=0;
		if ((yyvsp[-1].rv_expr)==0) { yyerror ("bad regex case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-1].rv_expr), 1, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 9496 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 615:
#line 2460 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((((yyval.case_stms)=mk_case_stm(0, 0, (yyvsp[0].action), &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 9506 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 616:
#line 2465 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((((yyval.case_stms)=mk_case_stm(0, 0, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 9516 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 617:
#line 2470 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.case_stms)=0; yyerror("bad case label"); }
#line 9522 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 618:
#line 2471 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.case_stms)=0; yyerror("bad case regex label"); }
#line 9528 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 619:
#line 2472 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.case_stms)=0; yyerror("bad case label"); }
#line 9534 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 620:
#line 2473 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.case_stms)=0; yyerror("bad case regex label"); }
#line 9540 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 621:
#line 2474 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.case_stms)=0; yyerror ("bad case body"); }
#line 9546 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 622:
#line 2477 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=(yyvsp[-1].case_stms);
		if ((yyvsp[0].case_stms)==0) yyerror ("bad case");
		if ((yyval.case_stms)){
			*((yyval.case_stms)->append)=(yyvsp[0].case_stms);
			if (*((yyval.case_stms)->append)!=0)
				(yyval.case_stms)->append=&((*((yyval.case_stms)->append))->next);
		}
	}
#line 9560 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 623:
#line 2486 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=(yyvsp[0].case_stms);
		if ((yyvsp[0].case_stms)==0) yyerror ("bad case");
		else (yyval.case_stms)->append=&((yyval.case_stms)->next);
	}
#line 9570 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 624:
#line 2493 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0;
		if ((yyvsp[-3].rv_expr)==0){
			yyerror("bad expression in switch(...)");
			YYERROR;
		}else if ((yyvsp[-1].case_stms)==0){
			yyerror ("bad switch body");
			YYERROR;
		}else if (case_check_default((yyvsp[-1].case_stms))!=0){
			yyerror_at(&(yyvsp[-3].rv_expr)->fpos, "bad switch(): too many "
							"\"default:\" labels\n");
			YYERROR;
		}else if (case_check_type((yyvsp[-1].case_stms))!=0){
			yyerror_at(&(yyvsp[-3].rv_expr)->fpos, "bad switch(): mixed integer and"
							" string/RE cases not allowed\n");
			YYERROR;
		}else{
			(yyval.action)=mk_action(SWITCH_T, 2, RVE_ST, (yyvsp[-3].rv_expr), CASE_ST, (yyvsp[-1].case_stms));
			if ((yyval.action)==0) {
				yyerror("internal error");
				YYABORT;
			}
			set_cfg_pos((yyval.action));
		}
	}
#line 9600 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 625:
#line 2518 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0;
		warn("empty switch()");
		if ((yyvsp[-2].rv_expr)==0){
			yyerror("bad expression in switch(...)");
			YYERROR;
		}else{
			/* it might have sideffects, so leave it for the optimizer */
			(yyval.action)=mk_action(SWITCH_T, 2, RVE_ST, (yyvsp[-2].rv_expr), CASE_ST, 0);
			if ((yyval.action)==0) {
				yyerror("internal error");
				YYABORT;
			}
			set_cfg_pos((yyval.action));
		}
	}
#line 9621 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 626:
#line 2534 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror ("bad expression in switch(...)"); }
#line 9627 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 627:
#line 2536 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0; yyerror ("bad switch body"); }
#line 9633 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 628:
#line 2540 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].rv_expr) && rval_expr_int_check((yyvsp[-1].rv_expr))>=0){
			warn_ct_rve((yyvsp[-1].rv_expr), "while");
			(yyval.action)=mk_action( WHILE_T, 2, RVE_ST, (yyvsp[-1].rv_expr), ACTIONS_ST, (yyvsp[0].action));
			set_cfg_pos((yyval.action));
		}else{
			yyerror_at(&(yyvsp[-1].rv_expr)->fpos, "bad while(...) expression");
			YYERROR;
		}
	}
#line 9648 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 629:
#line 2559 "core/cfg.y" /* yacc.c:1646  */
    {
		if (sel.n >= MAX_SELECT_PARAMS-1) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[0].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[0].strval));
		sel.n++;
	}
#line 9662 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 630:
#line 2568 "core/cfg.y" /* yacc.c:1646  */
    {
		if (sel.n >= MAX_SELECT_PARAMS-2) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[-3].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[-3].strval));
		sel.n++;
		sel.params[sel.n].type = SEL_PARAM_INT;
		sel.params[sel.n].v.i = (yyvsp[-1].intval);
		sel.n++;
	}
#line 9679 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 631:
#line 2580 "core/cfg.y" /* yacc.c:1646  */
    {
		if (sel.n >= MAX_SELECT_PARAMS-2) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[-3].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[-3].strval));
		sel.n++;
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[-1].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[-1].strval));
		sel.n++;
	}
#line 9697 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 634:
#line 2599 "core/cfg.y" /* yacc.c:1646  */
    { sel.n = 0; sel.f[0] = 0; }
#line 9703 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 635:
#line 2599 "core/cfg.y" /* yacc.c:1646  */
    {
		sel_ptr = (select_t*)pkg_malloc(sizeof(select_t));
		if (!sel_ptr) {
			yyerror("No memory left to allocate select structure\n");
		}
		memcpy(sel_ptr, &sel, sizeof(select_t));
		(yyval.select) = sel_ptr;
	}
#line 9716 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 636:
#line 2609 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_FROM; }
#line 9722 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 637:
#line 2610 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_TO; }
#line 9728 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 638:
#line 2611 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_URI; }
#line 9734 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 639:
#line 2612 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_URI; }
#line 9740 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 640:
#line 2613 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_USER; }
#line 9746 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 641:
#line 2614 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_USER; }
#line 9752 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 642:
#line 2615 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_DOMAIN; }
#line 9758 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 643:
#line 2616 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_DOMAIN; }
#line 9764 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 644:
#line 2617 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_ALL | AVP_CLASS_GLOBAL; }
#line 9770 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 645:
#line 2620 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_NAME_STR; s_attr->name.s.s = (yyvsp[0].strval); s_attr->name.s.len = strlen ((yyvsp[0].strval)); }
#line 9776 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 648:
#line 2627 "core/cfg.y" /* yacc.c:1646  */
    {
		s_attr = (struct avp_spec*)pkg_malloc(sizeof(struct avp_spec));
		if (!s_attr) { yyerror("No memory left"); YYABORT; }
		else s_attr->type = 0;
	}
#line 9786 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 649:
#line 2634 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.attr) = s_attr; }
#line 9792 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 650:
#line 2637 "core/cfg.y" /* yacc.c:1646  */
    {
		s_attr->type|= (AVP_NAME_STR | ((yyvsp[-1].intval)<0?AVP_INDEX_BACKWARD:AVP_INDEX_FORWARD));
		s_attr->index = ((yyvsp[-1].intval)<0?-(yyvsp[-1].intval):(yyvsp[-1].intval));
		(yyval.attr) = s_attr;
	}
#line 9802 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 651:
#line 2644 "core/cfg.y" /* yacc.c:1646  */
    {
		s_attr->type|= AVP_INDEX_ALL;
		(yyval.attr) = s_attr;
	}
#line 9811 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 658:
#line 2666 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].lval)->type==LV_AVP){
			s_attr = pkg_malloc(sizeof(struct avp_spec));
			if (!s_attr) { yyerror("No memory left"); YYABORT; }
			else{
				*s_attr=(yyvsp[0].lval)->lv.avps;
			}
			(yyval.attr)=s_attr;
		}else
			(yyval.attr)=0; /* not an avp, a pvar */
		pkg_free((yyvsp[0].lval));
	}
#line 9828 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 659:
#line 2678 "core/cfg.y" /* yacc.c:1646  */
    {
		avp_spec_t *avp_spec;
		str s;
		int type, idx;
		avp_spec = pkg_malloc(sizeof(*avp_spec));
		if (!avp_spec) {
			yyerror("Not enough memory");
			YYABORT;
		}
		s.s = (yyvsp[0].strval);
		if (s.s[0] == '$')
			s.s++;
		s.len = strlen(s.s);
		if (parse_avp_name(&s, &type, &avp_spec->name, &idx)) {
			yyerror("error when parsing AVP");
			pkg_free(avp_spec);
			YYABORT;
		}
		avp_spec->type = type;
		avp_spec->index = idx;
		(yyval.attr) = avp_spec;
	}
#line 9855 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 660:
#line 2702 "core/cfg.y" /* yacc.c:1646  */
    {
			s_tmp.s=(yyvsp[0].strval); s_tmp.len=strlen((yyvsp[0].strval));
			pv_spec=pv_cache_get(&s_tmp);
			if (!pv_spec) {
				yyerror("Can't get from cache: %s", (yyvsp[0].strval));
				YYABORT;
			}
			(yyval.pvar)=pv_spec;
		}
#line 9869 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 661:
#line 2713 "core/cfg.y" /* yacc.c:1646  */
    {
				lval_tmp=pkg_malloc(sizeof(*lval_tmp));
				if (!lval_tmp) {
					yyerror("Not enough memory");
					YYABORT;
				}
				memset(lval_tmp, 0, sizeof(*lval_tmp));
				s_tmp.s=(yyvsp[0].strval); s_tmp.len=strlen(s_tmp.s);
				lval_tmp->lv.pvs = pv_cache_get(&s_tmp);
				if (lval_tmp->lv.pvs==NULL){
					lval_tmp->lv.avps.type|= AVP_NAME_STR;
					lval_tmp->lv.avps.name.s.s = s_tmp.s+1;
					lval_tmp->lv.avps.name.s.len = s_tmp.len-1;
					lval_tmp->type=LV_AVP;
				}else{
					lval_tmp->type=LV_PVAR;
				}
				(yyval.lval) = lval_tmp;
				DBG("parsed ambiguous avp/pvar \"%.*s\" to %d\n",
							s_tmp.len, s_tmp.s, lval_tmp->type);
			}
#line 9895 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 662:
#line 2744 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = ASSIGN_T; }
#line 9901 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 663:
#line 2748 "core/cfg.y" /* yacc.c:1646  */
    {
					lval_tmp=pkg_malloc(sizeof(*lval_tmp));
					if (!lval_tmp) {
						yyerror("Not enough memory");
						YYABORT;
					}
					lval_tmp->type=LV_AVP; lval_tmp->lv.avps=*(yyvsp[0].attr);
					pkg_free((yyvsp[0].attr)); /* free the avp spec we just copied */
					(yyval.lval)=lval_tmp;
				}
#line 9916 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 664:
#line 2758 "core/cfg.y" /* yacc.c:1646  */
    {
					if (!pv_is_w((yyvsp[0].pvar)))
						yyerror("read only pvar in assignment left side");
					if ((yyvsp[0].pvar)->trans!=0)
						yyerror("pvar with transformations in assignment"
								" left side");
					lval_tmp=pkg_malloc(sizeof(*lval_tmp));
					if (!lval_tmp) {
						yyerror("Not enough memory");
						YYABORT;
					}
					lval_tmp->type=LV_PVAR; lval_tmp->lv.pvs=(yyvsp[0].pvar);
					(yyval.lval)=lval_tmp;
				}
#line 9935 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 665:
#line 2772 "core/cfg.y" /* yacc.c:1646  */
    {
					if (((yyvsp[0].lval))->type==LV_PVAR){
						if (!pv_is_w((yyvsp[0].lval)->lv.pvs))
							yyerror("read only pvar in assignment left side");
						if ((yyvsp[0].lval)->lv.pvs->trans!=0)
							yyerror("pvar with transformations in assignment"
									" left side");
					}
					(yyval.lval)=(yyvsp[0].lval);
				}
#line 9950 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 666:
#line 2784 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_INT, (void*)(yyvsp[0].intval)); }
#line 9956 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 667:
#line 2785 "core/cfg.y" /* yacc.c:1646  */
    {	s_tmp.s=(yyvsp[0].strval); s_tmp.len=strlen((yyvsp[0].strval));
							(yyval.rv_expr)=mk_rve_rval(RV_STR, &s_tmp); }
#line 9963 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 668:
#line 2787 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_AVP, (yyvsp[0].attr)); pkg_free((yyvsp[0].attr)); }
#line 9969 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 669:
#line 2788 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_PVAR, (yyvsp[0].pvar)); }
#line 9975 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 670:
#line 2789 "core/cfg.y" /* yacc.c:1646  */
    {
							switch((yyvsp[0].lval)->type){
								case LV_AVP:
									(yyval.rv_expr)=mk_rve_rval(RV_AVP, &(yyvsp[0].lval)->lv.avps);
									break;
								case LV_PVAR:
									(yyval.rv_expr)=mk_rve_rval(RV_PVAR, (yyvsp[0].lval)->lv.pvs);
									break;
								default:
									yyerror("BUG: invalid lvalue type ");
									YYABORT;
							}
							pkg_free((yyvsp[0].lval)); /* not needed anymore */
						}
#line 9994 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 671:
#line 2803 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_SEL, (yyvsp[0].select)); pkg_free((yyvsp[0].select)); }
#line 10000 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 672:
#line 2804 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[0].action)); }
#line 10006 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 673:
#line 2805 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve_rval(RV_BEXPR, (yyvsp[0].expr)); }
#line 10012 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 674:
#line 2806 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[-1].action)); }
#line 10018 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 675:
#line 2807 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad command block"); }
#line 10024 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 676:
#line 2808 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[-1].action)); }
#line 10030 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 677:
#line 2809 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10036 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 678:
#line 2813 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=RVE_LNOT_OP; }
#line 10042 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 679:
#line 2814 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=RVE_BNOT_OP; }
#line 10048 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 680:
#line 2815 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=RVE_UMINUS_OP; }
#line 10054 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 681:
#line 2828 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=(yyvsp[0].rv_expr);
										if ((yyval.rv_expr)==0){
											/*yyerror("out of memory\n");*/
											YYERROR;
										}
									}
#line 10065 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 682:
#line 2834 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve1((yyvsp[-1].intval), (yyvsp[0].rv_expr)); }
#line 10071 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 683:
#line 2835 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve1(RVE_INT_OP, (yyvsp[0].rv_expr)); }
#line 10077 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 684:
#line 2836 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve1(RVE_STR_OP, (yyvsp[0].rv_expr)); }
#line 10083 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 685:
#line 2837 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_PLUS_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 10089 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 686:
#line 2838 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_MINUS_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 10095 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 687:
#line 2839 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_MUL_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 10101 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 688:
#line 2840 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_DIV_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 10107 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 689:
#line 2841 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_MOD_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 10113 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 690:
#line 2842 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_BOR_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr)); }
#line 10119 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 691:
#line 2843 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_BAND_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 10125 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 692:
#line 2844 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_BXOR_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 10131 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 693:
#line 2845 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_BLSHIFT_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 10137 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 694:
#line 2846 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_BRSHIFT_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 10143 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 695:
#line 2847 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve2( (yyvsp[-1].intval), (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));}
#line 10149 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 696:
#line 2848 "core/cfg.y" /* yacc.c:1646  */
    {
			/* comparing with $null => treat as defined or !defined */
			if((yyvsp[0].rv_expr)->op==RVE_RVAL_OP && (yyvsp[0].rv_expr)->left.rval.type==RV_PVAR
					&& (yyvsp[0].rv_expr)->left.rval.v.pvs.type==PVT_NULL) {
				if((yyvsp[-1].intval)==RVE_DIFF_OP || (yyvsp[-1].intval)==RVE_IDIFF_OP
						|| (yyvsp[-1].intval)==RVE_STRDIFF_OP) {
					DBG("comparison with $null switched to notdefined operator\n");
					(yyval.rv_expr)=mk_rve1(RVE_DEFINED_OP, (yyvsp[-2].rv_expr));
				} else {
					DBG("comparison with $null switched to defined operator\n");
					(yyval.rv_expr)=mk_rve1(RVE_NOTDEFINED_OP, (yyvsp[-2].rv_expr));
				}
				/* free rve struct for $null */
				rve_destroy((yyvsp[0].rv_expr));
			} else {
				(yyval.rv_expr)=mk_rve2((yyvsp[-1].intval), (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));
			}
		}
#line 10172 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 697:
#line 2866 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve2(RVE_LAND_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));}
#line 10178 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 698:
#line 2867 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve2(RVE_LOR_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));}
#line 10184 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 699:
#line 2868 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=(yyvsp[-1].rv_expr);}
#line 10190 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 700:
#line 2869 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve1(RVE_STRLEN_OP, (yyvsp[-1].rv_expr));}
#line 10196 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 701:
#line 2870 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve1(RVE_STREMPTY_OP, (yyvsp[-1].rv_expr));}
#line 10202 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 702:
#line 2871 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve1(RVE_DEFINED_OP, (yyvsp[0].rv_expr));}
#line 10208 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 703:
#line 2872 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10214 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 704:
#line 2873 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10220 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 705:
#line 2874 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10226 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 706:
#line 2875 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10232 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 707:
#line 2876 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10238 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 708:
#line 2877 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10244 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 709:
#line 2878 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10250 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 710:
#line 2879 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10256 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 711:
#line 2880 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10262 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 712:
#line 2881 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10268 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 713:
#line 2883 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10274 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 714:
#line 2885 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10280 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 715:
#line 2886 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10286 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 716:
#line 2887 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10292 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 717:
#line 2888 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10298 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 718:
#line 2889 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10304 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 719:
#line 2890 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10310 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 720:
#line 2893 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action((yyvsp[-1].intval), 2, LVAL_ST, (yyvsp[-2].lval),
														 	  RVE_ST, (yyvsp[0].rv_expr));
											set_cfg_pos((yyval.action));
										}
#line 10319 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 721:
#line 2911 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = 1; }
#line 10325 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 722:
#line 2912 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = 0; }
#line 10331 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 723:
#line 2913 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = -1; }
#line 10337 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 724:
#line 2916 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 10343 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 725:
#line 2917 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(	FORWARD_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10349 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 726:
#line 2918 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(	FORWARD_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10355 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 727:
#line 2919 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(	FORWARD_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10361 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 728:
#line 2920 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10367 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 729:
#line 2921 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10373 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 730:
#line 2922 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10379 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 731:
#line 2923 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 10385 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 732:
#line 2924 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10391 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 733:
#line 2925 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10397 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 734:
#line 2926 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 10403 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 735:
#line 2927 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad forward argument"); }
#line 10409 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 736:
#line 2928 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10415 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 737:
#line 2929 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10421 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 738:
#line 2930 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10427 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 739:
#line 2931 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10433 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 740:
#line 2932 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10439 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 741:
#line 2933 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10445 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 742:
#line 2934 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 10451 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 743:
#line 2935 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10457 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 744:
#line 2936 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10463 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 745:
#line 2937 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 10469 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 746:
#line 2938 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad forward_udp argument"); }
#line 10475 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 747:
#line 2939 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10481 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 748:
#line 2940 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10487 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 749:
#line 2941 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10493 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 750:
#line 2942 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10499 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 751:
#line 2943 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10505 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 752:
#line 2944 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10511 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 753:
#line 2945 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 10517 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 754:
#line 2946 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10523 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 755:
#line 2947 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10529 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 756:
#line 2948 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 10535 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 757:
#line 2949 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad forward_tcp argument"); }
#line 10541 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 758:
#line 2950 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10554 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 759:
#line 2958 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10567 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 760:
#line 2966 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10580 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 761:
#line 2974 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10593 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 762:
#line 2982 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10606 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 763:
#line 2990 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
					}
#line 10619 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 764:
#line 2998 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10632 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 765:
#line 3006 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10645 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 766:
#line 3014 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10658 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 767:
#line 3022 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 10664 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 768:
#line 3023 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0;
									yyerror("bad forward_tls argument"); }
#line 10671 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 769:
#line 3025 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 10684 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 770:
#line 3033 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 10697 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 771:
#line 3041 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 10710 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 772:
#line 3049 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 10724 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 773:
#line 3058 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 10738 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 774:
#line 3067 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
					}
#line 10752 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 775:
#line 3076 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 10765 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 776:
#line 3084 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 10779 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 777:
#line 3093 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10792 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 778:
#line 3101 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 10798 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 779:
#line 3102 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0;
									yyerror("bad forward_sctp argument"); }
#line 10805 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 780:
#line 3104 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(LOG_T, 2, NUMBER_ST,
										(void*)(L_DBG+1), STRING_ST, (yyvsp[-1].strval));
									set_cfg_pos((yyval.action)); }
#line 10813 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 781:
#line 3107 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(LOG_T, 2, NUMBER_ST, (void*)(yyvsp[-3].intval), STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 10819 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 782:
#line 3108 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 10825 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 783:
#line 3109 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad log argument"); }
#line 10831 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 784:
#line 3110 "core/cfg.y" /* yacc.c:1646  */
    {
							if (check_flag((yyvsp[-1].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(SETFLAG_T, 1, NUMBER_ST,
													(void*)(yyvsp[-1].intval));
							set_cfg_pos((yyval.action));
									}
#line 10843 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 785:
#line 3117 "core/cfg.y" /* yacc.c:1646  */
    {
							i_tmp=get_flag_no((yyvsp[-1].strval), strlen((yyvsp[-1].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(SETFLAG_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									}
#line 10855 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 786:
#line 3124 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 10861 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 787:
#line 3125 "core/cfg.y" /* yacc.c:1646  */
    {
							if (check_flag((yyvsp[-1].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(RESETFLAG_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
							set_cfg_pos((yyval.action));
									}
#line 10872 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 788:
#line 3131 "core/cfg.y" /* yacc.c:1646  */
    {
							i_tmp=get_flag_no((yyvsp[-1].strval), strlen((yyvsp[-1].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(RESETFLAG_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									}
#line 10884 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 789:
#line 3138 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 10890 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 790:
#line 3139 "core/cfg.y" /* yacc.c:1646  */
    {
							if (check_flag((yyvsp[-1].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(ISFLAGSET_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
							set_cfg_pos((yyval.action));
									}
#line 10901 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 791:
#line 3145 "core/cfg.y" /* yacc.c:1646  */
    {
							i_tmp=get_flag_no((yyvsp[-1].strval), strlen((yyvsp[-1].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(ISFLAGSET_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									}
#line 10913 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 792:
#line 3152 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 10919 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 793:
#line 3153 "core/cfg.y" /* yacc.c:1646  */
    {
		i_tmp=get_avpflag_no((yyvsp[-1].strval));
		if (i_tmp==0) yyerror("avpflag not declared");
		(yyval.action)=mk_action(AVPFLAG_OPER_T, 3, AVP_ST, (yyvsp[-3].attr), NUMBER_ST, (void*)(long)i_tmp, NUMBER_ST, (void*)(yyvsp[-5].intval));
		set_cfg_pos((yyval.action));
	}
#line 10930 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 794:
#line 3159 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0; yyerror("error parsing flag name");
	}
#line 10938 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 795:
#line 3162 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0; yyerror("error parsing first parameter (avp or string)");
	}
#line 10946 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 796:
#line 3165 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad parameters"); }
#line 10952 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 797:
#line 3166 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 10958 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 798:
#line 3167 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(ERROR_T, 2, STRING_ST, (yyvsp[-3].strval), STRING_ST, (yyvsp[-1].strval));
			set_cfg_pos((yyval.action));
	}
#line 10966 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 799:
#line 3170 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 10972 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 800:
#line 3171 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad error argument"); }
#line 10978 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 801:
#line 3172 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].rv_expr)) {
			(yyval.action) = mk_action(ROUTE_T, 1, RVE_ST, (void*)(yyvsp[-1].rv_expr));
			set_cfg_pos((yyval.action));
		} else {
			(yyval.action) = 0;
			YYERROR;
		}
	}
#line 10992 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 802:
#line 3181 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].strval)) {
			(yyval.action) = mk_action(ROUTE_T, 1, STRING_ST, (void*)(yyvsp[-1].strval));
			set_cfg_pos((yyval.action));
		} else {
			(yyval.action) = 0;
			YYERROR;
		}
	}
#line 11006 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 803:
#line 3190 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11012 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 804:
#line 3191 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad route argument"); }
#line 11018 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 805:
#line 3192 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(EXEC_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11024 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 806:
#line 3193 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_HOST_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11030 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 807:
#line 3194 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11036 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 808:
#line 3195 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11042 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 809:
#line 3196 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(PREFIX_T, 1, STRING_ST,  (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11048 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 810:
#line 3197 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11054 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 811:
#line 3198 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11060 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 812:
#line 3199 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(STRIP_TAIL_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11066 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 813:
#line 3200 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11072 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 814:
#line 3201 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, number expected"); }
#line 11078 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 815:
#line 3202 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(STRIP_T, 1, NUMBER_ST, (void*) (yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11084 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 816:
#line 3203 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11090 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 817:
#line 3204 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, number expected"); }
#line 11096 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 818:
#line 3205 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_USERPHONE_T, 0); set_cfg_pos((yyval.action)); }
#line 11102 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 819:
#line 3206 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11108 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 820:
#line 3207 "core/cfg.y" /* yacc.c:1646  */
    {
			(yyval.action)=mk_action(REMOVE_BRANCH_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
			set_cfg_pos((yyval.action));
	}
#line 11117 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 821:
#line 3211 "core/cfg.y" /* yacc.c:1646  */
    {
			(yyval.action)=mk_action(REMOVE_BRANCH_T, 0);
			set_cfg_pos((yyval.action));
	}
#line 11126 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 822:
#line 3215 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11132 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 823:
#line 3216 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, number expected"); }
#line 11138 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 824:
#line 3217 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(CLEAR_BRANCHES_T, 0); set_cfg_pos((yyval.action)); }
#line 11144 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 825:
#line 3218 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_HOSTPORT_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11150 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 826:
#line 3219 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11156 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 827:
#line 3220 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11162 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 828:
#line 3221 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_HOSTPORTTRANS_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11168 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 829:
#line 3222 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11174 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 830:
#line 3223 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11180 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 831:
#line 3224 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_PORT_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11186 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 832:
#line 3225 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11192 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 833:
#line 3226 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11198 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 834:
#line 3227 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_USER_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11204 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 835:
#line 3228 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11210 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 836:
#line 3229 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11216 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 837:
#line 3230 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_USERPASS_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11222 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 838:
#line 3231 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11228 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 839:
#line 3232 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11234 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 840:
#line 3233 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_URI_T, 1, STRING_ST,(yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11240 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 841:
#line 3234 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11246 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 842:
#line 3235 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11252 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 843:
#line 3236 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(REVERT_URI_T, 0); set_cfg_pos((yyval.action)); }
#line 11258 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 844:
#line 3237 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(REVERT_URI_T, 0); set_cfg_pos((yyval.action)); }
#line 11264 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 845:
#line 3238 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORCE_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 11270 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 846:
#line 3239 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORCE_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 11276 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 847:
#line 3240 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(ADD_LOCAL_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 11282 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 848:
#line 3241 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(ADD_LOCAL_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 11288 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 849:
#line 3242 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	}
#line 11301 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 850:
#line 3250 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 0);
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	}
#line 11314 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 851:
#line 3258 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 0);
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	}
#line 11327 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 852:
#line 3266 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0; yyerror("bad argument, number expected"); }
#line 11333 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 853:
#line 3268 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(UDP_MTU_TRY_PROTO_T, 1, NUMBER_ST, (yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11339 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 854:
#line 3270 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, UDP, TCP, TLS or SCTP expected"); }
#line 11345 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 855:
#line 3271 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0;
		if ((str_tmp=pkg_malloc(sizeof(str)))==0) {
			PKG_MEM_CRITICAL;
		} else {
			str_tmp->s=(yyvsp[-1].strval);
			str_tmp->len=(yyvsp[-1].strval)?strlen((yyvsp[-1].strval)):0;
			(yyval.action)=mk_action(SET_ADV_ADDR_T, 1, STR_ST, str_tmp);
			set_cfg_pos((yyval.action));
		}
	}
#line 11361 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 856:
#line 3282 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11367 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 857:
#line 3283 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11373 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 858:
#line 3284 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0;
		tmp=int2str((yyvsp[-1].intval), &i_tmp);
		if ((str_tmp=pkg_malloc(sizeof(str)))==0) {
			PKG_MEM_CRITICAL;
		} else {
			if ((str_tmp->s=pkg_malloc(i_tmp))==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy(str_tmp->s, tmp, i_tmp);
				str_tmp->len=i_tmp;
				(yyval.action)=mk_action(SET_ADV_PORT_T, 1, STR_ST, str_tmp);
				set_cfg_pos((yyval.action));
			}
		}
	}
#line 11394 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 859:
#line 3300 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11400 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 860:
#line 3301 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11406 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 861:
#line 3302 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(FORCE_SEND_SOCKET_T, 1, SOCKID_ST, (yyvsp[-1].sockid));
		set_cfg_pos((yyval.action));
	}
#line 11415 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 862:
#line 3306 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0; yyerror("bad argument, [proto:]host[:port] expected");
	}
#line 11423 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 863:
#line 3309 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11429 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 864:
#line 3310 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_FWD_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 11437 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 865:
#line 3313 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_FWD_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 11445 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 866:
#line 3316 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_RPL_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 11453 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 867:
#line 3319 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_RPL_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 11461 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 868:
#line 3322 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_FWD_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 11469 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 869:
#line 3325 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_FWD_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 11477 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 870:
#line 3328 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_RPL_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 11485 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 871:
#line 3331 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_RPL_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 11493 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 872:
#line 3334 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(CFG_SELECT_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
	}
#line 11501 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 873:
#line 3337 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(CFG_SELECT_T, 2, STRING_ST, (yyvsp[-3].strval), RVE_ST, (yyvsp[-1].rv_expr)); set_cfg_pos((yyval.action));
	}
#line 11509 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 874:
#line 3340 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11515 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 875:
#line 3341 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad arguments, string and number expected"); }
#line 11521 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 876:
#line 3342 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(CFG_RESET_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action));
	}
#line 11529 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 877:
#line 3345 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11535 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 878:
#line 3346 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad arguments, string expected"); }
#line 11541 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 879:
#line 3347 "core/cfg.y" /* yacc.c:1646  */
    {mod_func_action = mk_action(MODULE0_T, 2, MODEXP_ST, NULL, NUMBER_ST,
			0); }
#line 11548 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 880:
#line 3348 "core/cfg.y" /* yacc.c:1646  */
    {
		mod_func_action->val[0].u.data =
			find_export_record((yyvsp[-4].strval), mod_func_action->val[1].u.number, rt);
		if (mod_func_action->val[0].u.data == 0) {
			if (find_export_record((yyvsp[-4].strval), mod_func_action->val[1].u.number, 0) ) {
					LM_ERR("misused command %s\n", (yyvsp[-4].strval));
					yyerror("Command cannot be used in the block\n");
			} else {
				LM_ERR("cfg. parser: failed to find command %s (params %ld)\n",
						(yyvsp[-4].strval), mod_func_action->val[1].u.number);
				yyerror("unknown command, missing loadmodule?\n");
			}
			free_mod_func_action(mod_func_action);
			mod_func_action=0;
		}else{
			if (mod_func_action && mod_f_params_pre_fixup(mod_func_action)<0) {
				/* error messages are printed inside the function */
				free_mod_func_action(mod_func_action);
				mod_func_action = 0;
				YYERROR;
			}
		}
		(yyval.action) = mod_func_action;
		set_cfg_pos((yyval.action));
	}
#line 11578 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 881:
#line 3373 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("'('')' expected (function call)");}
#line 11584 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 883:
#line 3377 "core/cfg.y" /* yacc.c:1646  */
    { }
#line 11590 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 884:
#line 3378 "core/cfg.y" /* yacc.c:1646  */
    {}
#line 11596 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 885:
#line 3381 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].rv_expr) && mod_func_action->val[1].u.number < MAX_ACTIONS-2) {
			mod_func_action->val[mod_func_action->val[1].u.number+2].type =
				RVE_ST;
			mod_func_action->val[mod_func_action->val[1].u.number+2].u.data =
				(yyvsp[0].rv_expr);
			mod_func_action->val[1].u.number++;
		} else if ((yyvsp[0].rv_expr)) {
			yyerror("Too many arguments\n");
			YYERROR;
		} else {
			YYERROR;
		}
	}
#line 11615 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 886:
#line 3398 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST,
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	}
#line 11624 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 887:
#line 3402 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[0].rv_expr), NUMBER_ST,
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	}
#line 11633 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 888:
#line 3406 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST,
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	}
#line 11642 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 889:
#line 3410 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	}
#line 11652 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 890:
#line 3415 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[0].rv_expr), NUMBER_ST, (void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	}
#line 11661 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 891:
#line 3419 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	}
#line 11671 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 892:
#line 3424 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)RETURN_R_F); set_cfg_pos((yyval.action));
	}
#line 11680 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 893:
#line 3428 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)RETURN_R_F); set_cfg_pos((yyval.action));
	}
#line 11689 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 894:
#line 3432 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[0].rv_expr), NUMBER_ST, (void*)RETURN_R_F);
		set_cfg_pos((yyval.action));
	}
#line 11698 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 895:
#line 3436 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST, (void*)BREAK_R_F);
		set_cfg_pos((yyval.action));
	}
#line 11707 "core/cfg.tab.c" /* yacc.c:1646  */
    break;


#line 11711 "core/cfg.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 3442 "core/cfg.y" /* yacc.c:1906  */


static void get_cpos(struct cfg_pos* pos)
{
	pos->s_line=startline;
	pos->e_line=line;
	pos->s_col=startcolumn;
	pos->e_col=column-1;
	if(finame==0)
		finame = (cfg_file!=0)?cfg_file:"default";
	pos->fname=finame;
	pos->rname=(routename!=0)?routename:default_routename;
}


static void warn_at(struct cfg_pos* p, char* format, ...)
{
	va_list ap;
	char s[256];

	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	if (p->e_line!=p->s_line)
		LM_WARN("warning in config file %s, from line %d, column %d to"
					" line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_line, p->e_col, s);
	else if (p->s_col!=p->e_col)
		LM_WARN("warning in config file %s, line %d, column %d-%d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_col, s);
	else
		LM_WARN("warning in config file %s, line %d, column %d: %s\n",
				p->fname, p->s_line, p->s_col, s);
	cfg_warnings++;
}



static void yyerror_at(struct cfg_pos* p, char* format, ...)
{
	va_list ap;
	char s[256];

	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	if (p->e_line!=p->s_line)
		LM_CRIT("parse error in config file %s, from line %d, column %d"
					" to line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_line, p->e_col, s);
	else if (p->s_col!=p->e_col)
		LM_CRIT("parse error in config file %s, line %d, column %d-%d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_col, s);
	else
		LM_CRIT("parse error in config file %s, line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, s);
	cfg_errors++;
}



static void warn(char* format, ...)
{
	va_list ap;
	char s[256];
	struct cfg_pos pos;

	get_cpos(&pos);
	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	warn_at(&pos, s);
}



static void yyerror(char* format, ...)
{
	va_list ap;
	char s[256];
	struct cfg_pos pos;

	get_cpos(&pos);
	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	yyerror_at(&pos, s);
}



/** mk_rval_expr_v wrapper.
 *  checks mk_rval_expr_v return value and sets the cfg. pos
 *  (line and column numbers)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr_v)
 */
static struct rval_expr* mk_rve_rval(enum rval_type type, void* v)
{
	struct rval_expr* ret;
	struct cfg_pos pos;

	get_cpos(&pos);
	ret=mk_rval_expr_v(type, v, &pos);
	if (ret==0){
		yyerror("internal error: failed to create rval expr");
		/* YYABORT; */
	}
	return ret;
}


/** mk_rval_expr1 wrapper.
 *  checks mk_rval_expr1 return value (!=0 and type checking)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr1)
 */
static struct rval_expr* mk_rve1(enum rval_expr_op op, struct rval_expr* rve1)
{
	struct rval_expr* ret;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;

	if (rve1==0)
		return 0;
	ret=mk_rval_expr1(op, rve1, &rve1->fpos);
	if (ret && (rve_check_type(&type, ret, &bad_rve, &bad_t, &exp_t)!=1)){
		yyerror_at(&rve1->fpos, "bad expression: type mismatch"
					" (%s instead of %s)", rval_type_name(bad_t),
					rval_type_name(exp_t));
		rve_destroy(ret);
		ret=0;
	}
	return ret;
}


/** mk_rval_expr2 wrapper.
 *  checks mk_rval_expr2 return value (!=0 and type checking)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr2)
 */
static struct rval_expr* mk_rve2(enum rval_expr_op op, struct rval_expr* rve1,
									struct rval_expr* rve2)
{
	struct rval_expr* ret;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;
	struct cfg_pos pos;

	if ((rve1==0) || (rve2==0))
		return 0;
	bad_rve=0;
	bad_t=0;
	exp_t=0;
	cfg_pos_join(&pos, &rve1->fpos, &rve2->fpos);
	ret=mk_rval_expr2(op, rve1, rve2, &pos);
	if (ret && (rve_check_type(&type, ret, &bad_rve, &bad_t, &exp_t)!=1)){
		if (bad_rve)
			yyerror_at(&pos, "bad expression: type mismatch:"
						" %s instead of %s at (%d,%d)",
						rval_type_name(bad_t), rval_type_name(exp_t),
						bad_rve->fpos.s_line, bad_rve->fpos.s_col);
		else
			yyerror("BUG: unexpected null \"bad\" expression\n");
		rve_destroy(ret);
		ret=0;
	}
	return ret;
}


/** check if the expression is an int.
 * if the expression does not evaluate to an int return -1 and
 * log an error.
 * @return 0 success, no warnings; 1 success but warnings; -1 on error */
static int rval_expr_int_check(struct rval_expr *rve)
{
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;

	if (rve==0){
		yyerror("invalid expression");
		return -1;
	}else if (!rve_check_type(&type, rve, &bad_rve, &bad_t ,&exp_t)){
		if (bad_rve)
			yyerror_at(&rve->fpos, "bad expression: type mismatch:"
						" %s instead of %s at (%d,%d)",
						rval_type_name(bad_t), rval_type_name(exp_t),
						bad_rve->fpos.s_line, bad_rve->fpos.s_col);
		else
			yyerror("BUG: unexpected null \"bad\" expression\n");
		return -1;
	}else if (type!=RV_INT && type!=RV_NONE){
		warn_at(&rve->fpos, "non-int expression (you might want to use"
				" casts)\n");
		return 1;
	}
	return 0;
}


/** warn if the expression is constant.
 * @return 0 on success (no warning), 1 when warning */
static int warn_ct_rve(struct rval_expr *rve, char* name)
{
	if (rve && rve_is_constant(rve)){
		warn_at(&rve->fpos, "constant value in %s%s",
				name?name:"expression", name?"(...)":"");
		return 1;
	}
	return 0;
}


static struct name_lst* mk_name_lst(char* host, int flags)
{
	struct name_lst* l;
	if (host==0) return 0;
	l=pkg_malloc(sizeof(struct name_lst));
	if (l==0) {
		PKG_MEM_CRITICAL;
	} else {
		l->name=host;
		l->flags=flags;
		l->next=0;
	}
	return l;
}


static struct socket_id* mk_listen_id(char* host, int proto, int port)
{
	struct socket_id* l;
	if (host==0) return 0;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0) {
		PKG_MEM_CRITICAL;
	} else {
		l->addr_lst=mk_name_lst(host, 0);
		if (l->addr_lst==0){
			pkg_free(l);
			return 0;
		}
		l->flags=0;
		l->port=port;
		l->proto=proto;
		l->next=0;
	}
	return l;
}


static void free_name_lst(struct name_lst* lst)
{
	struct name_lst* tmp;

	while(lst){
		tmp=lst;
		lst=lst->next;
		pkg_free(tmp);
	}
}


static struct socket_id* mk_listen_id2(struct name_lst* addr_l, int proto,
										int port)
{
	struct socket_id* l;
	if (addr_l==0) return 0;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0) {
		PKG_MEM_CRITICAL;
	} else {
		l->flags=addr_l->flags;
		l->port=port;
		l->proto=proto;
		l->addr_lst=addr_l;
		l->next=0;
	}
	return l;
}


static void free_socket_id(struct socket_id* i)
{
	free_name_lst(i->addr_lst);
	pkg_free(i);
}


static void free_socket_id_lst(struct socket_id* lst)
{
	struct socket_id* tmp;

	while(lst){
		tmp=lst;
		lst=lst->next;
		free_socket_id(tmp);
	}
}


/** create a temporary case statmenet structure.
 *  *err will be filled in case of error (return == 0):
 *   -1 - non constant expression
 *   -2 - expression error (bad type)
 *   -10 - memory allocation error
 */
static struct case_stms* mk_case_stm(struct rval_expr* ct, int is_re,
											struct action* a, int* err)
{
	struct case_stms* s;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;
	enum match_str_type t;

	t=MATCH_UNKNOWN;
	if (ct){
		/* if ct!=0 => case, else if ct==0 is a default */
		if (!rve_is_constant(ct)){
			yyerror_at(&ct->fpos, "non constant expression in case");
			*err=-1;
			return 0;
		}
		if (rve_check_type(&type, ct, &bad_rve, &bad_t, &exp_t)!=1){
			yyerror_at(&ct->fpos, "bad expression: type mismatch:"
							" %s instead of %s at (%d,%d)",
							rval_type_name(bad_t), rval_type_name(exp_t),
							bad_rve->fpos.s_line, bad_rve->fpos.s_col);
			*err=-2;
			return 0;
		}
		if (is_re)
			t=MATCH_RE;
		else if (type==RV_STR)
			t=MATCH_STR;
		else
			t=MATCH_INT;
	}

	s=pkg_malloc(sizeof(*s));
	if (s==0) {
		yyerror("internal error: memory allocation failure");
		*err=-10;
	} else {
		memset(s, 0, sizeof(*s));
		s->ct_rve=ct;
		s->type=t;
		s->actions=a;
		s->next=0;
		s->append=0;
	}
	return s;
}


/*
 * @return 0 on success, -1 on error.
 */
static int case_check_type(struct case_stms* stms)
{
	struct case_stms* c;
	struct case_stms* s;

	for(c=stms; c ; c=c->next){
		if (!c->ct_rve) continue;
		for (s=c->next; s; s=s->next){
			if (!s->ct_rve) continue;
			if ((s->type!=c->type) &&
				!(	(c->type==MATCH_STR || c->type==MATCH_RE) &&
					(s->type==MATCH_STR || s->type==MATCH_RE) ) ){
					yyerror_at(&s->ct_rve->fpos, "type mismatch in case");
					return -1;
			}
		}
	}
	return 0;
}


/*
 * @return 0 on success, -1 on error.
 */
static int case_check_default(struct case_stms* stms)
{
	struct case_stms* c;
	int default_no;

	default_no=0;
	for(c=stms; c ; c=c->next)
		if (c->ct_rve==0) default_no++;
	return (default_no<=1)?0:-1;
}



/** fixes the parameters and the type of a module function call.
 * It is done here instead of fix action, to have quicker feedback
 * on error cases (e.g. passing a non constant to a function with a
 * declared fixup)
 * The rest of the fixup is done inside do_action().
 * @param a - filled module function call (MODULE*_T) action structure
 *            complete with parameters, starting at val[2] and parameter
 *            number at val[1].
 * @return 0 on success, -1 on error (it will also print the error msg.).
 *
 */
static int mod_f_params_pre_fixup(struct action* a)
{
	ksr_cmd_export_t* cmd_exp;
	action_u_t* params;
	int param_no;
	struct rval_expr* rve;
	struct rvalue* rv;
	int r;
	str s;

	cmd_exp = a->val[0].u.data;
	param_no = a->val[1].u.number;
	params = &a->val[2];

	switch(cmd_exp->param_no) {
		case 0:
			a->type = MODULE0_T;
			break;
		case 1:
			a->type = MODULE1_T;
			break;
		case 2:
			a->type = MODULE2_T;
			break;
		case 3:
			a->type = MODULE3_T;
			break;
		case 4:
			a->type = MODULE4_T;
			break;
		case 5:
			a->type = MODULE5_T;
			break;
		case 6:
			a->type = MODULE6_T;
			break;
		case VAR_PARAM_NO:
			a->type = MODULEX_T;
			break;
		default:
			yyerror("function %s: bad definition"
					" (invalid number of parameters)", cmd_exp->name);
			return -1;
	}

	if ( cmd_exp->fixup) {
		if (is_fparam_rve_fixup(cmd_exp->fixup))
			/* mark known fparam rve safe fixups */
			cmd_exp->fixup_flags  |= FIXUP_F_FPARAM_RVE;
		else if (!(cmd_exp->fixup_flags & FIXUP_F_FPARAM_RVE) &&
				 cmd_exp->free_fixup == 0) {
			/* v0 or v1 functions that have fixups and no coresp. fixup_free
			   functions, need constant, string params.*/
			for (r=0; r < param_no; r++) {
				rve=params[r].u.data;
				if (!rve_is_constant(rve)) {
					yyerror_at(&rve->fpos, "function %s: parameter %d is not"
								" constant\n", cmd_exp->name, r+1);
					return -1;
				}
				if ((rv = rval_expr_eval(0, 0, rve)) == 0 ||
						rval_get_str(0, 0, &s, rv, 0) < 0 ) {
					/* out of mem or bug ? */
					rval_destroy(rv);
					yyerror_at(&rve->fpos, "function %s: bad parameter %d"
									" expression\n", cmd_exp->name, r+1);
					return -1;
				}
				rval_destroy(rv);
				rve_destroy(rve);
				params[r].type = STRING_ST; /* asciiz */
				params[r].u.string = s.s;
				params[r].u.str.len = s.len; /* not used right now */
			}
		}
	}/* else
		if no fixups are present, the RVEs can be transformed
		into strings at runtime, allowing seamless var. use
		even with old functions.
		Further optimizations -> in fix_actions()
		*/
	return 0;
}



/** frees a filled module function call action structure.
 * @param a - filled module function call action structure
 *            complete with parameters, starting at val[2] and parameter
 *            number at val[1].
 */
static void free_mod_func_action(struct action* a)
{
	action_u_t* params;
	int param_no;
	int r;

	param_no = a->val[1].u.number;
	params = &a->val[2];

	for (r=0; r < param_no; r++)
		if (params[r].u.data)
			rve_destroy(params[r].u.data);
	pkg_free(a);
}



/*
int main(int argc, char ** argv)
{
	if (yyparse()!=0)
		fprintf(stderr, "parsing error\n");
}
*/
